/**
 * 协同H5处理js
 * @author xuqw
 * @since V5-A8 6.1
 */

/**
 * 初始化处理页面
 */
function __initDeal__(callback){
    
    if (!summaryBO["summary"].finished){
        //指定回退中间节点
        if(summaryBO["summary"].affairState == 3 
            && summaryBO["summary"].affairSubState == 17 ) {
        
            summaryBO.pageConfig.canDeal = false;
        }
    }else { //流程结束
        //当前affair状态不是待办，或者是指定回退中间节点，都不能有处理提交按钮。
        if((summaryBO["summary"].affairState == 3 && summaryBO["summary"].affairSubState == 17) || !summaryBO["summary"].affairState == 3){
            summaryBO.pageConfig.canDeal = false;
        }
    }
    
    //加锁处理
    _lockForm(function(lockRet){
        _initDealDom(lockRet);
        callback && callback();
    });
    
  //添加缓存
    document.addEventListener('beforepageredirect', function(e){ 
        if(!pageX.isMoreComment){
            window.summaryBO.signatureId = window.signatureId;
            window.summaryBO.isLightForm = pageX.cache.isLightForm;
        }
        cmp.storage.save(CollCacheKey.summary.summaryBO + pageX.winParams.cache_subfix, cmp.toJSON(window.summaryBO));
    });
    
    document.addEventListener('deletesessioncache', function(e){
        //批量删除这类的全部数据
        CollCacheKey.delCacheKeys(CollCacheKey.summary, pageX.winParams.cache_subfix);
    });
}


/**
 * 表单加锁
 */
function _lockForm(callback){
    
    if(typeof summaryBO.formIsLock == "undefined"){
        
      //目前不支持新闻审批、公告审批。所以可以不加锁
        if (summaryBO["summary"].bodyType == '20' 
                && summaryBO.pageConfig.canDeal) {
            
            lockCollForm(function(ret) {
                
                //增加属性，表明表单锁
                summaryBO.formIsLock = !ret;
                callback && callback(ret);
            });
        }else{
            summaryBO.formIsLock = false;
            callback && callback(true);
        }
    }else{
        if(summaryBO.formIsLock && summaryBO.formLockMsg){
            _alert(summaryBO.formLockMsg);
//        	cmp.notification.confirm(summaryBO.formLockMsg,function(index){
//                if(index == 0){
//                    if (!pageX.wfDesigner || !pageX.wfDesigner.isInit()) {
//                        _alert(cmp.i18n("collaboration.page.lable.onloading"));
//                        return;
//                    }
//                    cmp.notification.close();
//                    var _workflowData = {
//                        processId: summaryBO.summary.processId,
//                        workitemId: summaryBO["summary"].affairWorkitemId,
//                        bugType: "4",
//                        appName: "collaboration"
//                    }
//                    pageX.wfDesigner.showProblemReport(_workflowData);
//                } else {
//                    cmp.notification.close();
//                }
//            },cmp.i18n("collaboration.page.dialog.note")/*提示*/,[cmp.i18n("Edoc.workflow.problems"),cmp.i18n("collaboration.page.dialog.OK")],null,true,0);
            delete summaryBO.formLockMsg;//清空消息
        }
        callback && callback(!summaryBO.formIsLock);
    }
}

//协同表单上锁
function lockCollForm(callback) {
    var collObj = {
            "formAppId" : summaryBO["summary"].formAppId,
            "formRecordId" : summaryBO["summary"].formRecordId,
            "rightId" : summaryBO["summary"].rightId,
            "affairId" : summaryBO["summary"].affairId,
            "affairState" : summaryBO["summary"].affairState,
            "nodePolicy" : summaryBO["summary"].nodePolicy,
            "affairReadOnly" : summaryBO["summary"].affairReadOnly
        };
    
    $s.Coll.lockCollForm({}, collObj, errorBuilder({
        success : function(result) {
            var ret = true;
            if(result && result.canSubmit=="0") {
                _alert(cmp.i18n("collaboration.common.flag.editingForm", [result.loginName, result.from]));
                ret = false;
            }
            callback(ret);
        }
    }));
}

/**
 * 处理按钮相关DOM操作
 */
function _initDealDom(lockRet){
    
    if(summaryBO["summary"].listType != "onlyView" && !summaryBO["isHistory"]) {
        var ps = summaryBO.pageConfig.nodeActions;
        
        if(!summaryBO["summary"].finished) {
            if(!lockRet){
                if(CollUtils.isInArray(ps, "Forward")){
                    _showDealBtns(summaryBO.pageConfig.canDeal && summaryBO.formIsLock !== true, ["Forward"]);
                }
            }else{
                _showDealBtns(summaryBO.pageConfig.canDeal && summaryBO.formIsLock !== true, ps);
            }
        } else {
        	
            //已办增加收藏  (流程结束的已办)  or 流程结束已发
            if(summaryBO.pageConfig.canFavorite || summaryBO.openFrom == 'listSent'){
                _showDealBtns(summaryBO.pageConfig.canDeal && summaryBO.formIsLock !== true, ["canFavorite"]);
            }
            
            // 流程虽然结束，但当前affair数据的状态还是待办，就需要有提交按钮
            if(summaryBO["summary"].affairState == 3) {
            	_showDealBtns(summaryBO.pageConfig.canDeal && summaryBO.formIsLock !== true, ps);
            }
            
        }
    }else{
        //从我的收藏过来且当前文件是收藏的情况显示取消收藏
        if (summaryBO.openFrom == 'docLib' && summaryBO.isFavorite == true) {
        	 _showDealBtns(summaryBO.pageConfig.canDeal && summaryBO.formIsLock !== true, ["canFavorite"]);
        }else {
        	//把所有按钮干掉
        	_$("#footer_btns").remove();
        }
    }
    
    //轮循加锁机制
    if (summaryBO.pageConfig.canDeal && summaryBO.formIsLock !== true) {
        pageX.lockFormInt = setInterval("updateLockTime()", 180*1000);
    }
}

/**
 * 更新锁时间
 */
function updateLockTime(){

    
    var formRecordId ="";
    if(summaryBO["summary"].bodyType == '20' && summaryBO.pageConfig.canDeal){
        formRecordId = summaryBO["summary"].formRecordId;
    }
    processId = summaryBO["summary"].processId;
    
    $s.Coll.updateLockTime({"formRecordId":formRecordId,"processId":processId},errorBuilder({
        error : function(){
            clearInterval(pageX.lockFormInt);
        },
        exeSelfError : true
    }));
    
}

//处理协同
function _dealSummary(){
    
    //表单校验判断
    if(!pageX.isMoreComment && summaryBO["summary"].bodyType == "20"){
        if(cmp.sui.isPreventSubmit()){
            //表单失去焦点校验失败,阻止跳转
            return;
        }
    }
    if(_summaryRepeatClk){
        return;
    }
    _summaryRepeatClk = true;
    var pageParams = {
        "cache_subfix" : pageX.winParams.cache_subfix,
        "WebviewEvent" : WebEvents.M3_EVENT_SUMMARY + pageX.winParams.cache_subfix,
        "action" : WorkFlowLock.SUBMIT//提交操作
    }
    summaryBO.backIndex = summaryBO.backIndex + 1;
    _cacheSignet(false);
    cmp.event.trigger("beforepageredirect", document);
    cmp.href.next(_collPath + "/html/details/comment.html"+colBuildVersion, pageParams, {openWebview : true});
}

//回退
function _returnSummary() {
    //协同流程回退加锁
    var _sbCall = function(){
        WorkFlowDesignerUtil.lockH5Workflow(summaryBO["summary"].processId, WorkFlowLock.STEP_BACK, function(ret) {
            if(ret) {
                
                var nextPageData = {
                        "cache_subfix" : pageX.winParams.cache_subfix,
                        "WebviewEvent" : WebEvents.M3_EVENT_SUMMARY + pageX.winParams.cache_subfix,
                        "title" : cmp.i18n("collaboration.page.lable.button.return"),//回退
                        "placeholder" : cmp.i18n("collaboration.page.info.whencancel", [cmp.i18n("collaboration.page.lable.button.return")]),//回退流程不可恢复，若确认回退流程，请在这里输入回退附言。
                        "action" : WorkFlowLock.STEP_BACK
                }
                summaryBO.backIndex = summaryBO.backIndex + 1;
                cmp.event.trigger("beforepageredirect", document);
                cmp.href.next(_collPath + "/html/details/comment.html"+colBuildVersion, nextPageData, {openWebview : true});
            }
        });
    }
    var params = {"affairId":summaryBO["summary"].affairId};
    $s.EdocResource.transStepBackValid({},params, errorBuilder({
        success : function(result) {
            if(result["error_msg"]){
                _alert(result["error_msg"]);
                return;
            }else {
                _sbCall();
            }
        }
    }));
    
}

//处理人撤销
function _repealSummary(){
    //协同流程撤销加锁
    var repelaCall = function(){
        WorkFlowDesignerUtil.lockH5Workflow(summaryBO["summary"].processId, WorkFlowLock.REPEAL_ITEM, function(ret) {
            if(ret) {

                var nextPageData = {
                    "action" : WorkFlowLock.REPEAL_ITEM,
                    "cache_subfix" : pageX.winParams.cache_subfix,
                    "WebviewEvent" : WebEvents.M3_EVENT_SUMMARY + pageX.winParams.cache_subfix,
                    "title" : cmp.i18n("collaboration.page.lable.button.cancel1"),//撤销
                    "placeholder" : cmp.i18n("collaboration.page.info.whencancel", [cmp.i18n("collaboration.page.lable.button.cancel1")])//撤销流程不可恢复, 若确认撤销流程, 请在这里输入撤销附言。
                }
                summaryBO.backIndex = summaryBO.backIndex + 1;
                cmp.event.trigger("beforepageredirect", document);
                cmp.href.next(_collPath + "/html/details/comment.html"+colBuildVersion, nextPageData, {openWebview : true});
            }
        });
    }
    var params = {"summaryId":summaryBO["summary"].id,"affairId":summaryBO["summary"].affairId};
     // 撤销公文
    $s.EdocResource.transRepalValid({},params,errorBuilder({
      success : function(result) {
          if(result.error_msg || result["error_msg"]){
              _alert(result.error_msg || result["error_msg"],null,"");
              return;
          }else {
            repelaCall();
          }
      }
    }));
}

//指定回退
function _specifiesReturn(){
    
    pageX.wfDesigner.specifiesReturn(function(returnInfo, submitStyleName){
        
        var pageParams = {
                "cache_subfix" : pageX.winParams.cache_subfix,
                "WebviewEvent" : WebEvents.M3_EVENT_SUMMARY + pageX.winParams.cache_subfix,
                "action" : WorkFlowLock.SPECIFIES_RETURN,//提交操作
                "title" : submitStyleName,//回退
                "placeholder" : cmp.i18n("collaboration.page.info.whencancel", [cmp.i18n("collaboration.page.lable.button.return")]),//回退流程不可恢复，若确认回退流程，请在这里输入回退附言。
                "returnInfo" : returnInfo
            }
        summaryBO.backIndex = summaryBO.backIndex + 1;
        cmp.event.trigger("beforepageredirect", document);
        cmp.href.next(_collPath + "/html/details/comment.html"+colBuildVersion, pageParams, {openWebview : true});
    });
}


//终止
function _terminateSummary() {
    //协同流程终止加锁
    WorkFlowDesignerUtil.lockH5Workflow(summaryBO["summary"].processId, WorkFlowLock.STEP_STOP, function(ret) {
        if(ret) {
            _formLoadCheck({
                checkCallback : function(ret){
                    if(ret == true){
                         if(_summaryRepeatClk){
        					  return;
    					 }
    					_summaryRepeatClk = true;
                        var nextPageData = {
                            "action" : WorkFlowLock.STEP_STOP,
                            "cache_subfix" : pageX.winParams.cache_subfix,
                            "WebviewEvent" : WebEvents.M3_EVENT_SUMMARY + pageX.winParams.cache_subfix,
                            "title" : cmp.i18n("collaboration.page.lable.button.terminate"),//终止
                            "placeholder" : cmp.i18n("collaboration.page.info.whencancel",[cmp.i18n("collaboration.page.lable.button.terminate")])//终止流程不可恢复，若确认回退流程，请在这里输入终止附言。
                        }
                        summaryBO.backIndex = summaryBO.backIndex + 1;
                        cmp.event.trigger("beforepageredirect",document);
                        cmp.href.next(_collPath + "/html/details/comment.html"+colBuildVersion, nextPageData, {openWebview : true});
                    }
                }
            });
        }
    });
}
var isFavoriteOrCancelSuccess = true;

var hasFavorite="";
function _favoriteSummary(){
	isFavoriteOrCancelSuccess = false;
	var affairId = summaryBO.summary.affairId;
	var paramData = {"affairId" : affairId,"from":""};
	if(hasFavorite == "1"){
		 $s.EdocResource.cancelFavoriteAffair(paramData, errorBuilder({
				success : function(result) {
					if (result.success == "true") {
						//reloadPage();
						hasFavorite = "0";
						summaryBO.summary.hasFavorite = "0";
                        // 取第一个元素 存在收藏的时候可用
						_$('.deal-button-el .deal-button-name').innerHTML = cmp.i18n("collaboration.page.favorite");
                        cmp.notification.alert(cmp.i18n("collaboration.favorite.cancelSuccess"), null, "", cmp.i18n("collaboration.page.dialog.OK"));
					} else {
						cmp.dialog.failure(result.message, null, "", cmp.i18n("collaboration.page.dialog.OK"));
					}
				}
	    }));
	}else{
		 $s.EdocResource.favoriteAffair(paramData, errorBuilder({
			success : function(result) {
				if (result.success == "true") {
					hasFavorite = "1";
					summaryBO.summary.hasFavorite = "1";
                    // 取第一个元素 存在收藏的时候可用
				    _$('.deal-button-el .deal-button-name').innerHTML = cmp.i18n("collaboration.page.cancelfavorite2");
                    cmp.notification.alert(cmp.i18n("collaboration.favorite.success"), null, "", cmp.i18n("collaboration.page.dialog.OK"));
				} else {
					cmp.dialog.failure(cmp.i18n("collaboration.takeBackErr.msg11"), null, "", cmp.i18n("collaboration.page.dialog.OK"));
				}
			}
		}));
	}
}

//已办、在办、已发流程结束、未结束、我的收藏的收藏接口调用
function canFavoriteBtn(callback) {
    var affairId = summaryBO.summary.affairId;
    var paramData = {"affairId" : affairId,"from":""};
    if(hasFavorite == "1"){
    	 $s.EdocResource.cancelFavoriteAffair(paramData, errorBuilder({
    			success : function(result) {
    				if (result.success == "true") {
    					//reloadPage();
    					hasFavorite = "0";
    					summaryBO.summary.hasFavorite = "0";
                        callback&&callback('0');
    					var label=_$("#canFavoriteBtnLable"); 
    					// label.innerText=cmp.i18n("collaboration.page.favorite");
                        cmp.notification.alert(cmp.i18n("collaboration.favorite.cancelSuccess"), null, "", cmp.i18n("collaboration.page.dialog.OK"));
    					
    				} else {
                        cmp.dialog.failure(result.message);
    				}
    			}
        }));
    }else{
    	 $s.EdocResource.favoriteAffair(paramData, errorBuilder({
    		success : function(result) {
    			if (result.success == "true") {
    				hasFavorite = "1";
    				summaryBO.summary.hasFavorite = "1";
    				
    				var label=_$("#canFavoriteBtnLable");
                    callback&&callback('1');
    				// label.innerText=cmp.i18n("collaboration.page.cancelfavorite2");
                    cmp.notification.alert(cmp.i18n("collaboration.favorite.success"), null, "", cmp.i18n("collaboration.page.dialog.OK"));
    			} else {
                    cmp.dialog.failure(cmp.i18n("collaboration.takeBackErr.msg11"));
    			}
    		}
    	}));
    }
}

//移交
function _transferSummary() {
    //协同流程终止加锁
    WorkFlowDesignerUtil.lockH5Workflow(summaryBO["summary"].processId, WorkFlowLock.TRANSFER, function(ret) {
        if(ret) {
            _formLoadCheck({
                checkCallback : function(ret){
                    if(ret == true){
                        if(_summaryRepeatClk){
                            return;
                        }
                        _summaryRepeatClk = true;
                        var nextPageData = {
                            "action" : WorkFlowLock.TRANSFER,
                            "cache_subfix" : pageX.winParams.cache_subfix,
                            "WebviewEvent" : WebEvents.M3_EVENT_SUMMARY + pageX.winParams.cache_subfix,
                            "title" : cmp.i18n("collaboration.page.lable.button.transfer")
                            //"placeholder" : cmp.i18n("collaboration.page.info.whencancel",[cmp.i18n("collaboration.page.lable.button.terminate")])//终止流程不可恢复，若确认回退流程，请在这里输入终止附言。
                        }
                        summaryBO.backIndex = summaryBO.backIndex + 1;
                        cmp.event.trigger("beforepageredirect",document);
                        cmp.href.next(_collPath + "/html/details/comment.html"+colBuildVersion, nextPageData, {openWebview : true});
                    }
                }
            });
        }
    });
}


//撤销
function _transRepal(){
    //协同流程撤销加锁
    WorkFlowDesignerUtil.lockH5Workflow(summaryBO["summary"].processId, WorkFlowLock.REPEAL_ITEM, function(ret) {
        if(ret) {
            var nextPageData = {
                    "cache_subfix" : pageX.winParams.cache_subfix,
                    "WebviewEvent" : WebEvents.M3_EVENT_SUMMARY + pageX.winParams.cache_subfix,
            };
            
            summaryBO.backIndex = summaryBO.backIndex + 1;
            
            cmp.event.trigger("beforepageredirect",document);
            cmp.href.next(_collPath + "/html/cancel.html"+colBuildVersion, nextPageData, {openWebview : true});
        }
    });    
}

//支持原样表单，多一层验证
function _dealSummaryCheck(){
	_formLoadCheck({
		checkCallback : function(ret){
			if(ret == true){
				_dealSummary();
			}
		}
	});
}

//原表单预提交处理
var _violenceClickFlag = false;
function _formLoadCheck(xParams){
    
    if(_violenceClickFlag){
        //暴力点击
        return;
    }
    
    _violenceClickFlag = true;
    
    var checkCallback;
    
    checkCallback = function(ckRet){
        xParams.checkCallback(ckRet);
        _violenceClickFlag = false;
    }
    
    //意见更多处理
    if(pageX.isMoreComment){
        checkCallback(true);
        return;
    }
    
    if(summaryBO["summary"].bodyType == '20' && !_isContentInit){
        _alert(cmp.i18n("collaboration.action.alert.contentinit"));
        checkCallback(false);
        return;
    }
    
    //直接提交
    checkCallback(true);
}


function _transRepalValid(){
    var params = {"summaryId":summaryBO["summary"].id,"affairId":summaryBO["summary"].affairId};
     // 撤销公文
    $s.EdocResource.transRepalValid({},params,errorBuilder({
        success : function(result) {
            if(result["msg"]){
                _alert(result["msg"],null,"");
            }else if(result.error_msg || result["error_msg"]){
                _alert(result.error_msg || result["error_msg"],null,"");
                return;
            }else {
                _transRepal();
            }
        }
    }));
}


//跟踪切换
function _taggleTrack(){
    var trackBtn = _$("#trackBtn");
    var trackFlag = trackBtn.getAttribute("trackFlag");
    var trackLable = _$("#trackBtnLable");
    var trackImg = _$("#trackBtnImg");
    if(trackFlag == "1"){
        trackBtn.setAttribute("trackFlag", "0");
        trackImg.className="see-icon-v5-common-tracking";
        trackLable.innerText = cmp.i18n("collaboration.page.lable.button.track");//跟踪
    }else{
        trackBtn.setAttribute("trackFlag", "1");
        trackImg.className="see-icon-v5-common-tracking-cancel";
        trackLable.innerText = cmp.i18n("collaboration.page.lable.button.track_cancel");//取消跟踪
    }
}

function transForward() {
	
	var page = {
            "summaryId" : summaryBO["summary"].id,
            "affairId" : summaryBO["summary"].affairId,
            "defPolicy" : summaryBO["defPolicy"],
            'accountId':summaryBO["summary"].accountId,
            "cache_subfix" : pageX.winParams.cache_subfix,
            "WebviewEvent" : WebEvents.M3_EVENT_SUMMARY + pageX.winParams.cache_subfix,
            //"backIndex" : summaryBO.backIndex + 1,
            "parentX":{
                "openFrom": "summary"
            }
    };
	
	if(summaryBO && summaryBO.openFrom =="listWaitSend"
		&& summaryBO["summary"].templateId){
		
	    var templateId = summaryBO["summary"].templateId;
    	$s.Coll.isTemplateDeleted({
            "templateIds" : templateId
        }, errorBuilder({
            success : function(result) {

                if (result && result.code == "0") {

                    var delTemplateIds = result["data"]["delTemplateIds"];
                    if (delTemplateIds.length > 0) {

                        _alert(cmp.i18n('collaboration.forword.errorTemplate',[summaryBO["summary"]["subject"]]));
                        forwardCount = 0;
                        return;
                    }

                    // 待发的时候转发协同该属性引起报错 跳转回来的时候重新加载页面加载上该属性。
                    cmp.event.trigger("beforepageredirect", document);
                    cmp.href.next(_collPath + "/html/colForward.html" + colBuildVersion, page, {
                        openWebview : true
                    });
                }
                else {
                    _alert(result.message);
                    return;
                }
            },

            error : function(result) {
                _alert(result.message);
                return;
            }
        }));
	}else{
		//待发的时候转发协同该属性引起报错 跳转回来的时候重新加载页面加载上该属性。
		cmp.event.trigger("beforepageredirect",document);
		cmp.href.next(_collPath + "/html/colForward.html"+colBuildVersion,page, {openWebview : true});
	}
    

}

/**
 * 协同取回公用方法
 * @param workitemId 
 * @param processId
 * @param activityId
 * @param performer
 * @param caseId
 * @param appName
 * @param isForm
 * @param affairId 
 * @param trackBackCall 
 */
function trackBack(workitemId, processId, activityId, performer, caseId, appName, isForm,affairId,trackBackCall){
    var trackBackParam = {};
    var affairParam = {};
    affairParam.summaryId = summaryBO["summary"].id;
    affairParam.currentUserId = summaryBO.affairMemberId;
    
    $s.EdocResource.getLastDoneAffair(affairParam,errorBuilder({
			success : function(result) {
					if (result.activityId != null) {
						activityId = result.activityId;
					}
					if(result.subObjectId != null){
						workitemId = result.subObjectId;
					}
					if(result.id != null){
						trackBackParam.affairId = result.id;
					}else{
						trackBackParam.affairId = affairId;
					}
					//调用工作流的是否能取回方法
				    canTakeBack(workitemId, processId, activityId, null, caseId, appName, isForm,function(msg){
				        //判断是否能够取回
				        if (msg!=null && !msg.canTakeBack) {
				            var errorMsg = msg.err_msg;
				            clickCount = false;
				            _alert(errorMsg,null,cmp.i18n("collaboration.page.dialog.note"),[cmp.i18n("collaboration.button.close.label")]);
				            return;
				        }else{
				            //协同流程取回加锁
				            WorkFlowDesignerUtil.lockH5Workflow(summaryBO["summary"].processId, WorkFlowLock.TAKE_BACK, function(ret) {
				                if(ret) {
				                	var workflowCheckParam = {
				              			event : "BeforeTakeBack",
				              			callback : function(flag){
				              				if(flag){
				              					var updateComment = cmp.i18n("collaboration.page.lable.updateComment");
				              					var notUpdateComment = "否，撤回重新处理";
				              					var items=[updateComment,
				              					           notUpdateComment,
				              					           cmp.i18n("collaboration.page.cancelFavorite"),
				              					           cmp.i18n("collaboration.page.lable.sureUpdateComment")]; 
				              					cmp.notification.judge(items[3],function(index){
				              						if (index != 2) {
				              							if (index == 0) {//修改原意见
				              								trackBackParam.isSaveOpinion = false;
				              							} else if (index == 1) {//重新处理
				              								trackBackParam.isSaveOpinion = true;
				              							}
				              							//dee表单开发高级
				              							var deeSuccessFn = function(){
				              								$s.EdocResource.newTakeBack(trackBackParam,errorBuilder({
				              									success : function(result) {
				              										if (result.message != "null") {
				              											_alert(result.message);
				              										}
				              										if(typeof(trackBackCall)=='function'){
                                                                        // 因为M3默认同一流程只显示一条,取回后传最新的affairId打开公文详情以便当前用户能继续处理
				              											trackBackCall(trackBackParam.affairId);
				              										}
				              									}
				              								}));
				              							}
				              						//表单开发高级
				              	   					formDevelopAdance4ThirdParty(summaryBO["summary"].bodyType,summaryBO["summary"].affairId,"takeback","",null,deeSuccessFn);
				              						} else {
				              							clickCount = false;
				              							WorkFlowDesignerUtil.unLockH5Workflow(summaryBO["summary"].processId, WorkFlowLock.TAKE_BACK);
				              						}
				              					},null,[items[0],items[1],items[2]],null,2);
				              				}else{
				              					clickCount = false;
				              					WorkFlowDesignerUtil.unLockH5Workflow(summaryBO["summary"].processId, WorkFlowLock.TAKE_BACK);
				              				}
				              			},
				                        formAppId : summaryBO.workflowCheckParam.formAppId,
				                        formId : summaryBO.workflowCheckParam.formId,
				                        formOperationId : summaryBO.workflowCheckParam.formOperationId
				                    };
				                	pageX.wfDesigner.executeWorkflowBeforeEvent(workflowCheckParam);
				                }else{
				                	clickCount = false;
				                }
				            });
				        }
				    });
				}
			}));
}
var btns = [];
var clickCount = false;//防止重复点击
//处理按钮设置 TODO 本期改造点
function _showDealBtns(canDeal, nodeActions){
   
    //页面显示
    var footerBar = _$("#footer_btns");
    var affairSubState = summaryBO["summary"].affairSubState;
    var summaryState = summaryBO["summary"].state;
    if(canDeal){
    	if(_$("#otherBtns")){
    		_$("#otherBtns").remove();
    	}
        _$("#deal_summary_btn").addEventListener("tap", _dealSummaryCheck);
        
        
        function initMorBtns(hasSign){
            
            var actionI18n = {
                    "Forward" : cmp.i18n("collaboration.page.lable.button.forward"),//转发协同
                    "Return" : cmp.i18n("collaboration.page.lable.button.return"),//回退
                    "Terminate" : cmp.i18n("collaboration.page.lable.button.terminate"),//终止
                    "Cancel" : cmp.i18n("collaboration.page.lable.button.cancel1"),//撤销
                    "SpecifiesReturn" : cmp.i18n("collaboration.default.stepBack"),// 指定回退
                    "Transfer" : cmp.i18n("collaboration.page.lable.button.transfer"),// 移交
                    "Edit" : cmp.i18n("collaboration.page.lable.button.modifyContent")//修改正文
                }

            if(!summaryBO.isHaveNewColl){
                delete actionI18n["Forward"];
            }
            
            //只有office格式的正文才能修改正文且只有CMP壳才能修改正文
            if(!summaryBO.content 
                    || !summaryBO.canEditContent
                    || summaryBO.content.contentType=="20" 
                    || !summaryBO.content.fileId 
                    || !CollUtils.isCMPShell() 
                    || !cmp.os.android){
            	delete actionI18n["Edit"];
            }
            
          //非当前指定回退状态，整个流程处于指定回退状态
            if(summaryBO.inInSpecialSB){
                delete actionI18n["SpecifiesReturn"];
                delete actionI18n["Return"];
            }else if(affairSubState == '15'){
                
                delete actionI18n["Transfer"];
                delete actionI18n["Return"];
                delete actionI18n["SpecifiesReturn"];
                
            }else if(affairSubState == '16'){
                
                delete actionI18n["Transfer"];
                delete actionI18n["Return"];
                
            }else if(affairSubState == '17'){
                
                delete actionI18n["Transfer"];
                delete actionI18n["Return"];
                delete actionI18n["SpecifiesReturn"];
            }
            
            for(var i = 0, len = summaryBO.pageConfig.commonActions.length; i < len; i++){
                var action = summaryBO.pageConfig.commonActions[i];
                if(actionI18n[action]){
                    btns.push({
                        key : action,
                        name : actionI18n[action]
                    });
                }
            }
          
          //顺序
          if(hasSign){
            btns.push({
                key : "Sign",
                name : cmp.i18n("collaboration.page.lable.button.signature")//签章
            });
           }
          //收藏 addby lib
           if(summaryBO.pageConfig.canFavorite){
        	   hasFavorite = summaryBO.summary.hasFavorite;
        	   if(hasFavorite == '1' && summaryBO.isFavorite){
        		   var labelName1 = cmp.i18n("collaboration.page.cancelfavorite2");
            	   var labelName2= cmp.i18n("collaboration.page.favorite");
            	   hasFavorite = "1";
        	   }else{
        		   var labelName1 = cmp.i18n("collaboration.page.favorite");
            	   var labelName2= cmp.i18n("collaboration.page.cancelfavorite2");
            	   hasFavorite = "0";
        	   }
        	   
        	   btns.push({
                   key : "FavoriteKey",
                   name : labelName1,
                   name2 : labelName2
               });
           }
           //电话会议
           if(summaryBO.showMeetingBtn){
        	   btns.push({
        		   key : "Meeting",
        		   name : cmp.i18n("collaboration.page.lable.button.meeting")
        	   });
           }
        }
        
        //先判断签章 TODO 可以优化，等点签章的时候再判断权限
        if((affairSubState != '15' && affairSubState != '17') 
                && !pageX.isMoreComment && CollUtils.isInArray(nodeActions, "Sign") 
                && ((summaryBO["summary"].bodyType == "10" && !summaryBO.content.isForwardForm)
                        || summaryBO["summary"].bodyType == "20")){
            
            LazyUtil.addLoadedFn("lazy_iSignaturePhone", function(){
                if(typeof summaryBO.hasSignFlag == "undefined"){
                    hasSignaturepolicy(function(_keySn){
                        summaryBO.hasSignFlag = false;
                        if(_keySn){
                            summaryBO.hasSignFlag = true;
                            summaryBO.hasKeySn = _keySn;
                        }
                        initMorBtns(summaryBO.hasSignFlag);
                   });
                }else{
                    initMorBtns(summaryBO.hasSignFlag);
                }
            });
        }else{
            initMorBtns(false);
        }
        
        //处理按钮左边，显示编辑流程的图标
        showWorkflowEditButton();
        
        footerBar.style.display = "";
        
    }else{
        if(!summaryBO.isPassRead){
            _$("#handleBtns").remove();
        }
		if(summaryBO["summary"].affairState != 3){//非待办隐藏处理的时候影藏意见和态度，处理界面移植添加
			if(!summaryBO.isPassRead){
                _$("#hand_first_line").style.display="none"; 
            }
			_$("#button_list_nav_new").style.display="none";
		}
        var otherBtn = _$("#otherBtns");
        var otherBtns = [];
		var isAddFavorited = false;//是否已经添加收藏按钮
        //流程未结束，常规的操作按钮
        if(!summaryBO["summary"].finished) {
             
            hasFavorite = summaryBO.summary.hasFavorite;
            var labname = "";
            if(hasFavorite == '1' && summaryBO.isFavorite){
                labname ="collaboration.page.cancelfavorite2";
                hasFavorite = "1";
            }else{
                labname = "collaboration.page.favorite"
                hasFavorite = "0";
            }  
            
            //已办
            if(summaryBO["summary"].affairState == 4){
                otherBtns.push({
                    id:"flowView",//查看流程
                    class:"see-icon-v5-common-lookflow",
                    lable:"查看流程"
                });
                if (summaryBO.openFrom != 'docLib') {
                    otherBtns.push({
                        "attrs" : "",
                        "id" : "takeBackBtn",
                        "class" : "see-icon-v5-common-getback",
                        "lable" :"撤回"//zsy-取回改成撤回 cmp.i18n("collaboration.page.lable.button.tackback")//取回
                    });
                }
				
				//(流程未结束的已办) 已办、在办
                if(summaryBO.pageConfig.canFavorite){
				  isAddFavorited = true;
                //   otherBtns.push({
                //       "attrs" : hasFavorite,
                //       "id" : "canFavoriteBtn",
                //       "class" : hasFavorite=='0'?"see-icon-v5-common-collect":'see-icon-v5-common-collect-fill',
                //       "lable" : cmp.i18n(labname)//收藏
                //   });
                    
                }
                //zsy-已办数据-显示留言按钮
                otherBtns.push({
                    id:"replayText",//查看流程
                    class:"see-icon-v5-common-opinion",
                    lable:"留言"
                });
                
            } 

            //已发
            else if((summaryBO["summary"].affairState == 2 
                        || (summaryBO["summary"].affairState == 3 
                                && (affairSubState == 15 
                                        || affairSubState == 17))
                    )) {
				if(CollUtils.isInArray(nodeActions, "Cancel")){
					 otherBtns.push({
	                    "attrs" : "",
	                    "id" : "cancelBtn",
	                    "class" : "see-icon-v5-common-rollback",
	                    "lable" : cmp.i18n("collaboration.page.lable.button.cancel1")//撤销
					});
				}
               
				//流程未结束的已发
				if(summaryBO.pageConfig.canFavorite){  
				  isAddFavorited = true;
                //   otherBtns.push({
                //       "attrs" : "",
                //       "id" : "canFavoriteBtn",
                //       "class" : hasFavorite=='0'?"see-icon-v5-common-collect":'see-icon-v5-common-collect-fill',
                //       "lable" : cmp.i18n(labname)//收藏
                //   });
                }
            } 
            
            //待发
            else if(summaryBO["summary"].affairState == 1) {
                if(summaryBO["summary"].bodyType != '20' && (summaryBO.isHaveNewColl || summaryBO["summary"].templateId)) {
                    //待发-发送
                    otherBtns.push({
                        "attrs" : "",
                        "id" : "sendImmediateBtn",
                        "class" : "see-icon-v5-common-send",
                        "lable" : cmp.i18n("collaboration.page.lable.button.send")//发送
                    });
                }else if(summaryBO["summary"].bodyType=='20') {
                    //待发-编辑
                    otherBtns.push({
                        "attrs" : "",
                        "id" : "editBtn",
                        "class" : "see-icon-v5-common-doc-edit",
                        "lable" : cmp.i18n("collaboration.page.lable.button.edit")//编辑
                    });
                }
            }
        }
        var canfowardColl = summaryBO && summaryBO.summary && summaryBO.summary.canForward != '0';
        if(CollUtils.isInArray(nodeActions, "Forward") && summaryBO.isHaveNewColl && canfowardColl){
            otherBtns.push({
                "attrs" : "",
                "id" : "transformBtn",
                "class" : "see-icon-v5-common-transmit",
                "lable" : cmp.i18n("collaboration.page.lable.button.forward")//转发协同
            });
        }
		
		
        //已办增加收藏功能(流程结束的已办) 流程结束的已发
        if(((summaryBO.pageConfig.canFavorite || summaryBO.openFrom == 'listSent') || (summaryBO.openFrom == 'docLib' && summaryBO.isFavorite == true)) && CollUtils.isInArray(nodeActions, "canFavorite") && !isAddFavorited  ){
           hasFavorite = summaryBO.summary.hasFavorite;
           var labname = "";
           if(hasFavorite == '1' && summaryBO.isFavorite){
              labname ="collaboration.page.cancelfavorite2";
              hasFavorite = "1";
           }else{
              labname = "collaboration.page.favorite"
              hasFavorite = "0";
           }   
        
        //    otherBtns.push({
        //        "attrs" : hasFavorite,
        //        "id" : "canFavoriteBtn",
        //        "class" : hasFavorite=='0'?"see-icon-v5-common-collect":'see-icon-v5-common-collect-fill',
        //        "lable" : cmp.i18n(labname)//收藏
        //    });
        }
        
        
        //流程未结束，常规的操作按钮
        if(!summaryBO["summary"].finished) {
            if(CollUtils.isInArray(nodeActions, "Track")) {
                if((summaryBO["summary"].listType != "listWaitSend" 
                        && affairSubState != 15 
                        && affairSubState != 17)
                        && summaryState == 0) {
                    
                    //公告审批和新闻审批待办时不能有跟踪按钮
                    var isTrack=cmp.i18n("collaboration.page.lable.button.track_cancel");
                    var trackClass = "see-icon-v5-common-tracking-cancel";
                    var _tf= '1';
                    if(summaryBO.summary.affairTrack == "0" || summaryBO.summary.affairTrack == null){
                        _tf='0'
                        isTrack=cmp.i18n("collaboration.page.lable.button.track");
                        trackClass = "see-icon-v5-common-tracking";
                    }
                    otherBtns.push({
                        "attrs" : _tf,
                        "id" : "trackBtn",
                        "class" : trackClass,
                        "lable" : isTrack//取消跟踪
                    });
                }
            }
        }
        
        if(otherBtns.length > 0){
            // var otherBtnTemplate = _$("#other_btn_template").innerHTML;
            // var btnHTML = cmp.tpl(otherBtnTemplate, otherBtns);
            // otherBtn.innerHTML = btnHTML;
            var handleBtnsOption = {
                type:'button',
                el: '#otherBtns-cmp-ui',
                data: [],
                iconData:[],
                class:"cmp-white-bg",
            };
            otherBtns.forEach(function (o,i) {
                handleBtnsOption.iconData.push({
                    text: o.lable||'',
                    iconClass:o.class + ' cmp-theme-fc page-f-22',
                    data: cmp.extend({_eq:i},o),
                    class: ' cmp-main-fc cmp-f-2'
                })
            });
            var $uiButton = null;
            cmp.require('ui-button', function() {
                $uiButton = new cmp.ui.button(handleBtnsOption,function (res) {
                    var data = res;
                    addOtherBtnsEvent(data)
                });
            });
            //添加事件
            function addOtherBtnsEvent (contextInfo){
                var aId = contextInfo.id;
                switch (aId) {
                    case "takeBackBtn": //取回
                        var idMap = {
                            "summaryID" : summaryBO.summary.id,
                            "affairID" : summaryBO.summary.affairId
                        }
                        //协同已办列表取回前事件
                        var eventParams={
                            funName : "beforeDoneTakeBack",
                            data : idMap,
                            success : function(){
                                LazyUtil.addLoadedFn("lazy_dee", function(){
                                    //取回
                                    if(!clickCount){
                                        clickCount=true;
                                        var isForm = summaryBO["summary"].bodyType == '20';
                                        //因为M3默认同一流程只显示一条,取回后传最新的affairId:lastDoneAffair打开公文详情以便当前用户能继续处理
                                        trackBack(summaryBO["summary"].affairWorkitemId, summaryBO["summary"].processId,
                                            summaryBO["summary"].activityId, null, summaryBO["summary"].caseId,
                                            "collaboration", isForm,summaryBO["summary"].affairId,function(lastDoneAffair){
                                                //wxj 协同取回后，直接进入该协同的处理页面
                                                var paramData = {
                                                    "affairId" : lastDoneAffair,
                                                    "backIndex" : summaryBO.backIndex + 1
                                                }
                                                setListViewRefresh("true");
                                                if(cmp.platform.CMPShell) {
                                                    //触发平台事件，用于刷新列表数据
                                                    cmp.webViewListener.fire({
                                                        type: "com.seeyon.m3.ListRefresh",
                                                        data: {type: 'update'}
                                                    });
                                                    cmp.webViewListener.fire({
                                                        type: "edoc.ListRefresh",
                                                    });
                                                    //触发门户刷新数据事件
                                                    cmp.webViewListener.fire({
                                                        type: "refreshPortalData",
                                                        data: "pendingSection,pendingEdocSection,doneSection,sentSection,waitSendSection",
                                                        success: function(){},
                                                        error: function(){}
                                                    });
                                                }
                                                cmp.storage.delete("summary_page_pause", true);
                                                var nextUrl = "/html/details/summary.html"+colBuildVersion;
                                                cmp.href.next(_collPath + nextUrl, paramData);
                                            });
                                    }
                                });
                            },
                            error : function(){

                            }
                        }
                        cmp.funProxy.getter(eventParams);
                        break;
                    case "cancelBtn" : //撤销
                        if(summaryBO["summary"].affairState == 2){
                            var idMap = {
                                "summaryID" : summaryBO.summary.id,
                                "affairID" : summaryBO.summary.affairId
                            }
                            //协同已发撤销前事件
                            var eventParams={
                                funName : "beforeDealCancel",
                                data : idMap,
                                success : function(){
                                    _transRepalValid();
                                },
                                error : function(){

                                }
                            }
                            cmp.funProxy.getter(eventParams);
                        }else{
                            //处理时撤销
                            _repealSummary();
                        }
                        break;
                    case "sendImmediateBtn": //发送
                        _sendImmediate();
                        break;
                    case "editBtn": //编辑

                        var paramData = {
                            "summaryId" : summaryBO["summary"].id,
                            "openFrom" : "listWaitSend",//summaryBO.openFrom
                            "backIndex" : summaryBO.backIndex + 1,
                            "preCaches" : CollCacheKey.getCacheKeys(CollCacheKey.summary, pageX.winParams.cache_subfix)
                        }
                        //更多页面编辑，删除表单缓存
                        /*if(pageX.isMoreComment){
                            if(window.summaryBO && summaryBO["summary"].bodyType == "20"){
                                if(cmp.sui){
                                    var options = {
                                            moduleId:summaryBO["summary"].id,
                                            rightId:summaryBO["summary"].rightId,
                                            viewState: summaryBO._viewState
                                    }
                                    cmp.sui.clearCache(options);
                                }
                            }
                        }*/
                        cmp.href.next(_collPath + "/html/newCollaboration.html"+colBuildVersion, paramData);
                        break;
                    case "trackBtn"://取消跟踪
                        //跟踪 TODO 好像默认显示的不对
                        $s.Coll.getTrackInfo(summaryBO["summary"].affairId, {},errorBuilder({
                            success : function(result) {
                                if(result && result["error_msg"]){
                                    _alert(result["error_msg"]);
                                }else{
                                    setTrackFlag(contextInfo);
                                }
                            }
                        }));
                        break;
                    case "terminateBtn":
                        _terminateSummary();
                        break;
                    case "transformBtn"://转发协同
                        transForward();
                        break;
                    case "canFavoriteBtn": //收藏
                        canFavoriteBtn(function (st) {
                            setCollection(contextInfo,st);
                        });
                        break;
                    case "flowView"://查看流程
                        //zsy改造-使用新的查看流程组件
                        //_showWorkflow();
                        var _body = document.body;
                        if(_body.classList.contains("is-out")){
                            _body.classList.remove("is-out");
                        }
                        var options = {
                            id:summaryBO.summary.id,
                            processId:summaryBO.summary.processId,
                            cancelCllback:function(){
                                if(!_body.classList.contains("is-in") && !_body.classList.contains("is-out")){
                                    _body.classList.add("is-out");
                                }
                            }
                        }
                        cmp.asyncLoad.css(_$pagePath+"/css/details/edocFlowList.css?" + $verstion);
                        cmp.asyncLoad.js([_$pagePath + "/js/details/edocFlowList.js?" + $verstion],function(){
                            if(!window.edocFlowListFun){
                                window.edocFlowListFun = new edocFlowList(options);
                            }else{
                                window.edocFlowListFun.init(options);
                            }
                        });

                        break;
                    case "replayText": //留言
                        var paramData = {
                            'type': 11,
                            'affairId':summaryBO.summary.affairId,
                            'summaryBO':summaryBO,
                            'pageX':pageX,
                            "cache_subfix": pageX.winParams.cache_subfix,
                        };
                        cmp.href.next(_edocPath + "/html/details/leavingMessageList.html?r="+Math.random(), paramData);
                        break;
                    default:
                        break;
                }
            }
            /*cmp("#otherBtns").on("tap", "a", function(){
                

            });*/
            function setTrackFlag(res) {
                var data = res;
                var isTrack=cmp.i18n("collaboration.page.lable.button.track_cancel");
                var trackClass = "see-icon-v5-common-tracking-cancel";
                var _tf= "1";
                if (data.attrs == '1') {
                    _tf="0";
                    isTrack=cmp.i18n("collaboration.page.lable.button.track");
                    trackClass = "see-icon-v5-common-tracking";
                }
                var item = {
                    "attrs" : _tf,
                    "id" : "trackBtn",
                    "class" : trackClass,
                    "lable" : isTrack//取消跟踪
                };
                handleBtnsOption.iconData.splice(data._eq,1,{
                    text: item.lable,
                    iconClass:item.class + ' cmp-theme-fc page-f-22',
                    class: ' cmp-main-fc cmp-f-2',
                    data: cmp.extend({_eq:data._eq},item)
                });
                $uiButton.update(handleBtnsOption,function (rs) {
                    addOtherBtnsEvent(rs);
                })
            }
            function setCollection (res,st) {
                var data = res;
                var isTrack=cmp.i18n("collaboration.page.cancelfavorite2");
                if (st == '0') {
                    _tf="0";
                    isTrack=cmp.i18n("collaboration.page.favorite");
                }
                var item = {
                    "attrs" : st =='0' ? '0':'1',
                    "id" : "canFavoriteBtn",
                    "class" : st=='0'?'see-icon-v5-common-collect':'see-icon-v5-common-collect-fill',
                    "lable" : isTrack//取消收藏
                };
                handleBtnsOption.iconData.splice(data._eq,1,{
                    text: item.lable,
                    iconClass:item.class + ' cmp-theme-fc page-f-22',
                    class: ' cmp-main-fc cmp-f-2',
                    data: cmp.extend({_eq:data._eq},item)
                });
                $uiButton.update(handleBtnsOption,function (rs) {
                    addOtherBtnsEvent(rs);
                })
            }

            footerBar.style.display = "";
        }else{
            footerBar.remove();
        }
    }
}

//处理按钮左边，显示编辑流程的图标
function showWorkflowEditButton() {
    
    var _viewCanEdit = !window.summaryBO.formIsLock && summaryBO.pageConfig.canDeal;
    var subState = window.summaryBO["summary"].affairSubState;
    if (subState != "15" 
        && subState != "16" 
            && subState != "17" 
                && window.summaryBO["summary"].canModify == 'true' 
                    && _viewCanEdit) {
        
        var nodeActions = window.summaryBO.pageConfig.nodeActions;
        if (CollUtils.isInArray(nodeActions, "AddNode") 
                || CollUtils.isInArray(nodeActions, "JointSign") 
                || CollUtils.isInArray(nodeActions, "RemoveNode") 
                || CollUtils.isInArray(nodeActions, "Infom")) {

            // var $workflowbtn = _$("#workflow_btn");
            // if ($workflowbtn) {
                // $workflowbtn.classList.remove("display_none");
                // $workflowbtn.addEventListener("tap", _editWorkflow);
            // }

        }
    }
}

/**
 * 展现流程图
 */
var _summaryRepeatClk = false;

function _editWorkflow(){
    
     _formLoadCheck({
            checkCallback : function(ret){
                if(ret == true){
                    //TODO 如果是非编辑状态下就不需要这个判断了
                    //表单校验判断
                    if(summaryBO.pageConfig.canDeal 
                            && summaryBO["summary"].bodyType == "20"){
                        if(cmp.sui.isPreventSubmit()){
                            //表单失去焦点校验失败,阻止跳转
                            return;
                        }
                    }
                    if(_summaryRepeatClk){
        				return;
    				}
    				_summaryRepeatClk = true;
                    
                    //这里传参要和点击处理一致, 表单有office正文不允许处理
                    var pageParams = {
                        "canEditWorkflow" : true,
                        "action" : WorkFlowLock.SUBMIT,// 提交操作
                        "cache_subfix" : pageX.winParams.cache_subfix,
                        "WebviewEvent" : WebEvents.M3_EVENT_SUMMARY + pageX.winParams.cache_subfix,
                        "edit" : true,
                        "canBack" : false
                    }
                    summaryBO.backIndex = summaryBO.backIndex + 1;
                    cmp.event.trigger("beforepageredirect", document);
                    cmp.href.next(_collPath + "/html/details/workflowEdit.html" + colBuildVersion, pageParams, {openWebview : true});
                }
            }
        });
}

/**
 * 添加流程相关数据
 * 
 * @param param
 * @returns
 */
function _addWorflowData(param) {
    // 删除无用的参数
    delete param["opinionPolicy"];
    delete param["attribute"];
    delete param["nowNodeOpinion"];
    delete param["actions"];
    delete param["filedsIsNull"];
    delete param["actionName"];
    delete param["workflowParam"];
    
    //流程相关参数
    param = cmp.extend(param, pageX.wfDesigner.getDatas());
    return param;
}

var sendCount = 0;
function _sendImmediate() {
	if(sendCount > 0){
		return;
	}
	sendCount++;
	
    //1 开启进度条
    _startSubmitting();
    
    //2 验证流程超期时间是否已过
    var deadlineDatetime = summaryBO["summary"].processDeadLineName;
    if(deadlineDatetime) {
        var nowDatetime = new Date();
        if(deadlineDatetime && (nowDatetime.getTime()+summaryBO.server2LocalTime) > new Date(deadlineDatetime.replace(/-/g,"/")).getTime()){
            _alert(cmp.i18n("collaboration.deadline.sysAlert"), function(){sendCount--;});
            _stopSubmitting();
            return;
        }
    }
    
    //3 验证是否调用模板
    var templateId = null;
    if(summaryBO["summary"].affairSubState != "16") {//指定回退被回退的不再校验模板
        templateId = summaryBO["summary"].templateId;
    }
    if(templateId && templateId!=null && templateId!="") {//有模板
        
        //4 调用模板的状态校验
        $s.Coll.checkCollTemplate({templateId : templateId}, errorBuilder({
            success: function(ret) {
                //4-1 模板删除状态验证
                if(ret.result =='cannot') {
                    _alert(cmp.i18n('collaboration.send.fromSend.templeteDelete'), function(){sendCount--;});//模板已经被删除，或者您已经没有该模板的使用权限三
                    _stopSubmitting();
                    return;
                } 
                //5 是否有流程的验证
                else if(ret.result =='noworkflow') {
                     //协同没有流程,不能发送
                    _alert(cmp.i18n('collaboration.send.fromSend.noWrokFlow'), function(){sendCount--;});
                     _stopSubmitting();
                     return;
                }
                if(ret.result =='isTextTemplate') {
                    if(!summaryBO["summary"].processId) {
                        _alert(cmp.i18n('collaboration.send.fromSend.noWrokFlow'), function(){sendCount--;});
                        _stopSubmitting();
                        return;
                    }
                    _sendImmediateCallback();
                } else {
                    summaryBO["summary"].processId = ret.result;
                    //6 公文发送预提交及提交
                    _sendImmediateCallback();
                }
            }
        }));
    } else {//无模板
        //5 流程的验证
        if(!summaryBO["summary"].processId) {//无模板，有流程
            _alert(cmp.i18n('collaboration.send.fromSend.noWrokFlow'), function(){sendCount--;});
            _stopSubmitting();
            return;
        }
        //TODO 流程id是否为空验证
        //TODO 是否有发起权限验证
        
        //6 公文发送预提交及提交
        _sendImmediateCallback();
    }
}

function _sendImmediateCallback() {
    pageX.wfDesigner.preSubmit({
        contentData : [],
        onPop : function() {
            //组件层级管理，需要把这个影藏
            _stopSubmitting();
        },
        callback : function(preSubmitResult) {
            if(preSubmitResult["result"] == "true") {
                var param = {};
                //处理协同
                $s.Coll.sendImmediate(summaryBO["summary"].affairId, {}, _addWorflowData(param), errorBuilder({
                    success : function(result) {
                        _stopSubmitting();
                        if(result["error_msg"]) {
                            _alert(result["error_msg"], function() {
                                if(window._gotoList){
                                    //意见更多
                                    window._gotoList();
                                }else{
                                    _goBack();
                                }
                            });
                        } else {
                            if(window._gotoList){
                                //意见更多
                                window._gotoList();
                            }else{
                                _goBack();
                            }
                        }
                    }
                }));
            } else {
            	sendCount--;
                _stopSubmitting();
            }
        }
    });
}

function exchangeSendNotSupportSub(){//交换流程不支持回退的校验
	if(summaryBO.summary.exchangeSendAffairId != null && summaryBO.summary.exchangeSendAffairId != '' && summaryBO.summary.govdocType == 'govdocSend'){
		return true;
	}
	return false;
}

//分享组件中的电话会议调用方法
function goMeeting4Share() {
	_goMeeting();
}

//电话会议
function _goMeeting(){
	$s.Coll.multiCall({}, errorBuilder({
        success : function(result) {
        	var obj = result.data.meetingParams;
        	if(obj.meeting_url!=null && obj.meeting_url!=''){
        		obj.openFrom = "openWin";
        		cmp.href.next(_collPath + "/html/multicallPerson_next.html"+colBuildVersion,obj,{nativeBanner:true,openWebViewCatch:1});
        	}else{
        		var options = {
        			title : cmp.i18n("collaboration.meeting.choosePerson"),
        			showAll : false,
        			showState : false,
        			showMeetingInfo : true,
        			callback : function(result){
        				var obj = summaryBO.meetingParams;
        				obj.parties = result;
        				obj.openFrom = "CollSummary";
        				cmp.href.next(_collPath + "/html/multicallPerson_next.html"+colBuildVersion,obj,{nativeBanner:true,openWebViewCatch:1});
        			}
        		};
        		_exeAtWho(options);
        	}
        }
    }));
}

//开始提交
function _startSubmitting(){
    cmp.dialog.loading();
}

//结束提交
function _stopSubmitting(){
	clickCount = false;
    cmp.dialog.loading(false);
}

function _setCommentValue(){
}
/**
 * 协同工作流参数设置， 多个地方调用，一个地方初始化
 */

/**
 * 属性扩展
 * @param paramExt
 * @param infoExt
 */
function _initWfDesigner(paramExt, infoExt){
    LazyUtil.addLoadedFn("lazy_wf", function(){
        
        if(pageX.wfDesigner == null){
            
            var wfParams = {
                    workflow : {
                        moduleType : "1",
                        processId : summaryBO["summary"].processId,
                        caseId : summaryBO["summary"].caseId,
                        currentNodeId : summaryBO["summary"].activityId,
                        subObjectId : summaryBO["summary"].affairWorkitemId
                    },
                    info : {
                        //model : "",
                        //wfSelectorId : "",
                        state : "edit_current",
                        dataCacheKey : CollCacheKey.summary.workflow + pageX.winParams.cache_subfix,//数据缓存key
                        //canEdit : null,
                        //beforDrawWf : null,
                        //customerTap : null,
                        //onTriggerEdit : null,
                        defaultPolicyId : summaryBO["defPolicy"]["value"],
                        defaultPolicyName : summaryBO["defPolicy"]["name"],
                        currentAccountId : summaryBO["currentUser"]["loginAccount"],
                        currentAccountName : summaryBO["currentUser"]["loginAccountName"],
                        currentUserId : summaryBO["currentUser"]["id"],
                        currentUserName : summaryBO["currentUser"]["name"],
                        category : "edoc",
						formEdoc : "formEdoc",
                        workItemId : summaryBO["summary"].affairWorkitemId,
                        affairId : summaryBO["summary"].affairId,
                        summaryId : summaryBO["summary"].id,
                        bodyType : summaryBO["summary"].bodyType,
                        activityId : summaryBO["summary"].activityId,
                        formData : summaryBO["summary"].formRecordId,
                        processTemplateId : summaryBO["summary"].templateProcessId,
                        canTrackWorkflow : summaryBO["canTrackWorkflow"],
                        currentWorkItemIsInSpecial : (summaryBO["summary"].affairSubState == '15' 
                            || summaryBO["summary"].affairSubState == '16' 
                                || summaryBO["summary"].affairSubState == '17'),
                        submitStyleCfg : summaryBO.pageConfig["submitStyleCfg"],
                        isProcessTemplate : summaryBO["isProcessTemplate"],//模板减签
                        templateCanDeleteNode : summaryBO["templateCanDeleteNode"]//模板减签
                    },
                    style : {
                        zIndex : 11
                    },
                    getPermissions : function(callback){
                        var params = {"appName":"collaboration",
                                      "summaryId":summaryBO["summary"].id,
                                      "bodyType":summaryBO["summary"].bodyType,
                                      "defaultPolicyId":summaryBO["defPolicy"].value,
                                      "accountId":summaryBO["summary"].accountId,
                                      "isSystemTemplate":summaryBO["summary"].systemTemplate};
                        //获取节点权限
                      //  $s.Coll.permissions({},params, errorBuilder({
                        //    success : function(ret){
                       //         callback(ret);
                      //      }
                      //  }))
                        $s.EdocResource.permissions({"type":summaryBO["summary"].govdocType,"policyName" : wfParams["info"].currentAccountId, "orgAccountId":summaryBO["summary"].accountId,"formAppid":summaryBO.summary.formAppid}, {
                            success : function(ret){
                                callback(ret);
                            },
                            error: function(err){
                            	EdocUtils.ajaxErrorHander(err);
                            }
                        })
                    }
                }
            
            //扩展属性
            if(paramExt){
                wfParams = cmp.extend(true, wfParams, paramExt);
            }
            
            if(infoExt){
                wfParams.info = cmp.extend(true, wfParams.info, infoExt);
            }
            pageX.wfDesigner = new WorkFlowDesigner(wfParams);
        }
		if(infoExt.finishWfData){
		  infoExt.finishWfData.call();
		}
        //清空配置
        paramExt = null; 
        infoExt = null;
    });
}/**
 * 
 */

//office格式的正文修改
function _editContent(readOnly){
	//判断是否移动授权(获取序列号)
	$s.EditContent.getOfficeAuthKey({},{},errorBuilder({
		success : function(result) {
			if(result && result.officeAuth=="true"){
				var canEdit = false;
				if((cmp.os.ios && result.iosWpsKey) || (!cmp.os.ios && result.androidWpsKey)){
					canEdit = true;
				}
				if(canEdit){
					summaryBO.officeLicense = result;
					summaryBO.type = "newEdoc";
					summaryBO.readOnly = readOnly;
					summaryBO.isClearTrace = true;
					if(!readOnly){
						//修改正文时加锁
						WorkFlowDesignerUtil.lockH5Workflow(summaryBO["summary"].id, CopyWorkFlowLock.EDIT_CONTENT, function(ret) {
							if(ret) {
								LazyUtil.addLoadedFn("lazy_edit", function(){
									ContentEdit.init(summaryBO);
								});
							}
						});
					}else{
						LazyUtil.addLoadedFn("lazy_edit", function(){
							ContentEdit.init(summaryBO);
						});
					}
				}else{
					_alert(cmp.i18n("collaboration.edit.office.content.serial.number"));
				}
			}else{
				_alert(cmp.i18n("collaboration.edit.office.content.authorization"));
			}
        }
	}));
}

function _backPage(callBack){
	var btns = [{
        key : "giveuptip",
        name : cmp.i18n("collaboration.edit.office.content.confirm.save")//放棄修改正文
    },{
        key : "giveup",
        name : cmp.i18n("collaboration.page.lable.yes")//是
    }];
	
	cmp.dialog.actionSheet(btns,cmp.i18n("collaboration.page.lable.no"), function(item) {
        //点击操作
        if("giveup" == item.key){
        	callBack();
        }
    }, function() {
    	return;
    });
}/*
 * 表单开发高级 : 表单开发高级
 * @param bodyType ：正文类型
 * @param affairId :affairId
 * @param attitude :态度
 * @param opinionContent ：意见内容
 * @param currentDialogWindowObj ：当前Dialog对象
*/
function formDevelopAdance4ThirdParty(bodyType,affairId,attitude,opinionContent,currentDialogWindowObj,succesCallBack) {
  try{
      function failedCallBack(){
    	  _stopSubmitting();
      }
      function saveContentCallBack(message) {
    	  if(message != undefined && message != "") {
    	      _setCommentValue(message, true);
    	  }
      }
      if(bodyType != '20' ){
          succesCallBack();
      }else {
          var tAttitude = attitude || "",
              tOpinionContent = opinionContent || "";
          
          beforeSubmit(affairId, tAttitude.trim(), tOpinionContent.trim(),currentDialogWindowObj,succesCallBack,failedCallBack,saveContentCallBack);
      }
   }catch(e){
       _alert(cmp.i18n("collaboration.exception.formException"));
       _stopSubmitting();
   } 
}/**
 * 
 */

pageX.atDialog = null;
pageX.cache.hasAtWhoMembers = true;
pageX.cache.atWhoSelected = [];
pageX.atWhoPage = {"pageNo":1, "pageSize":50}
pageX.atWhoIsLast = false;
pageX.atWhoIsSearching = false;
pageX.options = {
	title : cmp.i18n("collaboration.page.lable.msgPushTitle"),
	showAll : true,
	showState : true,
	showMeetingInfo : false
};

function _initAtWho(){
    //at功能
    var $content = _$('#content');
    var $atBtn =  _$("#atBtn");
    
    if($atBtn && $atBtn.classList.contains("display_none") && 
    		_hasPermissions(summaryBO.pageConfig.nodeActions, "Opinion")){ // 有意见权限才加at功能
        $atBtn.classList.remove("display_none") 
    }
    if($content){
		 $content.addEventListener('keyup', _atWho);
	}
   
	if($atBtn){
		 $atBtn.addEventListener('tap', _exeAtWho);
	}
   
}

function _atWho(e){
    
    if(e.keyCode == KEY_CODE.BACKSPACE){
        //删除
        return;
    }
    
    var c = CollUtils.getCharacter(this);
    if(c === "@"){
        this.blur();
        setTimeout(_exeAtWho, 10);
    }
}

function _mergeConfig(options){
    var newOptions = pageX.options
    for(var key in options){
        if(options && typeof(options[key]) != "undefined"){
        	newOptions[key] = options[key];
        }
    }
    return newOptions;
}

function _exeAtWho(options){
	if(cmp.util.webkitType() == "wechat" && cmp.util.osType()=="ios"){//兼容jira bug OA-190999  微协同问题
		$handContent.classList.add('display_none');
		_$("#button_list_nav_new").classList.remove('display_none');
        _$("#hand_first_line").classList.remove('display_none');
    }
	pageX.options = _mergeConfig(options);
    var dialogConfig = {
        dir : "bottom-go",
        hideType : 'hide',
        initHeader : false,
        show : true,
        initHTML : function() {
            var dialogHtml = '';
            if(cmp.os.ios){
                dialogHtml = '<div class="cmp-search-content cmp-white-bg" style="position:absolute;padding: 40px;width:100%;">'
            }else{
                dialogHtml = '<div class="cmp-search-content cmp-white-bg" style="position:absolute;padding: 5px;width:100%;">'
            }
            dialogHtml = dialogHtml
                + '<form action="javascript:void(0)">'

                + '<div class="cmp-input-row cmp-search">'
                + '  <input id="at-who-input" type="search" autocomplete="off" class="cmp-input-bg cmp-input-clear" placeholder="">'
                + '  <span id="at-who-delete" class="cmp-icon cmp-icon-clear cmp-hidden"></span>'
                + '  <span id="at-who-placeholder" class="cmp-placeholder">'
                + '      <span class="cmp-icon cmp-icon-search cmp-sup-fc2"></span>'
                + '      <span class="cmp-sup-fc2">'+ cmp.i18n("collaboration.page.lable.msgPlaceholder") +'</span>'
                + '  </span>'
                + '</div>'

                +'</form>'
                +'</div>';
            if(cmp.os.ios){
                dialogHtml = dialogHtml + '<div class="cmp-white-bg back_white search_box" style="height: 100%;padding-top: 64px">';
            }else{
                dialogHtml = dialogHtml + '<div class="cmp-white-bg back_white search_box" style="height: 100%;padding-top: 44px">';
            }
            dialogHtml = dialogHtml
                + '<ul id="at-who-ul" class="cmp-list-content cmp-list-opinion-reply" style="width: 100%;height: 100%;overflow: auto;">'
                + '</ul>'
                +'</div>';
            return dialogHtml;
        },
        onInit : function() {


            //加载数据, 加载第一页数据
            _searchAtWhoItem("", true);

            pageX.atDialog.mainDiv.querySelector("#at-who-ul").addEventListener("scroll", function(e){

                //检测向上向下滚动
                var sTop = this.scrollTop, viewHeight = this.clientHeight;
                var hideHeight = this.scrollHeight - (sTop + viewHeight);
                if(hideHeight < 300 && pageX.atWhoIsSearching === false){
                    //请求下一页
                    _searchAtWhoItem(this.value, false);
                }
            });

            var atWhoInput = pageX.atDialog.mainDiv.querySelector("#at-who-input");
            var atWhoDelete = pageX.atDialog.mainDiv.querySelector("#at-who-delete");
            var atWhoPlaceholder = pageX.atDialog.mainDiv.querySelector("#at-who-placeholder");

            atWhoInput.addEventListener("keyup", function(e){
                if(e.keyCode == 13 || e.which == 13) {
                    _searchAtWhoItem(this.value, true);
                }
            });
            atWhoInput.addEventListener("focus", function(e){
                var pNode = this.parentNode;
                var pNodeCL = pNode.classList;
                if(!pNodeCL.contains("cmp-active")){
                    pNodeCL.add("cmp-active");
                }
                pNode.querySelector("#at-who-delete").classList.remove("cmp-hidden");
            });
            atWhoInput.addEventListener("blur", function(e){
                var pNode = this.parentNode;
                if(this.value == ""){
                    var pNodeCL = pNode.classList;
                    if(pNodeCL.contains("cmp-active")){
                        pNodeCL.remove("cmp-active");
                    }
                }
                pNode.querySelector("#at-who-delete").classList.add("cmp-hidden");
            });
            atWhoDelete.addEventListener("tap", function(e){
                var atInput = this.parentNode.querySelector("#at-who-input");
                var oldValue = atInput.value;
                if(oldValue != ""){
                    atInput.value = "";
                    _searchAtWhoItem("", true);
                }
            });
            atWhoPlaceholder.addEventListener("tap", function(e){
                this.parentNode.querySelector("#at-who-input").focus();
            });

            //
            cmp("#at-who-ul").on("tap", "li", function(e){
                var srcEle = e.target, tagName = srcEle.tagName.toLocaleLowerCase();
                if(tagName !== "input"){
                    e.stopPropagation();
                    var liInput = this.querySelector("input");
                    if(liInput){
                        if(liInput.checked){
                            liInput.checked = false;
                        }else{
                            liInput.checked = true;
                        }
                    }
                }
            });
        },
        onShow : function() {
            _$("title").innerText = cmp.i18n("collaboration.page.lable.msgPushTitle");
        },
        rightBtnConfig : {
            label : cmp.i18n("collaboration.page.cancelFavorite"),
            extClass : "aticon",
            isPopBtn : true,
            hander : function() {
                _$("#at-who-input").blur();
                pageX.atDialog.hide();
            }
        },
        bottonConfig : {
            buttons :[
                {
                    type : 1,
                    isPopBtn : true,
                    label : cmp.i18n("collaboration.page.cancelFavorite"),
                    hander : function(){
                        _$("#at-who-input").blur();
                        pageX.atDialog.hide();
                    }
                },
                {
                    label : cmp.i18n("collaboration.page.dialog.OK"),
                    hander : function(){
                        //
                        var inputs = _$("input", true, pageX.atDialog.mainDiv);
                        pageX.cache.atWhoSelected = [];//确定先清空之前的数据
                        if(inputs){
                            var selecteds = [];
                            for(var i = 0; i < inputs.length; i++){
                                var input = inputs[i];
                                if(input.checked){
                                    if(pageX.options.showMeetingInfo){
                                        selecteds.push({
                                            "name" : input.getAttribute("data-name"),
                                            "phone" : input.getAttribute("data-phone")
                                        });
                                    }else{
                                        selecteds.push({
                                            "affairId" : input.getAttribute("data-affairid"),
                                            "memberId" : input.value,
                                            "name" : input.getAttribute("data-name")
                                        });

                                    }
                                    input.checked = false;
                                }
                            }
                            if(typeof(pageX.options.callback) == "function"){
                                pageX.options.callback(cmp.toJSON(selecteds));
                            }else{
                                _pushAtWhoItem(selecteds);
                            }
                        }
                        closeAtDialog();
                    }
                }
            ]
        }
    }

    //弹出框
    pageX.atDialog = CollUtils.openDialog(dialogConfig);
    pageX.atDialog.popFun = function() {
        closeAtDialog();
    };
}

function closeAtDialog() {
    setTimeout(function() { //不加延时，没有效果
        window.scroll(0, 0);
    }, 700);
    // if (cmp.platform.wechat){
    //     //软键盘收起
    //     cmp('body').on('focusout','#content',function(){
    //         setTimeout(function() { //不加延时，没有效果
    //             window.scroll(0, 0);
    //         }, 100);
    //     });
    // }
    pageX.atDialog.close();
    pageX.atDialog = null;
}

function _mergeAtWho(content){
    
    var ret = [];
    if(pageX.cache.atWhoSelected && pageX.cache.atWhoSelected.length > 0){
        for(var i = 0, len = pageX.cache.atWhoSelected.length; i < len; i++){
            var atItem = pageX.cache.atWhoSelected[i];
			//新公文at功能不在意见区显示，所以content中不会有at标记
            //if(content.indexOf("@" + atItem.name) != -1){
                ret.push(atItem);
            //}
        }
    }
    return cmp.toJSON(ret);
}

function _pushAtWhoItem(datas){
    
    if(datas && datas.length > 0){
        
        var $content, pos, startStr, endStr, source;
        
        $content = _$("#content");
        $content.focus();
        source = $content.value;
        
        pos = CollUtils.getPos($content);
        startStr = source.slice(0, pos-1);
        endStr = source.slice(pos || 0);
        
        var c = CollUtils.getCharacter($content, pos);
        c = c != "@" ? "@" : "";
        
        var atStr = "";
        
        for(var i = 0; i < datas.length; i++){
            var data = datas[i], atAffairId, atMemberId, atName;
            
            atAffairId = data.affairId;
            atMemberId = data.memberId;
            atName = data.name;
            
            if(i != 0){
                atStr += "@";
            }
            atStr += atName + " "
            
            pageX.cache.atWhoSelected.push({
                "affairId" : atAffairId,
                "memberId" : atMemberId,
                "name" : atName
            });
        }
        
		//新公文at功能不在意见区显示，所以content中不会有at标记,只在pc端有消息提醒
        $content.value = source;
        //CollUtils.setPos($content, pos + atStr.length + 1);
        //$content.blur();
        
        //CollUtils.fnFontCount("#content", "#fontCount", pageX.MAX_INPUT_LENGTH);
        //$content.selectionStart = $content.selectionEnd = pos + atName.length + 1;
    }
}

function _searchAtWhoItem(val, refresh){
    
    if(pageX.atWhoIsLast === true && !refresh){
        return;
    }
    
    pageX.atWhoIsLast = false;
    val = val || "";
    
    //加载数据
    cmp.dialog.loading();
    pageX.atWhoIsSearching = true;
    if(refresh === true){
        pageX.atWhoPage.pageNo = 1;
    }else{
        pageX.atWhoPage.pageNo += 1;
    }
    
    pageX.atWhoPage.summaryId = summaryBO.summary.id;
    pageX.atWhoPage.name = val;
    $s.Coll.pushMessageToMembersList(pageX.atWhoPage, errorBuilder({
        success : function(ret){
            cmp.dialog.loading(false);
            pageX.atWhoIsSearching = false;
            ret = ret || [];
            if(!val && ret.length == 0 && pageX.atWhoPage.pageNo == 1){
                pageX.cache.hasAtWhoMembers = false;
                var msg = '<div class="StatusContainer"><div class="nocontent"></div><span class="text nocontent_text">'+cmp.i18n("collaboration.page.lable.msgNoMembers")+'</span></div>';
                pageX.atDialog.mainDiv.querySelector("#at-who-ul").innerHTML = msg;//没有消息推送的人
            }
            
            if(pageX.cache.hasAtWhoMembers){
                
                if(ret.length < pageX.atWhoPage.pageSize){
                    pageX.atWhoIsLast = true;
                }
                var searchResults = null;
                if(refresh && pageX.options.showAll){
                    searchResults = [{
                        "name" : "All",
                        "id" : "All",
                        "i18n" : cmp.i18n("collaboration.page.lable.msgAllMember"),//所有人
                        "memberId" : "All"
                    }].concat(ret);
                }else{
                    searchResults = ret;
                }
                _renderAtWhoList(searchResults, refresh);
            }
        },
        error : function(){
            cmp.dialog.loading(false);
            pageX.atWhoIsSearching = false;
        }
    }))
}

function _renderAtWhoList(memberList, refresh){
    
    var h = "";
    
    if(memberList && memberList.length > 0){
        
        var htmlTemplate = '<%for(var i = 0, len = this.length; i < len; i++){'
            +'  var item = this[i];var isSelected = false;for(var j = 0;j<pageX.cache.atWhoSelected.length;j++){if(pageX.cache.atWhoSelected[j].memberId == item.memberId){isSelected = true;break;}}'
            +'%>'
            +'<li class="cmp-list-cell ">'
            +' <div class="cmp-list-cell-img cmp-checkbox cmp-left">'
            +'<%if(isSelected){%>'
            +'     <input class="select-put" type="checkbox" checked="checked" value="<%=item.memberId%>" data-affairid="<%=item.id%>" data-phone="<%=item.phone%>" data-name="<%=item.name%>"/>'
            +'<%}else{%>'
            +'     <input class="select-put" type="checkbox" value="<%=item.memberId%>" data-affairid="<%=item.id%>" data-phone="<%=item.phone%>" data-name="<%=item.name%>"/>'
            +'<%}%>'
            +'<%if(item.id != "All"){%>'
            +'     <img class="cmp-pull-left img_setting" width="40px" height="40px" src="<%=item.headshotURL%>"/>'
            +'<%    var affairInfo = CollUtils.showAffairState(item.state, item.subState, item.backFromId); item.i18n=affairInfo.label;%>';
        if(pageX.options.showState){
        	htmlTemplate += '<%if(affairInfo.color != "sent"){%>'
                +'     <div style="left:52px;top:28px" class="read-states <%=affairInfo.color%>">'
                +'        <div class="state-bg">'
                +'           <span class="<%=affairInfo.icon%> state-color"></span>'
                +'        </div>'
                +'     </div>'
                +'<%}%>';
        }
        htmlTemplate += '<%}%>'
            +' </div>';
        if(pageX.options.showMeetingInfo){
        	htmlTemplate += ' <div class="cmp-list-cell-info" >';
        }else{
        	htmlTemplate += ' <div class="cmp-list-cell-info" style="width:50%">';
        }
        htmlTemplate += '<%if(item.postName){%>'
            +'     <span class="cmp-cont-fc cmp-ellipsis cmp-pull-left list_title_name width_69"><%=item.name%></span>';
        if(pageX.options.showMeetingInfo){
        	htmlTemplate += '     <span class="cmp-cont-fc cmp-ellipsis cmp-pull-left list_title_name width_69">('
        	+'<%if(item.phone){%>'
        		+'<%=item.phone%>'
        	+'<%}else{%>'
        		+ cmp.i18n("collaboration.multicall.none")
        	+'<%}%>)'
        }
        htmlTemplate += '     <h6 class="cmp-ellipsis list_cont_info cmp-sup-fc1"><%=item.postName%></h6>'
            +'<%}else{%>'
            +'     <span style="margin-top:10px;" class="cmp-cont-fc cmp-ellipsis cmp-pull-left list_title_name width_69"><%=item.name%></span>'
            +'<%}%>'
            +' </div>';
        if(pageX.options.showState){
        	htmlTemplate += '        <div class="handler-states common-state right" style="width:20%;"><span style="width:100%;margin-top:6px;"><%=item.i18n%></span></div>';
        }
        htmlTemplate += ' </li>'
            +'<%}%>';
        
        //设置头像
        for(var k = 0; k < memberList.length; k++){
            memberList[k]["headshotURL"] = cmp.origin + "/rest/orgMember/avatar/" + memberList[k]["memberId"] + "?maxWidth=200";
        }
        
        h = cmp.tpl(htmlTemplate, memberList);
    }
    
    if(refresh){
        pageX.atDialog.mainDiv.querySelector("#at-who-ul").innerHTML = h;
    }else if(h != ""){
        pageX.atDialog.mainDiv.querySelector("#at-who-ul").insertAdjacentHTML("beforeEnd", h);
    }
}