(function (_, $) {
    if (!window.$v5App) {
        window.$v5App = {};
    }
    var dealMap = {};

    function dealMarkAlert(id) {
        var idString = 'dealMask_component_' + id;
        var list = [
            [],
            [],
            []
        ];
        if (dealMap[idString]) {
            return dealMap[idString]
        }
        var target = null;
        createdDom.call(this);
        var eventMap = {};
        var eventShowMap = [];
        var eventCloseMap = [];
        var _that= this;
        this.open = function () {
            if (target) {
                var st = target.classList.contains('cmp-active');
                target.classList.add('cmp-active');
                cmp.zIndex.push(function (zIndex) {
                    target.style.zIndex = zIndex;
                });
                cmp.backbutton.push(function () {
                    _that.close();
                });
                if (!st) {
                    eventShowMap.forEach(function (item) {
                        item&&item({target:target});
                    });
                }
            }
        };
        this.close = function () {
            if (target) {
                var st = target.classList.contains('cmp-active');
                target.classList.remove('cmp-active');
                cmp.zIndex.pop();
                cmp.backbutton.pop();
                if (st) {
                    eventCloseMap.forEach(function (item) {
                        item&&item({target:target});
                    });
                }
            }
        };
        this.on = function (eventName, callback) {
            if (typeof callback === 'function' && eventName) {
                eventMap[eventName + ''] = callback;
            }
        };
        this.off = function (eventName) {
            if (eventMap[eventName + '']) {
                delete eventMap[eventName + '']
            }
        };
        this.destroy = function () {
            delete dealMap[idString];
            if (target) {
                target.remove();
            }
            eventMap = null;
            eventShowMap = null;
            eventCloseMap = null;
            for (var k in this) {
                if (typeof this[k] === 'function') {
                    this[k] = function () {
                    }
                }
            }
        };
        this.push = function (data, row) {
            if (data) {
                var datas = data;
                if (Object.prototype.toString.call(data) !== '[object Array]') {
                    datas = [data];
                }
                this.update({
                    col: 1000,
                    row: row,
                    data: datas,
                })
            }
        };
        this.onopen = function (callback) {
            if (typeof callback === 'function') {
                eventShowMap.push(callback);
            }
        };
        this.onclose = function (callback) {
            if (typeof callback === 'function') {
                eventCloseMap.push(callback);
            }
        };
        this.getBy = {
           $unique:function (unique) {

           },
           $group: function () {

           }
        };
        this.onclick = function (res) {
            console.log(res)
        };
        this.refresh = function () {
            target.querySelector('.deal-buttons-0').innerHTML = getItems(list[0], 0);
            target.querySelector('.deal-buttons-1').innerHTML = getItems(list[1], 1);
            target.querySelector('.deal-buttons-2').innerHTML = getItems(list[2], 2);
        };
        this.updateGroup = function (obj) {
            var cfg = cmp.extend({}, {
                col: 0,
                row: 0,
                data: [],
                group: ''
            }, obj);
            var data = cfg.data.length ? cfg.data : [];
            var isRow = cfg.row === parseInt(cfg.row) && (cfg.row >= 0 && cfg.row <= 2);
            if (isRow) {
                var warp = '.deal-buttons-' + cfg.row;
                var nows = list[cfg.row];
                var index = -1;
                var scrollx = target.querySelector(warp).scrollLeft || 0;
                    for (var i = 0; i < nows.length; i++) {
                    if (nows[i].$group && nows[i].$group === cfg.group) {
                        if (index === -1) {
                            index = i;
                        }
                        nows.splice(i, 1);
                        target.querySelectorAll(warp + ' .deal-button-el')[i].remove();
                        i--;
                    }
                }
                list[cfg.row] = nows;
                this.update({
                    col: index>=0?index:1000,
                    row: cfg.row,
                    data: data,
                },scrollx)
            }
        };
        this.update = function (obj,scrollX) {
            var cfg = cmp.extend({}, {
                col: 0,
                row: 0,
                data: [],
                group: ''
            }, obj);
            var isCol = cfg.col === parseInt(cfg.col) && (cfg.col >= 0);
            var isRow = cfg.row === parseInt(cfg.row) && (cfg.row >= 0 && cfg.row <= 2);
            var scrollx = Number(scrollX) || 0;
            if (isCol && isRow) {
                var data = cfg.data.length ? cfg.data : [];
                var nows = list[cfg.row];
                var s = getItems(data, cfg.row);
                var warp = '.deal-buttons-' + cfg.row;
                var slist = list[cfg.row];
                if (!scrollx){scrollx = target.querySelector(warp).scrollLeft || 0}
                if (nows.length === 0) {
                    list[cfg.row] = data;
                    target.querySelector(warp).innerHTML = s;
                } else if (cfg.col < (slist.length)) {
                    var args = [cfg.col, 1].concat(data);
                    slist.splice.apply(slist, args);
                    list[cfg.row] = slist;
                    var eqEl = target.querySelectorAll(warp + ' .deal-button-el')[cfg.col];
                    if (eqEl) {
                        $(eqEl).after(s);
                        eqEl.remove();
                    }
                } else if (cfg.col >= (slist.length) && data.length) {
                    slist.push.apply(slist, data);
                    list[cfg.row] = slist;
                    $(target.querySelector(warp)).append(s);
                }
                target.querySelector(warp).scrollLeft = scrollx;
                checkHasChild();
            }
        };
        dealMap[idString] = this;

        function checkHasChild() {
            var w0 = target.querySelectorAll('.deal-buttons-0 .deal-button-el');
            var w1 = target.querySelectorAll('.deal-buttons-1 .deal-button-el');
            var w2 = target.querySelectorAll('.deal-buttons-2 .deal-button-el');
            var all = w0.length + w1.length + w2.length;
            addNoChild(target, all);
            addNoChild(target.querySelector('.deal-group-item-0'), w0.length);
            addNoChild(target.querySelector('.deal-group-item-1'), w1.length);
            addNoChild(target.querySelector('.deal-group-item-2'), w2.length);

            function addNoChild(dom, num) {
                dom.classList[num ? 'remove' : 'add']('deal-no-el');
            }
        }

        function getItems(list, row) {
            var s = '';
            list.forEach(function (item) {
                if (row === 2) {
                    s += textItem(item);
                } else {
                    s += buttonItem(item);
                }
            });
            return s;
        }

        function textItem(data) {
            return '<div class="deal-button-el deal-button-name cmp-f-2 cmp-main-fc cmp-textover-1 cmp-white-bg">' + data.$name + '</div>'
        };

        function buttonItem(data) {
            var icon = data.$iconImg ? '<img src="' + data.$iconImg + '"' : '';
            if (!icon) {
                icon = data.$iconClass ? '<span class="' + data.$iconClass + '"></span>' : '';
            }
            var statusText = '';
            if (data.$statusText) {
                statusText = '<div class="deal-button-status cmp-f-2 cmp-theme-fc cmp-textover-1">' + data.$statusText + '</div>';
            }
            return '<div class="deal-buttons-item deal-button-el">\n' +
                '     <div class="deal-icon cmp-white-bg cmp-flex-h cmp-y-center cmp-x-center cmp-desc-fc">' +
                (icon) +
                '       </div>\n' +
                '                        <div class="deal-button-name cmp-f-2 cmp-main-fc cmp-textover-2">' + data.$name + '</div>\n' +
                statusText +
                '                    </div>';
        }

        function createdDom() {
            var that = this;
            if (document.querySelector('#' + idString)) {
                document.querySelector('#' + idString).remove();
            }
            var div = document.createElement('div');
            div.id = idString;
            div.style.backgroundColor = 'rgba(255,255,255,0)';
            div.className = 'collsumn-mask-alert deal-actions-alert Animated-Container bottom-go collsumn-fullscreen';
            div.innerHTML = '' +
                '  <div class="collsumn-mask-card collsumn-card-radius cmp-gray-bgc">\n' +
                '            <div class="collsumn-h-50 card-title collsumn-card-radius cmp-flex-h cmp-y-center cmp-x-center">\n' +
                '                <span class="cmp-main-fc cmp-f-6">' + (_.i18n("collaboration.page.lable.button.moreProcessing")) + '</span>\n' +
                '            </div>' +
                '<div class="deal-buttons-group collsumn-over-hidden">' +
                '               <div class="cmp-bda-bgc deal-group-item-0 cmp-after-line collsumn-over-hidden"><div data-row="0" class="deal-buttons-0 deal-buttons-warp collsumn-scroll collsumn-scroll-hidden"></div></div>' +
                '                <div class="cmp-bda-bgc deal-group-item-1 cmp-after-line collsumn-over-hidden"><div data-row="1" class="deal-buttons-1 deal-buttons-warp collsumn-scroll collsumn-scroll-hidden"></div></div>' +
                '                <div class="cmp-bda-bgc deal-group-item-2 cmp-after-line collsumn-over-hidden"><div data-row="2" class="deal-buttons-2 deal-buttons-text-warp collsumn-scroll collsumn-scroll-hidden"></div></div>' +
                '</div>' +
                '<div class="mask-close collsumn-mask-close collsumn-h-50 cmp-flex-h cmp-y-center cmp-x-center cmp-after-line">\n' +
                '                <span class="cmp-f-6 cmp-desc-fc">' + (_.i18n('collaboration.batch.title.label.close')) + '</span>\n' +
                '            </div>';
            target = div;
            document.body.appendChild(target);
            $(target).on('tap', function (e) {
                if (e.target === this) {
                    that.close();
                }
            });
            checkHasChild();
            $(target).on('tap', '.mask-close', function () {
                that.close();
            });
            $(target).on('tap', '.deal-button-el', function () {
                var sublings = this.parentElement.querySelectorAll('.deal-button-el');
                var userClose = false;
                for (var i = 0; i < sublings.length; i++) {
                    if (this === sublings[i]) {
                        var row = Number(this.parentElement.getAttribute('data-row'));
                        var item = list[row][i];
                        if (item.$event && eventMap[item.$event + '']) {
                            userClose = eventMap[item.$event + '']({
                                row: row,
                                col: i,
                                item: item
                            });
                        } else {
                            if (that.onclick) {
                                userClose = that.onclick({
                                    row: row,
                                    col: i,
                                    item: item
                                });
                            }
                            ;
                        }
                        if (!userClose) {
                            that.close();
                        }
                        break;
                    }
                }
            });
        }
    }

    window.$v5App.dealMarkAlert = dealMarkAlert
})(cmp, $cmp);