var documentTitle

function edocFlowList(opts) {
    this.init(opts);
    this.opts = opts;
}

edocFlowList.prototype = {
    init:function(opts){
        documentTitle = $('#showTitle').text();
        document.title = "查看流程";
        $('#showTitle').text("查看流程");
        $("#handler_switch_btn").hide();
        window.edocFlowList = this;
        initFlowListBack();
        initFlowListDom();
        getFlowListData(opts);
        
    },
    fireClose:function(){
        cmp.backbutton.pop();
        document.title = documentTitle;
        $('#showTitle').text(documentTitle);
        $('#flow-list-dialog').remove();
        $("#handler_switch_btn").show();
        this.opts.cancelCllback && this.opts.cancelCllback();
    }
}
// 初始化返回按钮
function initFlowListBack() {
    cmp.backbutton();
    cmp.backbutton.push(function () {
        $('#showTitle').text(documentTitle);
        $('#flow-list-dialog').remove();
        cmp.backbutton.pop();
    });
}

// 初始化dom
function initFlowListDom() {
    const html = `
    <div class="flow-list-wrap" id="flow-list-wrap">

    </div>
    <div id="subflow-dialog" class="subflow-dialog"></div>`;
    const flowListDialog = document.createElement('div');
    flowListDialog.id = 'flow-list-dialog';
    flowListDialog.className =
        'flow-list-dialog Animated-Container left-go cmp-active';
    const index = cmp.zIndex.get() + 2;
    const windowHeight = window.document.body.offsetHeight;
    const headerHeight = document.querySelector('#page_header').offsetHeight;
    flowListDialog.style.cssText =
        'z-index:' +
        index +
        ';top:' +
        headerHeight +
        'px;height:' +
        (windowHeight - headerHeight) +
        'px; ';
    flowListDialog.innerHTML = html;
    flowListDialog.innerHTML = html;
    document.body.appendChild(flowListDialog);
}

// 获取流程列表数据
function getFlowListData(opts) {
    
    const processId = opts.processId;
    const objectId = opts.id;
    cmp.dialog.loading();
    $s.PetroChinaApi.getFlowLogDataList(processId, objectId, {
        success : function(result) {
            cmp.dialog.loading(false);
            console.log(result);
            initFlowList(result);
            initFlowListEvent();
        },
        error: function(result){
            cmp.dialog.loading(false);
            EdocUtils.ajaxErrorHander(result);
        }
    });
}

function getSubFlowListData(opts,callback) {
    const processId = opts.linkProcessId;
    const objectId = opts.id;
    cmp.dialog.loading();
    $s.PetroChinaApi.getFlowLogDataList(processId, objectId, {
        success : function(result) {
            cmp.dialog.loading(false);
            console.log(result);
            callback(result);
        },
        error: function(result){
            cmp.dialog.loading(false);
            EdocUtils.ajaxErrorHander(result);
        }
    });
}

function initFlowList(data) {
    let html = '';
    let processLog = data.processLog || [];
    let pendingMessage = data.pendingMessage || [];
    processLog.reverse(); 
    let handlerData = [...pendingMessage, ...processLog];
    if (handlerData && handlerData.length) {
        // handlerData.forEach(ele => {
        //     html += renderFlowListItem(ele);
        // });
        if(pendingMessage && pendingMessage.length){
            pendingMessage.forEach(ele =>{
                ele.isPendingMessage = true;
                html += renderFlowListItem(ele);
            });

            //html += "<div class='zsy-big-gap'></div>";
        }
        if(processLog && processLog.length){
            processLog.forEach(ele =>{
                ele.isProcessLog = true;
                html += renderFlowListItem(ele);
            });
        }
        $('#flow-list-wrap').html(html);
    } else{
        // 无数据
        new cmp.ui.errorView(document.querySelector("#flow-list-wrap"), {
            code: '5001',
            showPosition: 'center',
            callback: function(){}
        })
    }
    
}   
// //转换日期格式 yyyy-MM-dd hh:mm
// function convertDateFormat(dateStr){
//     try {
//         let date = new Date(dateStr);
//         let y = date.getFullYear(),
//             M = date.getMonth()+1,
//             d = date.getDate(),
//             h = date.getHours(),
//             m = date.getMinutes();
//         return y + "-" + getFormatNum(M) + "-" + getFormatNum(d) + " " + getFormatNum(h) + ":" + getFormatNum(m);
//     }catch (e){
//
//     }
//     return dateStr;
// }
//
// function getFormatNum(n){
//     if(parseInt(n) < 10){
//         return "0" + n;
//     }
//     return n;
// }


function renderFlowListItem(data, isSubFlowItem) {
    const {nodeName, handler, linkProcessId, finishDateStr, actionDesc, opinion, runTime,currentMember, index, status,isPendingMessage, createDate} = data;
    const isHandled = !!finishDateStr;
    const renderFinishDateStr = isPendingMessage?createDate:finishDateStr;
    let html = `<div class="flow-list-item">
    <div class="flow-list-item-wrap">
        <div class="flow-list-item-icon-box">
             ${
                 isHandled
                     ? '<span class="see-icon-v5-common-select-fill-color flow-list-item-icon select-fill-icon"></span>'
                     : '<span class="see-icon-v5-common-right-circle flow-list-item-icon right-arrow-icon"></span>'
             }
        </div>
        <div class="flow-list-item-title text-ellipsis">${nodeName|| '节点标题，暂无数据'}</div>`;

    // 子流程不展示操作
    if (!isSubFlowItem) {
        //有子流程
        if (linkProcessId) {
            html +=
                '<div class="flow-list-item-arrow-box item_detail_find" linkProcessId="'+linkProcessId+'"><span class="flow-list-item-detail">查看</span></div>';
        } else {
            html +=
            '<div class="flow-list-item-arrow-box item_detail_arrow close"><span class="flow-list-item-detail">详细</span><div class="flow-list-item-arrow"></div></div>';
        }
    }

    html += `</div>
    <div class="flow-list-item-children">
    <div class="flow-list-item-children-border"></div>
    <div class="flow-list-item-time text-ellipsis">${renderFinishDateStr}</div>
    ${
        ( handler || currentMember )&&
        `<div class="flow-list-item-handler text-ellipsis">[${handler || currentMember}]</div>`
    }
    <div class="flow-list-children-wrap" >
    <div class="flow-list-item-children-item">`;
    if(status){
        html += `<p>${status}</p>`;
    } else {
        html += `<p>[ ${handler} ]执行了[ ${actionDesc} ]操作</p>`; 
    }
    if(runTime) {
        html += `<p>${runTime}</p>`;
    }
    html += `</div></div></div></div>`;
    return html;
}


function showSubFlowDialog(subflow) {

    let html = `
    <div class="subflow-mask">
        <div class="subflow-mask-wrap">
             <div class="subflow-mask-title">子流程</div>
             <div class="subflow-mask-content">`;
    let processLog = subflow.processLog || [];
    let pendingMessage = subflow.pendingMessage || [];
    if(pendingMessage && pendingMessage.length){
        pendingMessage.forEach(ele =>{
            ele.isPendingMessage = true;
            html += renderFlowListItem(ele);
        });
        //html += "<div class='zsy-big-gap'></div>";
    }
    if (processLog && processLog.length) {
        processLog.forEach(item => {
            html += renderFlowListItem(item, true);
        });

    }

    html += '</div></div></div>';
    $('#subflow-dialog').html(html);
    let subFlowDetailAction = false;
    $('#subflow-dialog').unbind("tap").bind('tap', function () {
        if(subFlowDetailAction){
            subFlowDetailAction = false;
        }else {
            $(this).empty();
        }

    });

    // 详细， 收起
    $('#subflow-dialog .item_detail_arrow').unbind("tap").bind("tap", function () {
        let className = $(this).attr('class');
        subFlowDetailAction = true;
        if (className.indexOf(' close') > -1) {
            className = className.replace(' close', '');
            $(this).children('.flow-list-item-detail').text('收起');
            $(this).parent().next().children('.flow-list-children-wrap').show();
            $(this).parent().next().children('.flow-list-item-handler').show();

        } else {
            className += ' close';
            $(this).children('.flow-list-item-detail').text('详细');
            $(this).parent().next().children('.flow-list-children-wrap').hide();
            $(this).parent().next().children('.flow-list-item-handler').show();
        }
        $(this).attr('class', className);
    });
}

function initFlowListEvent() {
    // 查看子流程
    $('.item_detail_find').on('tap', function () {
        let linkProcessId = $(this).attr("linkProcessId");
        let params = {
            id:"",
            linkProcessId:linkProcessId
        };
        getSubFlowListData(params,showSubFlowDialog);
    });
    // 详细， 收起
    $('.item_detail_arrow').on('tap', function () {
        let className = $(this).attr('class');
        if (className.indexOf(' close') > -1) {
            className = className.replace(' close', '');
            $(this).children('.flow-list-item-detail').text('收起');
            $(this).parent().next().children('.flow-list-children-wrap').show();
            $(this).parent().next().children('.flow-list-item-handler').show();
            
        } else {
            className += ' close';
            $(this).children('.flow-list-item-detail').text('详细');
            $(this).parent().next().children('.flow-list-children-wrap').hide();
            $(this).parent().next().children('.flow-list-item-handler').show();
        }
        $(this).attr('class', className);
    });
}
