cmp.ready(function () {// 缓存详情页面数据
    _initBackEvent();

    cmp.i18n.init(_collPath + "/i18n/", "Collaboration", function () {
        _fillPage();
    });
});

function _initBackEvent() {

    cmp.backbutton();
    cmp.backbutton.push(_goBack);
    _$("#goBackBtn").addEventListener("tap", _goBack);
}

// 页面布局
function _fillPage() {
    loadData();
}

//返回
function _goBack() {
    cmp.href.back();
}

function loadData() {
	//设置OCIP全局header跳转信息
	try{
		var ocipConfig = cmp.href.getParam('ocipConfig');
		var summaryId = cmp.href.getParam('summaryId');
		if(ocipConfig){
			cmp.setGlobalHeader({'forwardto' : ocipConfig});
		}
	}catch(err){}
    
    var params = {
        "objectId": cmp.href.getParam("summaryId"),
        "isHistoryFlag": "",
    };
    cmp.dialog.loading();
    cmp.listView("#handlerList", {
        config: {
            height: 50,
            pageSize: 20,
            params: params,
            dataFunc: getHandleDetail,
            renderFunc: _renderListData,
        },
        down: {
            contentprepage: cmp.i18n("Edoc.page.lable.prePage"),//上一页
            contentdown: cmp.i18n("Edoc.action.pullDownRefresh"),//可选，在下拉可刷新状态时，下拉刷新控件上显示的标题内容
            contentover: cmp.i18n("Edoc.action.loseRefresh"),//可选，在释放可刷新状态时，下拉刷新控件上显示的标题内容
            contentrefresh: cmp.i18n("Edoc.state.refreshing")//可选，正在刷新状态时，下拉刷新控件上显示的标题内容
        },
        up: {
            contentnextpage: cmp.i18n("Edoc.page.lable.nextPage"),//下一页
            contentdown: cmp.i18n("Edoc.action.loadMore"),//可选，在上拉可刷新状态时，上拉刷新控件上显示的标题内容
            contentrefresh: cmp.i18n("Edoc.state.loading"),//可选，正在加载状态时，上拉加载控件上显示的标题内容
            contentnomore: cmp.i18n("Edoc.state.noMore") //可选，请求完毕若没有更多数据时显示的提醒内容；
        }
    });
}

function getHandleDetail(params, options) {
    $s.EdocResource.handleDetail({}, params, {
        success: function (result) {
            cmp.dialog.loading(false);
            if (options.success && result) {
                for(var i = 0; i < result.data.data.length; i++) {
                    var item = result.data.data[i];
                    item.receiveTime = item.finishDate ? getDateStr(parseInt(item.finishDate)) : "-";
                }
                options.success(result.data);
            }
        },
        error: function (result) {
            cmp.dialog.loading(false);
            console.log(result);
        }
    });
}

function _renderListData(data, isRefresh) {
    var tpl = _$("#handler_li_tpl").innerHTML;
    var table = document.body.querySelector('.cmp-table-view');
    var html = cmp.tpl(tpl, data);
    if (isRefresh) {//是否刷新操作，刷新操作 直接覆盖数据
        table.innerHTML = html;
    } else {
        table.innerHTML = table.innerHTML + html;
    }
}

function getDateStr(timeLong) {
    var oDate = new Date(timeLong),
        oYear = oDate.getFullYear(),
        oMonth = oDate.getMonth() + 1,
        oDay = oDate.getDate(),
        oHour = oDate.getHours(),
        oMin = oDate.getMinutes(),
        oTime = oYear + '-' + getzf(oMonth) + '-' + getzf(oDay) + ' ' + getzf(oHour) + ':' + getzf(oMin);//最后拼接时间
    return oTime;
};

//补0操作
function getzf(num) {
    if (parseInt(num) < 10) {
        num = '0' + num;
    }
    return num;
}

