
// zsy改造-组合查询页面

(function(){

    var getParam;
    cmp.ready(function () {
        
        getParam = cmp.util.getParamByUrl();
        // document.title = getParam.appName;
        
        //初始化返回事件
        initBack();
    
        cmp.i18n.init(_edocPath+"/i18n/", "Collaboration", function() {
            cmp.require(['ui-nav','ui-paging','ui-function-list','ui-error-view'], function() {
                initPage();
            });
        },$verstion);
        
    });
    
    function initPage(){
        new groupSearch();
    }
        
    function groupSearch(){
        this.initMain();
    }
    
    groupSearch.prototype = {
    
        initDom:function(){
            this.mainContainer = document.querySelector(".main-container"); //主容器-多个菜单
            this.headerContainer = document.querySelector(".headerContainer");//顶部导航
            this.searchContainer = document.querySelector(".cmp-segmented_title_content");//搜索容器
            this.menuContainer = document.querySelector(".menu-container");//页签容器
            this.listContent = document.querySelector("#searchList-content");//列表容器
            this.searchSidebar = document.querySelector("#search-sidebar"); // 搜索弹窗容器
            this.searchInput = this.searchContainer.querySelector("#searchInput"); //搜索文本框

            this.searchState = false; //是否搜索过的状态-默认未搜索
        },
        refreshDom:function(){
            var _this = this;
            var bodyHeight = document.body.offsetHeight;
            var headerNavH = _this.headerContainer.offsetHeight;
            var searchH = _this.searchContainer.offsetHeight;
            var menuNavH = _this.menuContainer.offsetHeight;
            var height = bodyHeight - headerNavH - searchH - menuNavH;
            _this.listContent.style.height = height + "px";
        },
        //总入口
        initMain:function(){
            var _this = this;
            this.initDom();
            // cmp.dialog.loading();
            _this.selector = document.querySelector("#searchList-content");
            _this.target = $cmp(_this.selector);
            var params = {
                subject:"",  //标题
                startMemberName:"", //发起人 -暂无此搜索
                sDate:"", //开始时间  -暂无此搜索
                eDate:"", //结束时间  -暂无此搜索
                edocType:"997",
                listType:"listPending"
            }
            _this.initNav();
            // _this.initData(params);
            _this.initEvent();
            // 2020.11.24 隐藏筛选
            //this.initSearchSideBar();
        },
            //初始化页签
        initNav:function (data){
            var _this = this;
            var dataArray= [
                {
                    text:"发文",
                    id:"allPendingTab",
                    data:{
                        edocType:"997",
                        listType:"listPending"
                    }
                },{
                    text:"收文",
                    id:"doneTab",
                    data:{
                        edocType:"999",
                        listType:"listDoneAll"
                    }
                },{
                    text:"传阅件",
                    id:"doingTab",
                    data:{
                        edocType:"998",
                        listType:"listPass"
                    }
                }
            ]
            //参数列表：
            var _options = {
                type:"default",
                data:dataArray,
                callback:navCallback
            };
            function navCallback(res,self){
                if(!_this.searchState){ //如果未搜索过-点击页签默认不再请求数据
                    return;
                }
                cmp.dialog.loading();
                var params = {
                    subject:_this.searchInput.value,
                    startMemberName:"",
                    sDate:"",
                    eDate:"",
                    edocType:res.data.edocType,
                    listType:res.data.listType
                }
                _this.initData(params);
            }
            if(_this.cmpNav){
                _this.cmpNav.initData(dataArray);
            }else{
                _this.cmpNav = new cmp.ui.nav(".menu-navContent",_options);
            }
            _this.refreshDom();
            
        },
            
            
        //列表数据------------------------------start
        //初始化样式
        initStyle: function() {
            //容器初始化
            this.target.append('  <div class="cmp-listview-scroll cmp-p-bg">\
                                    <ul class="cmp-listview-content cmp-p-bg"></ul>\
                                    <div class="cmp-listview-bottom"></div>\
                                </div>');
            //内容节点
            this.contentEl = this.target.find('.cmp-listview-content');
        },
        //初始化滚动条
        initScroll: function() {
            var _this = this;
            // this.placeholder.destroy();
            this.initStyle();
            this.scroll = new cmp.ui.paging(this.selector, {
                listviewType: 'simple-paging',
                pageSize: 30,
                nextHandle: function(pageNum) { //下一页
                    var navData = _this.cmpNav.getIndex().data.data;
                    var params = {
                        pageNum:pageNum,
                        subject:"",
                        edocType:navData.edocType,
                        listType:navData.listType
                    }
                    _this.nextHandle(params);
                },
                refreshHandle: function() { //刷新
                    var navData = _this.cmpNav.getIndex().data.data;
                    var params = {
                        subject:_this.searchInput.value,
                        edocType:navData.edocType,
                        listType:navData.listType
                    }
                    _this.initData(params);
                }
            });
        },
        //初始化数据
        initData: function(options) {
            var _this = this;
            this.getDataListCb({
                pageNum: 1,
                _options:options,
                success: function(result) {
                    cmp.dialog.loading(false);
                    if(result.data){
                        if(result.data.data){
                            result.data = result.data.data;
                        }
                    }else{
                        result.data = [];
                    }
                    !_this.scroll && _this.initScroll();
                    //引用断裂
                    listData = cmp.util.clone(result.data);
                    _this.list = listData;
                    _this.render(listData, 'refresh', 1);
                    _this.scroll.refresh({
                        dataLength: listData.length,
                        top:0
                    });
                    _this.refreshDom();
                    //无内容异常处理
                    if (listData.length !== 0) {
                        _this.errorView && _this.errorView.destroy();
                    } else {
                        //无内容
                        _this.initErrorView('5001', function() {
                            var params = {
                                subject:_this.searchInput.value,
                                edocType:"997",
                                listType:"listPending"
                            }
                            _this.initData(params);
                        });
                    }
                    
                },
    
                error: function(e) {
                    cmp.dialog.loading(false);
                    e = e || {};
                    _this.refreshDom();
                    //异常处理
                    _this.initErrorView(e.code, function() {
                        var params = {
                            subject:_this.searchInput.value,
                            edocType:"997",
                            listType:"listPending"
                        }
                        _this.initData(params);
                    });
                }
            });
        },
        nextHandle: function(options) {
            var _this = this;
            this.getDataListCb({
                pageNum: options.pageNum,
                _options:options,
                success: function(result) {
                    if(result.data){
                        if(result.data.data){
                            result.data = result.data.data;
                        }
                    }else{
                        result.data = [];
                    }
                    _this.errorView && _this.errorView.destroy();
                    //引用断裂
                    listData = cmp.util.clone(result.data);
                    _this.render(listData, 'append', options.pageNum);
                    _this.scroll.refresh({
                        dataLength: listData.length
                    });
                },
                error: function() {
                    _this.initErrorView(function() {
                        _this.nextHandle(pageNum);
                    });
                }
            });
        },
        // 查询列表数据
        getDataListCb:function(options){
            var _this = this;
            var cmpNavItem = _this.cmpNav.getIndex().data.data;
            var listPass = cmpNavItem.listType == "listPass"; //获取传阅件数据
            var params = {
                pageNo:options.pageNum,//获取第几页数据
                pageSize:options.pageSize || 30,///每页条数
                subject:options._options.subject
            }
            if(listPass){ //传阅件数据
                params.condition = "1";
                params.listType = "listDone";
            }else{ //收文-发文数据
                var govdocType = "";
                if(options._options.listType == "listPending"){
                    govdocType = "1";
                }else if(options._options.listType == "listDoneAll"){
                    govdocType = "2";
                }
                params.govdocType = govdocType;
            }
            $s.PetroChinaApi[listPass ? "findPassReadList" : "getCtpAffairByPartCondition"]( //getSummaryListByEdocTypeAndListType
                {}, params , {
                success : function(result) {
                    options.success && options.success(result);
                },
                error : function(result){
                    console.log(result);
                }
            });
        },
        render: function(data, type, pageNum , config) {
            var _this = this,str = '';
            var navData = _this.cmpNav.getIndex().data.data;
            var listPass = navData.listType == "listPass";
            for (var i = 0;i < data.length;i++) {
                var item = data[ i ];
                str += '<li id="'+(item._id ||'')+'" itemData="'+JSON.stringify(item).escapeHTML()+'" class="cmp-flex-h cmp-comment-item cmp-white-bg cmp-after-line">'+
                            ' '+this.renderContent(item ,listPass)+' '+
                            ' '+ this.renderCustom(item , listPass)  +' '+
                        '</li>';
            }
            if (type === 'refresh') {
                this.contentEl.html(str);
                // this.list = data;
                // pageNum !== 1 && (this.classifyId = null);
            } else if (type === 'append'){
                this.contentEl.append(str);
                // this.list = this.list.concat(data);
            }
        },
        renderContent:function(item,listPass){
            var self = this;
            var str = '';
            str += self.renderLeft(item,listPass);
            str += self.renderCenter(item,listPass);
            return str;
        },
        //渲染左边区域
        renderLeft:function(item,listPass){
            var startUserId;
            if(!listPass){
                startUserId = item.summary && item.summary.id;
            }else{
                startUserId = item.summary ? item.summary.startUserId : item.startUserId;
            }
            var fileTypeName = "",
                edocType = "";
            if(item.summary){
                fileTypeName = item.summary.fileTypeName || "";
                edocType = item.summary.edocType;
            }else if(item.fileTypeName){
                fileTypeName = item.fileTypeName || "";
            }
            fileTypeName = _convertFileTypeName(fileTypeName,edocType)
            // var url = cmp.util.getSeeyonPath() + "/rest/orgMember/avatar/" + ( startUserId || "" ) + '?maxWidth=100';
            // var url = item.url ? item.url.escapeHTML() :"http://com.seeyon.cmp/v/img/def-header.png";
            return '<div class="cmp-comment-left cmp-liactive-bgc cmp-flex-h cmp-y-center cmp-x-center">'+ (fileTypeName) +'</div>';
        },
        //渲染中间区域，包括评论内容
        renderCenter:function(item,listPass){
            var self = this;
            if(!item)return;
            // var isAttachments = item.summary.hasAttachments; //是否有附件
            // var attHtml = isAttachments ? '<span class="isAttachment see-icon-accessory"></span>':'';
            var index = item.summary ? item.summary.urgentLevel : item.urgentLevel,classTheme="";
            if(index == "2"){
                classTheme = "cmp-theme-fc";
            }else if(index == "3" || index == "4"){
                classTheme = "cmp-hl-fc2";
            }else if(index == "5"){
                classTheme = "cmp-hl-fc3";
            }
            var getShowTime = item.createDateShow || self.getShowTime(item.createDate || item.createTime);
            // var urgent = item.summary.urgentLevel ? '<span class="see-icon-v5-common-important-' + (index-1) +'  ' + classTheme +' "></span>' : ""; //定义紧急程度
            var person = item.preApprover?(item.preApprover+"提交"):(item.createPerson+"发起");
            var str = '';

            //重新定义下数据
            var topText = (item.summary ? item.summary.subject : item.subject).escapeHTML(), //标题
                centerLeftText = item.nodePolicy || "",
                centerText = item.summary?item.summary.zsyFileType:"",
                centerRightText = person,
                bottomText = getShowTime;
                
            str +='<div class="cmp-flex-1 cmp-comment-center">'+
                '<div class="cmp-comment-content">'+
                    '<div class="title cmp-f-6 cmp-main-fc cmp-textover-2">' + topText +'</div>';
            if(!listPass){ //如果不是传阅件
                str +='<div class="userInfo cmp-f-4 cmp-sup-fc1">'+
                         '<span class="org-name">'+ centerLeftText +'</span>';
                         if(centerText){
                            str += '<span class="user-name"><span class="line">|</span>'+ centerText +'</span>';
                         }
                         if(centerRightText){
                            str += '<span class="user-name"><span class="line">|</span>'+ centerRightText +'</span>';
                         }
                str += '</div>';
            }
            str +='<div class="addressInfo cmp-f-4 cmp-sup-fc1">'+ bottomText +'</div>';
            str +='</div>'+
            '</div>';
            return str;
        },
        renderCustom:function(item,listPass){
            var str = '';
            var level = item.summary ? item.summary.urgentLevel : item.urgentLevel,text="",_text="",className="";
            if(level == "4" || level == "特急"){
                className = "4";
                _text = "特急";
            }else if(level == "5" || level == "紧急"){
                className = "5";
                _text = "紧急";
            }else{
                level = null;
            }
            if(level){
                text = '<span class="text">'+ _text +'</span>';
            }
            if(listPass){
                className +=" listPass";
                text = '<span class="see-icon-v5-common-more-fill text"></span>';
            }
            str += '<div class="urgentLevel urgentLevel-'+ className +' ">'+ text +'</div>';
            return (!level && !listPass) ? "":str;
        },
        initErrorView: function(code, callback) {
            var _this = this,
                obj = this.errorView;
            obj && obj.destroy();
            this.errorView = new cmp.ui.errorView(this.selector, {
                code: code,
                showPosition: _this.list && _this.list.length > 0 ? 'top' : 'center',
                callback: callback
            })
        },
        //列表数据------------------------------end
         
        initEvent:function(){
            var _this = this;
            var searchInput = _this.searchContainer.querySelector("#searchInput");
            var searchTitleCancel = document.querySelector(".search-title-cancel");//搜索取消按钮
            var searchTitleHead = document.querySelector(".cmp-content-title-search");
            //点击列表穿透事件
            _this.target.on('tap', 'li.cmp-comment-item', function(event){
                var target = event.target;
                var itemData = JSON.parse($cmp(this).attr("itemData"));
                var openFrom = "";
                
                if(target.classList.contains("urgentLevel") || target.classList.contains("text")){
                    //传阅件-点击更多
                    if(target.classList.contains("listPass") || target.parentNode.classList.contains("listPass")){
                        _this.openActionSheet(itemData.summaryId,itemData.subject);
                    }
                    return;
                }
                

                // 传阅件-跳转
                // if(_this.cmpNav.getIndex().data.id === "doingTab") {
                //     //
                //     var summaryId = itemData.summaryId || itemData.id;
                //     var summaryName = itemData.subject;
                //     const url = "/html/edocCirculation.html?summaryId=" + summaryId + "&summaryName=" + summaryName;
                //     cmp.href.next(_edocPath + url);
                // }

                var openFrom = "";
                if (itemData.affairState == "3") {
                    if (itemData.subState == "13" || itemData.subState == "19") {
                        openFrom = "listPass";
                    } else {
                        openFrom = "listPending";
                    }
                } else if (itemData.affairState == "2") {
                    openFrom = "listSent";
                } else if (itemData.affairState == "1") {
                    openFrom = "listWaitSend";
                } else {
                    openFrom = "listDoneAll";
                }
                var params = {
                    "openFrom": openFrom,
                    "isGrab": itemData.affair ? itemData.affair.isGrab : itemData.isGrab
                };
                if(itemData.affairId){
                    params["affairId"] = itemData.affairId;
                }else{ //收文登记簿/发文登记簿/签报登记簿-与后端对接说是这三种情况下affairId必为null,就赋值另外的参数
                    params["affairId"] = "-1";
                    params["summaryId"] = itemData.summary.summaryId;
                    params["openFrom"] = "glwd";
                }
                // 打开详情页
                edocApi.openSummary(params);
    
            });
            //点击搜索
            $(searchInput).on("focus",function(){
                searchTitleHead.classList.add("active");
            });
            $(searchInput).on("blur",function(){
                searchTitleHead.classList.remove("active");
            });
            $(searchInput).on("keyup",function(e){
                if(e.keyCode == 13){
                    _this.searchState = true;//执行过搜索
                    var navData = _this.cmpNav.getIndex().data.data;
                    var params = {
                        subject:this.value,
                        edocType:navData.edocType,
                        listType:navData.listType
                    }
                    _this.initData(params);
                    setTimeout(function(){
                        $(searchInput).blur();
                    },0);
                }
            });

            searchTitleCancel.addEventListener("tap",function(){
                _this.searchInput.value = "";
                searchTitleHead.classList.remove("active");
                var navData = _this.cmpNav.getIndex().data.data;
                var params = {
                    subject:"",
                    edocType:navData.edocType,
                    listType:navData.listType
                }
                _this.initData(params);
            },false);
            
            $("#goAheadBtn").on("tap",function(){
                cmp.href.back();
            });
            
        },
        //执行列表中-点击更多事件弹出底部选择正文或附件
        openActionSheet :function(summaryId,summaryName){
            var _this = this;
            var params = {
                summaryId:summaryId
            };
            cmp.dialog.loading();
            $s.PetroChinaApi.getAttAndContentFromPassReadSummary({},params,{
                success:function(result){
                    cmp.dialog.loading(false);
                    var onlineContentEnable = result.onlineContentEnable;
                    var contentData = result.contentData, //正文
                        attData = result.attData; //附件数据
                    var items = [{
                        key: "contentData",
                        data: JSON.stringify(contentData).escapeHTML(),
                        name: "正文",
                        name2: "",
                        onlineContentEnable:onlineContentEnable
                    }];
                    attData && attData.length > 0 && $(attData).each(function(i,attItem){
                        items.push({
                            key: "attData",
                            data: JSON.stringify(attItem).escapeHTML(),
                            name: "附件:" + attItem.filename,
                            name2: "",
                            onlineContentEnable:onlineContentEnable
                        });
                    });
                    var detailData = {"summaryId":summaryId,"summaryName":summaryName};
                    items.push({
                        key:"detailData",
                        data: JSON.stringify(detailData).escapeHTML(),
                        name:"传阅详情",
                        name2:"",
                        onlineContentEnable:onlineContentEnable

                    })
                    var _items = [{
                        groupName: "",
                        type: "text",
                        items: items
                    }];
                    cmp.dialog.groupSheet( _items, null, function (res) {
                        var data = JSON.parse(res.data);
                        if(res.key == "contentData"){ //查看正文
                            data.onlineContentEnable = onlineContentEnable;
                            _this.showContent(data);
                        }else if(res.key == "detailData"){//查看传阅详情
                            var summaryId = data.summaryId || itemData.id;
                            var summaryName = data.summaryName;
                            const url = "/html/edocCirculation.html?summaryId=" + summaryId + "&summaryName=" + summaryName;
                            cmp.href.next(_edocPath + url);
                        }else{ //查看附件
                            var filename = encodeURIComponent(data.filename);
                            cmp.att.read({
                              path:cmp.util.getSeeyonPath() + "/rest/attachment/file/" + data.fileUrl,//文件的服务器地址
                              filename:filename,//附件名称
                                fileId:data.fileUrl,
                                createDate:data.createdate,
                                v:data.v,
                              edit:false,  //是否可以进行修改编辑
                              officeTransformEnable:onlineContentEnable,
                              extData:{
                                  fileId: data.fileId,
                                  lastModified: data.lastModified,
                                  origin: 'xxx'
                              },
                              success:function(ret){
                                  console.log(ret);
                              },
                              error:function(error){
                                  console.log(error);
                              }
                          });
                        }
                    });
                },error:function(res){
                    console.log(res);
                    cmp.dialog.loading(false);
                }
            });
        },
        //加载正文
        showContent : function (contentData){
            var content = contentData;
            var content1bodyType = content["contentType"];
            if (content1bodyType != "10") { //SeeyonContent.getBodyCode("HTML")
                var suffixMap = {
                    "wps": "doc",
                    "et": "xls"
                }
                var subfix;
                if (46 == content1bodyType) {//ofd正文
                    subfix = "ofd";
                } else {
                    var WORD_BODY_TYPES = {
                        "10" : "HTML",
                        "20" : "form",
                        "30" : "txt",
                        "41" : "doc",
                        "42" : "xls",
                        "43" : "wps",
                        "44" : "et",
                        "45" : "pdf",
                        "90" : "third"
                    }
                    subfix = WORD_BODY_TYPES[content1bodyType];//SeeyonContent.getBodyType(content1bodyType)
                }
                var newFileName = "";
                var newSuffix = suffixMap[subfix] || subfix;
                if (46 == content1bodyType) {//微协同还是不支持ofd
                    cmp.notification.alert("暂不支持OFD正文");
                    return;
                }
                var srcFileName = newFileName || ("正文." + newSuffix);
                var fileName = srcFileName;
                fileName = encodeURIComponent(fileName);
                var downFilePath = cmp.origin + "/rest/attachment/file/" + content.content + "?fileName=" + fileName;
                //使用瑞飞提供的原生接口
                cmp.att.read({
                    fileId:content.content,
                    filename:fileName
                })
                return ;
                //如果文档类型支持在线转换且开启了在线转换服务
                if (cmp.att.isSupportReadOnline(newSuffix) && content.onlineContentEnable== "enable" ) {
      
                    $s.PetroChinaApi.getContentV(content.content, {
                        success : function(ret) {
                            cmp.dialog.loading(false);
                            var v =ret.data;
                            cmp.att.readOnline({
                                "fileUrl": content.content, // 文件fileUrl，必填
                                "filename": srcFileName,  // 必填
                                // 平台要求将createDate传入文件最新的修改时间
                                "createDate": content.createDate,   // 必填
                                "lastModifyDate": content.modifyDate,   // 必填，文件最后修改时间，用于缓冲管理
                                "v":v,
                                "success": function () {
                                    return;
                                },
                                "error": function () {
                                    return;
                                }
                            });
                        },
                        error: function(result){
                            cmp.dialog.loading(false);
                        }
                    });
      
                } else {
                    if (cmp.att.canDownload4Wechat(newSuffix)) {
                        cmp.att.download({"url": downFilePath, "title": srcFileName});
                    } else {
                        cmp.notification.toast(cmp.i18n("commons.note.notsuport3"), 'top', 1000);
                    }
                }
            }else{
                cmp.notification.toast("不支持查看!");
            }
        },
        initSearch:function(){
            var _this = this;
            //标题、发起人、发起时间
            var searchObj = [{ id: "subject", type: "text", condition: cmp.i18n("Edoc.title.title"), text: cmp.i18n("Edoc.title.title"), defValue: "" },
                { id: "startMemberName", type: "text", condition: cmp.i18n("Edoc.title.sender"), text: cmp.i18n("Edoc.title.sender"), defValue: "" },
                { id: "createDate", type: "date", condition: cmp.i18n("Edoc.title.createTime"), text: cmp.i18n("Edoc.title.createTime"), defValue: "" }];
    
            cmp.groupSearch.init({
                items: searchObj,
                model: {
                name: "edoc",
                    id: "1041"
                },
                appId:"4",
                H5Header: false,
                openSearchResult: false,//是否打开存放搜索结果的容器
                callback: function (result) {
                    var resData = result.result;
                    var indexNavData = _this.cmpNav.getIndex();
                    var params = {
                        subject:_this.searchInput.value,
                        startMemberName:"",
                        sDate:"",
                        eDate:"",
                        edocType:indexNavData.data.data.edocType,
                        listType:indexNavData.data.data.listType
                    }
                    $(resData).each(function(i,index){
                        if(params[index.id] == ""){
                            params[index.id] = index.value;
                        }
                    });
                    _this.initData(params);
                },
                closeCallback: function () { }
            });
        },
        // search-sidebar ------------------------------------- start
    
        initSearchSideBar: function(){
            const index = cmp.zIndex.get() + 2;
            $("#search-sidebar").css('z-index', index).show();
            const data = [
                {
                    name: '密级',
                    level: 3
                },
                {
                    name: '密级',
                    level: 3
                },
                {
                    name: '密级',
                    level: 3
                }
            ];
            this.renderSecretLevel(data);
            this.renderFileType(data);
            this.renderFileLevel(data)
    
    
            this.iniSearchSidevarEvent();
        },
    
        // 渲染密级内容
        renderSecretLevel: function(data) {
            let html = "";
            if(data && data.length) {
                data.forEach(item => {
                    html += `<div class="search-sidebar-check-ele">${item.name}`;
                    while(item && item.level--){
                        html += `<span class="cmp-icon see-icon-collect-fill">*</span>`;
                    }
                    html += `</div>`;
                });
            }
            $("#secret-level").html(html);
        },
        // 渲染文件类型
        renderFileType: function(data) {
            let html = "";
            if(data && data.length) {
                data.forEach(item => {
                    html += `<div class="search-sidebar-check-ele">${item.name}</div>`;
                });
            }
            $("#file-type").html(html);
        },
        // 渲染文件
        renderFileLevel: function(data) {
            let html = "";
            if(data && data.length) {
                data.forEach(item => {
                    html += `<div class="search-sidebar-check-ele">${item.name}</div>`;
                });
            }
            $("#file-level").html(html);
        },
    
        iniSearchSidevarEvent() {
            $('.search-sidebar-check-ele').on('click', function () {
                let className = $(this).attr('class');
                if (className.indexOf(' checked') > -1) {
                    className = className.replace(' checked', '');
                } else {
                    className += ' checked';
                }
                $(this).attr('class', className);
            });
        },
        //前端格式化时间
        getShowTime : function(inputTimestamp){
            if(isNaN(inputTimestamp)){
                inputTimestamp.replace(/-/g,"\/");
                inputTimestamp = new Date(inputTimestamp).getTime();
            }
            var oneYearTimestamp = 365 * 24 * 60*60*1000;//1年
            var todayTimestamp = 24*60*60*1000;//今天的整个时间戳长度
            var oneHour = 60*60*1000;//1小时
            var twoHour = 2*60*60*1000;//2小时
            var threeHour = 3*60*60*1000;//3小时
            var fiveMinute = 5*60*1000;//5分钟
            var inputDate = new Date(parseInt(inputTimestamp));//输入的日期
            var currentTimestamp = new Date().getTime();
            var ret = "";
            var timeDiff = currentTimestamp - inputTimestamp;
            var ymdhm = this.getYMDHMByDate(inputDate);
            if(timeDiff <= fiveMinute){
                ret = "刚刚";
            }else if(timeDiff<=  oneHour){
                var diffMunite = Math.floor(timeDiff/(60*1000));
                ret = diffMunite + "分钟前";
            }else if(timeDiff <= twoHour){
                ret = "1小时前";
            }else if(timeDiff <= threeHour){
                ret = "2小时前";
            }else if(timeDiff < todayTimestamp){

                var inputD = ymdhm[2];
                var currentD = new Date().getDate();
                var oneDayDescreption = "今天";
                if(inputD != currentD){
                    oneDayDescreption = "昨天"
                }

                ret = oneDayDescreption+ymdhm[3] + "时" + ymdhm[4] + "分";
            }else if(timeDiff <= oneYearTimestamp){
                ret = ymdhm[1] + "-" + ymdhm[2] + " " + ymdhm[3] + ":" + ymdhm[4];
            }else {
                ret = ymdhm[0] + "-" + ymdhm[1] + "-" + ymdhm[2] + " " + ymdhm[3] + ":" + ymdhm[4];
            }
            return ret;
        },
        getYMDHMByDate : function(date){
            var year = date.getFullYear(),
                month = this.handleNum(date.getMonth() + 1),
                dates = this.handleNum(date.getDate()),
                hour = this.handleNum(date.getHours()),
                minute = this.handleNum(date.getMinutes());
            return [year,month,dates,hour,minute];
        },
        handleNum : function(num){
            if(num < 10){
                num = "0" + num;
            }
            return num;
        },
        // search-sidebar ------------------------------------- end
    
    }

    /**
     * 转换文件类型的显示文字
     * @param zsyFileType：后台传的文件类型名字
     * @param edocType 公文类型（0：发文；1：收文）
     * @private
     */
    function _convertFileTypeName(fileTypeName,edocType){
        var ret = "";
        if(fileTypeName.indexOf("党群") != -1){
            ret = "党群";
        }else if(fileTypeName.indexOf("公司") != -1){
            if(edocType == 1){//收文的情况
                ret = "公司收文";
            }else {
                ret = "公司";
            }
        }else if(fileTypeName.indexOf("部门") != -1){
            if(edocType == 1){//收文的情况
                ret = "部门收文";
            }else {
                ret = "部门";
            }
        }else if(fileTypeName.indexOf("专用") != -1){
            ret = "专用";
        }else if(fileTypeName.indexOf("呈批件") != -1){
            ret = "呈";
        }else {
            ret = "其他";
        }
        return ret;
    }
    
    function initBack(){
        cmp.backbutton();
        cmp.backbutton.push(cmp.href.back);
    }
    
    })();
    
    