let selectedPeople;



function edocSelectPeople(opts) {
    
    this.init(opts);
}

edocSelectPeople.prototype = {
    init:function(opts){
        window.edocSelectPeople = this;
        this.opts = opts;
        initSelectPeopleBack(opts);
        selectedPeople = (opts && opts.selected) || [];
        initSelectPeopleDom();
        getSelectPeopleData();
        initEvent(opts);
    },
    fireClose:function(){
        cmp.backbutton.pop();
        $('#select-people-dialog').remove();
        this.opts.cancelCallback && this.opts.cancelCallback();
    }
}

// 初始化返回按钮
function initSelectPeopleBack(opts) {
    cmp.backbutton();
    cmp.backbutton.push(function () {
        $('#select-people-dialog').remove();
        opts.cancelCallback && opts.cancelCallback();
    });
}
// 初始化dom
function initSelectPeopleDom(opts) {
    const selectPeopleValue = (opts && opts.value) || [];
    const selectPeopleLen = selectPeopleValue.length;
    const html = `
    <div class="select-people-wrap">
    <div class="cmp-input-row cmp-search select-people-input">
        <span id="select_people_placeholder" class="cmp-placeholder text-align-left" >
			<span class="cmp-icon cmp-icon-search"></span>
			<span class="text-search">搜索</span>
		</span>
        <input id="select_people_input" type="search" class="cmp-input-clear" placeholder="" onblur="getSelectPeopleData">
	</div>
    <div id="select_people_tree" class="select-people-tree"></div>
    </div>
    <div class="select-people-bottom">
    <div class="select-people-bottom-label">已选<span id="select_people_num">${selectPeopleLen}</span>人</div>
    <button type="button" class="cmp-btn cmp-btn-primary select-people-submit" id="btn_submit">提交</button>
    </div>
    </div>
    </div>`;
    const selectPeopleDialog = document.createElement('div');
    selectPeopleDialog.id = 'select-people-dialog';
    selectPeopleDialog.className =
        'select-people-dialog Animated-Container left-go cmp-active';
    const index = cmp.zIndex.get() + 2;
    const windowHeight = window.document.body.offsetHeight;
    const headerHeight = document.querySelector("#page_header").offsetHeight;
    selectPeopleDialog.style.cssText = 'z-index:'+ index +';top:'+ headerHeight +'px;height:'+(windowHeight - headerHeight)+'px; ';
    selectPeopleDialog.innerHTML = html;
    document.body.appendChild(selectPeopleDialog);
}

// 获取人员数据
function getSelectPeopleData() {
    const inputValue = $('select_people_input').val();
    cmp.dialog.loading();
    // cmp.ajax({
    //     url: '/getList',
    //     type: 'POST',
    //     data: { searchValue: inputValue },
    //     success: function (ret) {
    //         cmp.dialog.loading(false);
    //         console.log(ret);
    //         initPeopleList(ret);
    //     },

    //     error: function (e) {
    //         cmp.dialog.loading(false);
    //         console.log(e);
    //     }
    // });
    cmp.dialog.loading(false);
    const ret = [
        {
            name: '1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111',
            children: [
                {
                    name: '1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                }
            ]
        },
        {
            name: '22',
            children: [
                {
                    name: '11'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                },
                {
                    name: '11'
                }
            ]
        }
    ];
    initPeopleList(ret);
}

function initPeopleList(data) {
    let html = '';
    if (data && data.length) {
        data.forEach(ele => {
            html += renderDepartmentList(ele);
        });
    }

    $('#select_people_tree').html(html);
}
function renderDepartmentList(dep) {
    const isChecked = isPeopleSelected(dep);
    let html = `<div class="select-people-dep">
    <div class="cmp-input-row cmp-checkbox cmp-left select-people-dep-item">
        <input name="checkbox" type="checkbox" checked=${isChecked}>
        <label class="select-people-dep-name">${dep.name}</label>
    </div>
    <div class="select-people-dep-icon-wrap">
        <div class="select-people-dep-icon"></div>
    </div>
    <div class="select-people-dep-children">`;
    if (dep.children && dep.children.length) {
        const children = dep.children;
        children.forEach(ele => {
            html += renderPeoppleList(ele);
        });
    }

    html += `</div></div>`;
    return html;
}

function renderPeoppleList(peo) {
    const isChecked = isPeopleSelected(peo);
    let html = `
    <div class="cmp-input-row cmp-checkbox cmp-left select-people-peo">
        <input name="checkbox" type="checkbox" checked=${isChecked}>
        <label class="select-people-peo-name">
        <span>icon</span>
        <span>${peo.name}</span>
        </label>
    </div>`;
    return html;
}

function isPeopleSelected(peo) {
    return selectedPeople && selectedPeople.includes(peo);
}

function initEvent(opts) {
    const callBack = opts && opts.callBack;
    // 点击搜索
    $('#select_people_placeholder').on('click', function () {
        $(this).hide();
    });
    // 点击选中， 取消
    $('input:checkbox').on('click', function () {
        const length = $('input:checkbox:checked').length;
        changeSelectPeopleNum(length);
    });
    //展开， 关闭子列表
    $('.select-people-dep-icon-wrap').on('click', function () {
        let className = $(this).attr('class');
        let childrenClassName = $(this).next().attr('class');
        if (className.indexOf(' close') > -1) {
            className = className.replace(' close', '');
            childrenClassName = childrenClassName.replace(' close', '');
        } else {
            className += ' close';
            childrenClassName += ' close';
        }
        $(this).attr('class', className);
        $(this).next().attr('class', childrenClassName);
    });
    // 提交
    $('#btn_submit').on('click', function () {
        console.log('ok');
        $('#select-people-dialog').remove();
        callBack && callBack(selectedPeople);
    });
}

// 改变选中数目
function changeSelectPeopleNum(num) {
    $('#select_people_num').text(num);
}
