(function (_, $) {
    
  var urlParam;

  var page = {};
  var refreshListview = false;

  var searchModelId = 1041;
  var pageX = {
    cacheKey: "m3_v5_edocList_cache_key",
    cacheData: {
      peivMenu: null,
      searchCondition: {}
    },
    loadAll: false
  };

  edocAllPendingKey = "997";
  edocAllDoneKey = "999";
  edocAllDoingKey = "998";
  edocAllDoneListType = "listDoneAll";
  edocAllDoingListType = "listZcdb";
  edocAllPendingListType = "listPending";

  var allPendingTab = "allPendingTab"; //待办
  var doneTab = "doneTab"; //已办
  var doingTab = "doingTab"; //在办
  var sendTab = "sendTab"; //发文管理
  var receiveTab = "receiveTab"; //收文管理
  var reportTab = "reportTab"; //签报管理

  //zsy
  edocAllPendingReadKey = "1100";
  edocAllDoneReadKey = "1101";
  edocAllStoreKey = "1102";

  edocAllPendingReadListType = "listPendingRead";
  edocAllDoneReadListType = "listDoneRead";
  edocAllStoreListType = "listStore";

  var pendingReadTab = "pendingReadTab"; //待阅
  var doneReadTab = "doneReadTab"; //已阅
  var storeTab = "storeTab"; //收藏


  var cmpNav = null;
  var cmpNavOptions = null;
  var businessListMap = {};
  /********************************** 初发化方法  ***********************************/
  cmp.ready(function () {
    cmp.header.customCMPHeader({
      backgroundColor: '#297FFB',
      textColor: '#ffffff',
      statusBarValue: 1
    });
    getPageReadyInfo();
    //初始化返回事件
    initPageBack();

    cmp.i18n.init(_edocPath + "/i18n/", "EdocResources", function () {
      //数据缓存机制，不用每次打开刷新页面
      initInStorage();

      cmpNavOptions = {
        data: [{
          id: allPendingTab,
          text: cmp.i18n('Edoc.label.allPending'),
          custom: {
            edocType: '997',
            href: '#allPending_'
          }
        }]
      };
      //从数据库中取数据
      initPageData();

      //初始化事件
      initEvent();
      _refreshHeight();
    }, $verstion);
    
    cmp.event.orientationChange(function (orientation) {
      if (orientation == "portrait") {
        //此时为竖屏
        // cmp.listView("#allPending").refreshHeight($("#allPending").height());
      } else {
        //此时为横屏
        // cmp.listView("#allPending").refreshHeight($("#allPending").height());
      }
    })

  });

  //zsy改造-动态高度
  function _refreshHeight(){
    var headerH = document.getElementById("edocHeader").offsetHeight;
    var footer = document.querySelector(".zsy-footer-collect");
    var footerH = !footer.classList.contains("cmp-hidden") ? footer.offsetHeight : 0;
    var height = document.body.offsetHeight - headerH - footerH - 104;
    $("#dataCommonDiv").height(height);
  }

  function getPageReadyInfo() {
    urlParam = cmp.href.getParam() || {};
    if (urlParam.openFrom == "edocListDone") {
      cmp.storage.delete(pageX.cacheKey, true); //首页跳转已办过来，清空缓存，不然页签切换不正确
      pageX.cacheData.edocType = edocAllDoneKey;
    } else if (urlParam.openFrom == "edocListDoing") {
      cmp.storage.delete(pageX.cacheKey, true);
      pageX.cacheData.edocType = edocAllDoingKey;
    } else {
      pageX.cacheData.edocType = urlParam.edocType || "";
    }
    var urlListType = EdocUtils.getHrefParam("listType");
    if (urlListType) {
      if (urlListType == "send") {
        pageX.cacheData.edocType = "0";
      } else if (urlListType == "receive") {
        pageX.cacheData.edocType = "1";
      } else if (urlListType == "report") {
        pageX.cacheData.edocType = "2";
      } else if (urlListType == "allDone" || urlListType == edocAllDoneListType) {
        cmp.storage.delete(pageX.cacheKey, true); //首页跳转已办过来，清空缓存，不然页签切换不正确
        pageX.cacheData.edocType = edocAllDoneKey;
      } else if (urlListType == "allDoing" || urlListType == "listDoneRoot") {
        cmp.storage.delete(pageX.cacheKey, true);
        pageX.cacheData.edocType = edocAllDoingKey;
      }
    }

    pageX.cacheData.searchCondition = urlParam.searchCondition || {};
  }

  /****************************** 监听返回事件(放到最前头)  ******************************/

  function initPageBack() {

    //监听点击设备的回退事件
    cmp.backbutton();
    if (EdocUtils.isFromM3NavBar()) {
      cmp.backbutton.push(cmp.closeM3App);
    } else {
      cmp.backbutton.push(_goBack);
    }
    //zsy-添加H5导航栏返回按钮事件
    cmp("header").on('tap', "#goBackBtn", _goBack);
    cmp("header").on('tap', "#menus", _goBack);
  }

  function _goBack() {

    if (EdocUtils.getBackURL() == "weixin") {
      //返回到外层, 微信入口逻辑，因为微信没办法返回到首页，所以这样处理， 暂时不要和else分支合并
      cmp.href.closePage();
    } else {
      //返回到外层
      cmp.href.back();
    }
  }

  /********************************** 页签定位  ***********************************/
  function getDefaultIndexTo() {
    var defaultIndexTo = allPendingTab;
    if (pageX.cacheData.edocType == edocAllDoneKey) { //已办
      defaultIndexTo = doneTab;
    } else if (pageX.cacheData.edocType == edocAllDoingKey) { //在办
      defaultIndexTo = doingTab;
    } else if (pageX.cacheData.edocType == '0') {
      defaultIndexTo = sendTab;
    } else if (pageX.cacheData.edocType == '1') {
      defaultIndexTo = receiveTab;
    } else if (pageX.cacheData.edocType == '2') {
      defaultIndexTo = reportTab;
    }
    return defaultIndexTo;
  }


  /********************************** 缓存操作  ***********************************/

  function initInStorage() {
    var cacheData = cmp.storage.get(pageX.cacheKey, true);
    if (cacheData) {
      pageX.cacheData = JSON.parse(cacheData);
      cmp.storage.delete(pageX.cacheKey, true);
    } else {
      pageX.cacheData.edocType = edocAllPendingKey; //zsy，初始化显示待办列表
    }
  }

  //存储状态数据
  function _M3_Save_Storage() {
    cmp.storage.save(pageX.cacheKey, JSON.stringify(pageX.cacheData), true);
  }

  /********************************** 页面数据初始化  ***********************************/

  function initPageData() {
    // initEdocTypeCount();
    //注册缓加载
    _registLazy();
    //启动懒加载
    LazyUtil.startLazy();

    if (!pageX.cacheData.peivMenu || true) {

      cmp.dialog.loading();
      $s.EdocResource.initEdocListParams({}, {
        pageNo: 1,
        pageSize: 10000
      }, {
        success: function (result) {
          cmp.dialog.loading(false);
          //M3端公文管理增加已办和在办页签,不在rest接口中增加免得影响pc端
          var aResult = {
            haveEdocDone: true,
            haveEdocDoing: true
          }
          var _result = $.extend(result.data, aResult);
          //end
          pageX.cacheData.peivMenu = _result;
          _initPervMenu(pageX.cacheData.peivMenu);
        },
        error: function (result) {
          cmp.dialog.loading(false);
          EdocUtils.ajaxErrorHander(result);
        }
      });
    } else {
      _initPervMenu(pageX.cacheData.peivMenu);
    }
  }

  function _initPervMenu(result) {
    if (result) {
      _edocUserPeivMenu(result);
      var d_options = JSON.parse(JSON.stringify(cmpNavOptions));
      d_options.callback = function (res) { //所有事件回调，包括编辑按钮事件
        pageNavTabEvent(res);
      };

      if (pageX.cacheData.edocType == edocAllDoneKey) { //已办
        d_options.defaultIndexTo = doneTab;
      } else if (pageX.cacheData.edocType == edocAllDoingKey) { //在办
        d_options.defaultIndexTo = doingTab;
      } else if (pageX.cacheData.edocType == edocAllPendingKey) { //待办
        d_options.defaultIndexTo = allPendingTab;
      }
      //zsystart=========//
      else if (pageX.cacheData.edocType == edocAllPendingReadKey) { //待阅
        d_options.defaultIndexTo = pendingReadTab;
      } else if (pageX.cacheData.edocType == edocAllDoneReadKey) { //已阅
        d_options.defaultIndexTo = doneReadTab;
      } else if (pageX.cacheData.edocType == edocAllStoreKey) { //收藏
        d_options.defaultIndexTo = storeTab;
      }

      //zsyend========//

      cmp.require(['ui-nav', 'ui-business-list'], function () {
        cmpNav = new cmp.ui.nav("#page-nav-warp", d_options);
        var passReadedListCount = result.passReadedListCount;
        if(passReadedListCount && passReadedListCount != "0"){
            renderUnreadDom("pendingRead");
        }
        initHtml();
        // initEdocTypeCount();
      });

    } else {
      _alert(cmp.i18n("Edoc.exception.noPermissionException"));
    }
  }

  /**
   * 注册缓加载
   */
  function _registLazy() {
    //注册缓加载
    LazyUtil.addLazyStack({
      "code": "lazy_load",
      "css": [
        _cmpPath + "/css/cmp-picker.css" + $verstion,
        _cmpPath + "/css/cmp-search.css" + $verstion,
        _cmpPath + "/css/cmp-dateCalender.css" + $verstion,
      ],
      "js": [
        _cmpPath + "/js/cmp-picker.js" + $verstion,
        _cmpPath + "/js/cmp-dtPicker.js" + $verstion,
        _cmpPath + "/js/cmp-search.js" + $verstion,
        _cmpPath + "/js/cmp-groupSearch.js" + $verstion,
        _cmpPath + "/js/cmp-dtPicker-calender.js" + $verstion,
        _cmpPath + "/js/cmp-dateCalender.js" + $verstion,
      ]
    });
  }

  function _edocUserPeivMenu(data) {
    if (data.haveEdocDone) { //已办
      cmpNavOptions.data.push({
        id: doneTab,
        text: cmp.i18n('Edoc.default.done'),
        custom: {
          edocType: '999',
          href: '#allDone_'
        }
      });
    }
    // if(data.haveEdocDoing){//在办
    //   cmpNavOptions.data.push({
    //     id: doingTab,
    //     text: cmp.i18n('Edoc.state.processing'),
    //     custom:{
    //       edocType: '998',
    //       href:'#allDoing_'
    //     }
    //   });
    // }

    //zsy
    //待阅
    cmpNavOptions.data.push({
      id: pendingReadTab,
      text: "待阅",
      custom: {
        edocType: edocAllPendingReadKey,
        href: '#pendingRead_'
      }
    });
    //已阅
    cmpNavOptions.data.push({
      id: doneReadTab,
      text: "已阅",
      custom: {
        edocType: edocAllDoneReadKey,
        href: '#doneRead_'
      }
    });
    //收藏
    cmpNavOptions.data.push({
      id: storeTab,
      text: "收藏",
      custom: {
        edocType: edocAllStoreKey,
        href: '#store_'
      }
    })


    if (data.haveEdocSend) { //发文管理
      $('#menu_send_item').removeClass('div-none')
    }
    if (data.haveEdocRec) { //收文管理
      $('#menu_receive_item').removeClass('div-none')

    }
    if (data.haveEdocSignReport) { //签报管理
      $('#menu_signandreport_item').removeClass('div-none')

    }
    if (data.haveAccountGovdocStat) { //公文统计
      $('#has_statistics_zone').removeClass('div-none');
      //      $s.EdocResource.listRegisterCount({},{pageNo:1,pageSize:10000},{
      //        success:function (res) {
      //          var data = res.data ||{};
      //        }
      //      })
      $('#has_statistics_zone .statistics-menu .statistics-num')[0].innerHTML = (data.sendRegisterCount || '-');
      $('#has_statistics_zone .statistics-menu .statistics-num')[1].innerHTML = (data.recRegisterCount || '-');
    }
  }

  function initEdocTypeCount() {
    $s.EdocResource.getListSizeByEdocType({}, {
      success: function (result) {
        renderEdocTypeData(result[0], "send");
        renderEdocTypeData(result[1], "receive");
        renderEdocTypeData(result[2], "report");

        initEvent_subList();
      },
      error: function (result) {
        EdocUtils.ajaxErrorHander(result);
      }
    });
  }

  /**
   * 填充发文、收文、签报的数量列表
   * @param result
   * @param replaceDiv
   */
  function renderEdocTypeData(result, replaceDiv) {
    var pendingTPL = $("#doc_type_tpl").html();
    var html = cmp.tpl(pendingTPL, result);
    $("#" + replaceDiv).html(html);
    cmp.IMG.detect();
  }

  //查询合并的已办和在办
  function getBusinessListItems(list,navItemId) {
    var items = [],isUnread = false;
    list.forEach(function (obj,i) {
        var urgentLevel = obj.summary.urgentLevel ? urgentLevelMapping[obj.summary.urgentLevel] : 0;
        if (obj.urgentLevel > 5) {
          urgentLevel = urgentLevelMapping[obj.summary.urgentLevel];
        }
        var firstIcon = '';
        if (urgentLevel == 4) {
            firstIcon = 'see-icon-v5-common-important-4 cmp-hl-fc3'
        } else if (urgentLevel == 3) {
            firstIcon = 'see-icon-v5-common-important-3 cmp-hl-fc2'
        } else if (urgentLevel == 2) {
            firstIcon = 'see-icon-v5-common-important-2 cmp-hl-fc2'
        } else if (urgentLevel == 1) {
            firstIcon = 'see-icon-v5-common-important-1 cmp-theme-fc'
        }
        //zsy改造，使用自定义模板-定义参数
        var showTime = obj.affair.state == "3"?getShowTime(obj.receiveTime):(obj.dealTime == null?obj.createDate:getShowTime(obj.dealTime));
        var person = obj.preApprover?obj.preApprover+"提交":obj.createPerson+"发起";
        if(navItemId == "allDone"){ //已办数据
            person = obj.currentHandleUser ? (obj.currentHandleUser + "处理中") : "已办结";
            person = (obj.currentHandleUser == "发起中")?obj.currentHandleUser:person;
        }
        var collectState = obj.favorite || false;
        var fileTypeName = obj.summary.fileTypeName || "";
        fileTypeName = _convertFileTypeName(fileTypeName,obj.summary.edocType);//转换文件类型头像文字
        var newItem = {
            model: navItemId,
            collectState:collectState,
            urgentLevel: urgentLevel,

            leftText:fileTypeName, //头像 //cmp.origin + "/rest/orgMember/avatar/"+ item.fr_id +"?maxWidth=200",
            topText:obj.summary.subject,  //标题
            bottomText:showTime, //时间
            centerLeftText:obj.nodePolicy, //中间左边显示文本：节点权限
            centerText:obj.summary.zsyFileType, //中间文本：文件类型
            centerRightText:person, //中间右边显示文本：处理人
        }
        //是否是未读
        if(navItemId == "allPending" && obj.affair.state != 4 && (obj.affair.readState == '0' || obj.affair.subState == '11')){
            isUnread = true;
            newItem.unread = true;
        }
        obj.model = navItemId;
        var item = {
            itemData:obj,
            index:i,
            // collectState:collectState,//当前数据收藏状态 -待阅已阅列表暂未开放此参数出来
            html: renderCustomItem(newItem), //zsy改造，使用自定义模板
        };
        items.push(item);
    });
    if(isUnread){//待办列表
        renderUnreadDom(navItemId);//加载未读样式
    }
    return items;
  };

  function buildBusinessList(containDivID, params) {
    // 只要点击页签了，就关闭掉左滑打开的效果
    var cmpSelectedItems = document.querySelectorAll("li.cmp-selected");
    cmpSelectedItems && cmpSelectedItems.length > 0 && $(cmpSelectedItems).each(function (i, index) {
      cmp.swipeoutClose(index[0]);
    });
    if (businessListMap[containDivID]) { //每次点击页签-重新加载数据
        businessListMap[containDivID].destroy()
        businessListMap[containDivID]=null;
        // $(containDivID).html("");
        // return;
    }
    var domID = containDivID.replace('#', '');
    businessListMap[containDivID] = new cmp.ui.businessList(containDivID, {
      listNavs: [{
          id: domID,
          //zsy-所有列表执行custom定义
          templateType: "custom" || 'default',
          //选择模式状态
          isSelectOn: false,
          //选择模式,single 单选， multiple 多选，不传默认为多选
          selectModal: 'multiple',
      }],
      //列表顶部按钮事件
      listTopBtnCb: function (item) {
          console.log(item);
          var _btn = item.item.data;
          if (_btn == "startBatch") { //开启批量操作
              var listConfig = {
                  listTopLeftBtn: {
                      text: "全选",
                      data: "allBatch" //开启批量操作
                  },
                  listTopRightBtn: {
                      text: "取消",
                      data: "cancelBatch" //开启批量操作
                  }
              }
              this.updateListTopBtn(listConfig, 0);
              this.setSelectModel(true);
              $(".zsy-footer-collect").removeClass("cmp-hidden");
              var containDivID = getCurrentDiv();
              if(containDivID == "#allStore"){
                  _setFooterCollect("allStore",false);
              }else{
                _setFooterCollect("daiyue",true);
              }
              _refreshHeight();
              //this.refreshScroll();//点击批量操作，默认显示全选和取消按钮
          } else if (_btn == "cancelBatch") {
              cancelBatchFn(this);
          }else if(_btn == "allBatch"){ //全选操作
              this.setCurListItemSelectState("all",true);
          } 
          
      },
      //选择模式时候的列表点击回调
      listSelectCb:function(item){
          console.log(item);
          var _model = item.item.itemData.model;
          var containDivID = getCurrentDiv();
          setTimeout(function(){
              var items = businessListMap[containDivID].getSelectItems();
              var mark = false;//默认都是未收藏状态
              if(items && items.length > 0){
                  $(items).each(function(i,_item){
                      var markState = _item.itemData.favorite;
                      var index = _item.index;
                      var selectedItems = document.querySelector(containDivID).querySelectorAll(".cmp-list-item.edoc-list-item")[index];
                      var attrText = selectedItems.getAttribute("markState");
                      var getAttribute = JSON.parse(attrText);
                      var favorite = attrText ? getAttribute : markState;
                      if(!favorite){ 
                          mark = true;
                          return false;
                      }
                  });
                  _setFooterCollect(_model,!mark);
              }
          },0);
          
      },
      listCb: function (item) {
          if(_isNeibuziliaoSecretLevel(item)){
              cmp.notification.alert("对不起，该数据不能在移动端处理，请用您的办公计算机办理。",null,"","确定");
              return;
          }
          if(_isNigaoNode(item)){
              cmp.notification.alert("对不起,拟稿环节不能在移动端处理,请用您的办公计算机办理。",null,"","确定");
              return;
          }
          var _target = item.e.target,
              _itemData = item.item.itemData,
              _model = item.item.itemData.model,
              _collectState = item.item.collectState;//收藏状态
          var _isurgent = _target.classList.contains("list-item-urgent"),//点击更多
              _iscollection = _target.classList.contains("item-collection"),//点击收藏
              _isdelete = _target.classList.contains("item-delete");//点击删除
          var _isAllstore = "allStore" === _model; //收藏模块
          if (_isurgent || _iscollection || _isdelete) { //待阅
              if (_isurgent) { //点击更多
                  var params = {
                      summaryId:item.item.itemData.summaryId
                  };
                  cmp.dialog.loading();
                  $s.PetroChinaApi.getAttAndContentFromPassReadSummary({},params,{
                      success:function(result){
                          cmp.dialog.loading(false);
                          var onlineContentEnable = result.onlineContentEnable;
                          var contentData = result.contentData, //正文
                              attData = result.attData; //附件数据
                          var items = [{
                              key: "contentData",
                              data: JSON.stringify(contentData).escapeHTML(),
                              name: "正文",
                              name2: "",
                              onlineContentEnable:onlineContentEnable
                          }];
                          attData && attData.length > 0 && $(attData).each(function(i,attItem){
                              items.push({
                                  key: "attData",
                                  data: JSON.stringify(attItem).escapeHTML(),
                                  name: "附件:" + attItem.filename,
                                  name2: "",
                                  onlineContentEnable:onlineContentEnable
                              });
                          });
                          var _items = [{
                              groupName: "",
                              type: "text",
                              items: items
                          }];
                          cmp.dialog.groupSheet( _items, null, function (res) {
                              var data = JSON.parse(res.data);
                              if(res.key == "contentData"){ //查看正文
                                  data.onlineContentEnable = onlineContentEnable;
                                  showContent(data);
                              }else{ //查看附件
                                  var filename = encodeURIComponent(data.filename);
                                  cmp.att.read({
                                    path:cmp.util.getSeeyonPath() + "/rest/attachment/file/" + data.fileUrl,//文件的服务器地址
                                    filename:filename,//附件名称
                                      fileId:data.fileUrl,
                                      createDate:data.createdate,
                                      v:data.v,
                                    edit:false,  //是否可以进行修改编辑
                                    officeTransformEnable:onlineContentEnable,
                                    extData:{
                                        fileId: data.fileId,
                                        lastModified: data.lastModified,
                                        origin: 'xxx'
                                    },
                                    success:function(ret){
                                        console.log(ret);
                                    },
                                    error:function(error){
                                        console.log(error);
                                    }
                                });
                              }
                          });
                      },error:function(res){
                          console.log(res);
                          cmp.dialog.loading(false);
                      }
                  });
                  
              } else if (_iscollection) { //点击收藏
                  var _classList = _target.classList,
                      collectIcon = "see-icon-v5-common-collect",
                      collectFillIcon = "see-icon-v5-common-collect-fill";
                  if (_classList.contains(collectIcon)) { //执行收藏
                      _classList.remove(collectIcon);
                      _classList.add(collectFillIcon);
                      $(_target).text("取消收藏");
                      var ids = [ _isAllstore ? _itemData.source_id:_itemData.affairId ];
                      //执行批量收藏
                      _batchAffair(true ,ids ,function(result){
                          cmp.notification.toast("收藏成功!");
                      },function(){
                          cmp.notification.toast("收藏失败!");
                      });
                  } else { //执行取消收藏
                      _classList.remove(collectFillIcon);
                      _classList.add(collectIcon);
                      $(_target).text("收藏");
                      var ids = [ _isAllstore ? _itemData.source_id:_itemData.affairId ];
                      //执行批量取消收藏
                      _batchAffair( false ,ids ,function(result){
                          cmp.notification.toast("取消收藏成功!");
                      },function(){
                          cmp.notification.toast("取消收藏失败!");
                      });
                  }
              } else if (_isdelete) { //点击删除
                  var title = _isAllstore ? "确定取消收藏?":"确定删除该传数据?";
                  cmp.notification.confirm( title , function (res) {
                    if (res == 1) {
                        var ids = [ _isAllstore ? _itemData.source_id:_itemData.affairId ];
                        if(_isAllstore){ //执行批量取消收藏
                            _batchAffair( false ,ids ,function(result){
                                var containDivID = getCurrentDiv();
                                businessListMap[containDivID].removeListItems(0,item.index);
                                cmp.notification.toast("删除成功!","center",500);
                            },function(res){
                                cmp.notification.toast("删除失败!","center",500);
                            });
                        }else{ //执行待阅和已阅列表的删除
                            cmp.notification.alert("差接口口口！！");
                            return;
                            $s.PetroChinaApi.findPassReadList({},_params,{
                                success:function(){
                                    cmp.notification.toast("删除成功!","center",500);
                                },error:function(){
                                    cmp.notification.toast("删除失败!","center",500);
                                }
                            });
                        }
                    }else{
                        var cmpSelectedItems = document.querySelectorAll("li.cmp-selected");
                        cmpSelectedItems && cmpSelectedItems.length > 0 && $(cmpSelectedItems).each(function (i, index) {
                            cmp.swipeoutClose(index[0]);
                        });
                    }
                });
              } else {
                  cmp.notification.toast("暂未开通穿透功能!");
              }
              return;
          }
          _M3_Save_Storage();
          var openFrom = "";
          if(!_itemData.affairState){
              _itemData.affairState = _itemData.affair ? _itemData.affair.state : null;
          }
          if (_itemData.affairState == "3") {
              if (_itemData.subState == "13" || _itemData.subState == "19") {
                openFrom = "listZcdb";
              } else {
                openFrom = "listPending";
              }
          } else if (_itemData.affairState == "2") {
              openFrom = "listSent";
          } else if (_itemData.affairState == "1") {
              openFrom = "listWaitSend";
          } else {
              openFrom = "listDoneAll";
          }
          _isAllstore && (openFrom = "listPending");
          var _params = {
            "affairId": _itemData.affairId || _itemData.source_id,
            "openFrom": openFrom,
            "isGrab": _itemData.affair && _itemData.affair.isGrab
          };
          //隐藏zsy原生导航栏
          // cmp.util.QiXinHideWebViewTitle();
          
          // 打开详情页
          edocApi.openSummary(_params);

          //点击穿透到详情的时候，将未读设置成已读
          // var items = businessListMap[containDivID].getItems({
          //     type: 'list',
          //     listIndex: 0
          // });
          // var datas = [];
          // items.forEach(function (info) {
          //   if (info._param.affairId === _itemData.affairId) {
          //       if (info._param.affair.subState == '11') {
          //           info._param.affair.subState = '12'
          //       }
          //       if (info._param.affair.readState == '0') {
          //           info._param.affair.readState = '1';
          //       }
          //   }
          //   datas.push(info._param);
          // });
          /*这句话会导致不能高亮先屏蔽*/
          // businessListMap[containDivID].updateList({
          //   listIndex: 0,
          //   //listData的数据结构请下载："业务列表内容数据格式.js"
          //   listData: getBusinessListItems(datas)
          // })
      },
      customBtnCb: function (obj) {
          //抢单操作
          this.listCb(obj);
      },
        /**
         * zsy获取分类名称
         * @param fileTypeName
         */
      getEdocCategory:function(fileTypeName){

      },
      getListDataCb: function (obj) {
          pageX[containDivID] = {};
          pageX[containDivID]['pageNo'] = obj.pageNum;
          
          var navItem = obj.navItem;
          var navItemId = navItem.id;
          //待阅已阅列表
          if ("pendingRead" == navItemId || "allDoneRead" == navItemId ) {
              obj["model"] = navItemId;
              var listType = "";
              if("pendingRead" == navItemId){
                  listType = "listPending";
              }
              if("allDoneRead" == navItemId){
                  listType = "listDoneAll";
              }
              var _params = {
                  listType:listType,//listPending:待阅列表 listDone:已阅列表
                  condition:"0", //0:走列表数据 1:走查询条件的列表数据
                  subject:""
              }
              _params = cmp.extend(_params,param);
              $s.PetroChinaApi.findPassReadList({},_params,{
                  success:function(result){
                      var dataList = result.data;
                      var newListData = [],isUnread = false;//是否有未读

                      dataList && dataList.length > 0 && $(dataList).each(function(i,item){
                          var fileTypeName = item.fileTypeName || "部门收文";//待阅已阅默认是部门收文，公司收文还没有做
                          fileTypeName = _convertFileTypeName(fileTypeName,item.edocType);//转换文件类型头像文字
                          var newItem = {
                              model: navItemId,
                              urgentLevel:item.urgentLevel,
                              collectState:item.favorite || false,

                              leftText:fileTypeName, //头像 //cmp.origin + "/rest/orgMember/avatar/"+ item.fr_id +"?maxWidth=200",
                              topText:item.subject,  //标题
                              bottomText:getShowTime(item.affairReceiveTime), //时间
                              // centerText:item.zsyFileType,
                              // centerRightText:item.startUserName,
                          }
                          if(navItemId == "pendingRead" && item.affairState != 4 && (item.affairReadState == '0' || item.affairSubState == '11')){
                              isUnread = true;
                              newItem.unread = true;
                          }
                          item.model = navItemId;
                          var _item = {
                              itemData:item,
                              index:i,
                              // collectState:item.favorite,//当前数据收藏状态
                              html: renderCustomItem(newItem)
                          };
                          newListData.push(_item);
                          
                      });
                      
                      var config = {
                          index: obj.navIndex,
                          listConfig: {
                              listTopLeftBtn: {
                                  icon: "",
                                  text: "批量操作",
                                  data: "startBatch" //开启批量操作
                              }
                          },
                          listData: newListData
                      }
                      obj.render(config);
                      if(isUnread){ //待阅列表
                          // renderUnreadDom(navItemId);//修改使用初始化参数来渲染红点
                      }
                  },
                  error:function(res){
                      console.log("待阅/已阅列表数据获取失败!");
                  }
              });
              return;
          }
          //收藏列表
          if("allStore" == navItemId){
              $s.PetroChinaApi.myFavorityList(param,{
                  success:function(result){
                      var listData = result.data;
                      obj["model"] = navItemId;
                      var newListData = [];
                      for (var i = 0, len = listData.length; i < len; i++) {
                          var item = listData[i];
                          var fileTypeName = item.fileTypeName || "";//收藏列表
                          fileTypeName = _convertFileTypeName(fileTypeName);//转换文件类型头像文字
                          var newItem = {
                              model: navItemId,
                              leftText:fileTypeName, //头像 //cmp.origin + "/rest/orgMember/avatar/"+ item.fr_id +"?maxWidth=200",
                              topText:item.fr_name,  //标题
                              bottomText:item.fr_create_time, //时间
                          }
                          item.model = navItemId;
                          var _item = {
                              itemData:item,
                              index:i,
                              // collectState:true,//当前数据收藏状态
                              html: renderCustomItem(newItem)
                          };
                          newListData.push(_item);
                      }
                      var config = {
                          index: obj.navIndex,
                          listConfig: {
                              listTopLeftBtn: {
                                  icon: "",
                                  text: "批量操作",
                                  data: "startBatch" //开启批量操作
                              }
                          },
                          listData: newListData
                      }
                      obj.render(config);
                  },
                  error:function(error){

                  }
              });
              return;
          }
          var param = cmp.extend({}, (params && params.length > 0 && params[1]) || {}, {
              pageNo: obj.pageNum
          });
          param.pageSize = 30;
          if (pageX.loadAll) {
              param.pageNo = 1;
              param.pageSize = pageX[containDivID]['pageNo'] * 30;
              pageX.loadAll = false;
          }
          //待办已办列表
          $s.PetroChinaApi.getSummaryListByEdocTypeAndListType({}, param, {
            success: function (result) {
                var config = {
                  //渲染的列表索引 必填
                  index: obj.navIndex,
                  //列表的配置 非必填
                  listConfig: {
                    //默认30 非必填
                    pageSize: 30
                  },
                  listData: getBusinessListItems(result.data,navItemId)
                };
                //已办也增加批量操作
                if("allDone" == navItemId){
                    config.listConfig.listTopLeftBtn = {
                        icon: "",
                        text: "批量操作",
                        data: "startBatch" //开启批量操作
                    }
                }
                obj.render(config);
            },
            error: function (result) {
                //处理异常
                EdocUtils.ajaxErrorHander(result);
            }
          });
      }
    });
  }
  //zsy列表数据判断是否是“内部资料”密级的，如果是的话，是不能点击穿透的
  function _isNeibuziliaoSecretLevel(listItem){
      if(listItem.item.itemData.summary){//收藏也用了这里的逻辑，进行一个兼容先
          var secretLevel = listItem.item.itemData.summary.secretLevel;
          return "5" == secretLevel;//5代表是内部资料的密级
      }
      return false;
  }
    //zsy列表数据判断是否是拟稿节点(已发不算，已发的state=2)（拟稿被回退了，然后作为了拟稿人的待办数据的情况，是不能点击穿透的）
    function _isNigaoNode(listItem){
        return listItem.item.itemData.nodePolicy && listItem.item.itemData.nodePolicy == "拟稿" && listItem.item.itemData.affair.state != "2";
    }
  //取消批量操作模式-
  function cancelBatchFn(content,listTopRightBtn){
      $(".zsy-footer-collect").addClass("cmp-hidden");
      _refreshHeight();
      content.setCurListItemSelectState("all", false); //全部取消选择
      content.setSelectModel(false);
      var listConfig = {
          listTopLeftBtn: {
              text: "批量操作",
              data: "startBatch" //开启批量操作
          },
          listTopRightBtn:listTopRightBtn
      }
      content.updateListTopBtn(listConfig, 0);
      content.refreshScroll();
  }
  //底部收藏和删除按钮根据参数动态设置状态
  function _setFooterCollect(model,state){ //model:模块 state:true(收藏) false(取消收藏)
      if(state){
          $(".collectText").text("取消收藏");
      }else{
          $(".collectText").text("收藏");
      }
      if(model == "allStore"){ //收藏模块-只显示收藏按钮
          $(".collectText").text("取消收藏");
      }
  }
  //批量收藏或单个收藏或取消收藏-接口封装
  function _batchAffair( mark, ids , success ,error){
      //mark:true 执行批量收藏 false:批量取消收藏
      $s.PetroChinaApi[mark?"batchFavoriteAffair":"batchCancelFavoriteAffair"]({},{
        affairIds:ids,
      },{
          success:function(result){
              console.log(result);
              if(result && result.success && result.success == "false"){
                  cmp.notification.toast(result.message,"center",500);
                  return;
              }
              success && success();
          },
          error:function(res){
              error && error(res);
          }
      });
      
  }
  //
  function showContent(contentData){
      var content = contentData;
      var content1bodyType = content["contentType"];
      if (content1bodyType != "10") { //SeeyonContent.getBodyCode("HTML")
          var suffixMap = {
              "wps": "doc",
              "et": "xls"
          }
          var subfix;
          if (46 == content1bodyType) {//ofd正文
              subfix = "ofd";
          } else {
              var WORD_BODY_TYPES = {
                  "10" : "HTML",
                  "20" : "form",
                  "30" : "txt",
                  "41" : "doc",
                  "42" : "xls",
                  "43" : "wps",
                  "44" : "et",
                  "45" : "pdf",
                  "90" : "third"
              }
              subfix = WORD_BODY_TYPES[content1bodyType];//SeeyonContent.getBodyType(content1bodyType)
          }
          var newFileName = "";
          var newSuffix = suffixMap[subfix] || subfix;
          if (46 == content1bodyType) {//微协同还是不支持ofd
              cmp.notification.alert("暂不支持OFD正文");
              return;
          }
          var srcFileName = newFileName || ("正文." + newSuffix);
          var fileName = srcFileName;
          fileName = encodeURIComponent(fileName);
          var downFilePath = cmp.origin + "/rest/attachment/file/" + content.content + "?fileName=" + fileName;
          //使用瑞飞提供的原生接口
          cmp.att.read({
              fileId:content.content,
              filename:fileName
          })
          return ;

          //如果文档类型支持在线转换且开启了在线转换服务
          if (cmp.att.isSupportReadOnline(newSuffix) && content.onlineContentEnable== "enable" ) {

              $s.PetroChinaApi.getContentV(content.content, {
                  success : function(ret) {
                      cmp.dialog.loading(false);
                      var v =ret.data;
                      cmp.att.readOnline({
                          "fileUrl": content.content, // 文件fileUrl，必填
                          "filename": srcFileName,  // 必填
                          // 平台要求将createDate传入文件最新的修改时间
                          "createDate": content.createDate,   // 必填
                          "lastModifyDate": content.modifyDate,   // 必填，文件最后修改时间，用于缓冲管理
                          "v":v,
                          "success": function () {
                              return;
                          },
                          "error": function () {
                              return;
                          }
                      });
                  },
                  error: function(result){
                      cmp.dialog.loading(false);
                  }
              });

          } else {
              if (cmp.att.canDownload4Wechat(newSuffix)) {
                  cmp.att.download({"url": downFilePath, "title": srcFileName});
              } else {
                  cmp.notification.toast(cmp.i18n("commons.note.notsuport3"), 'top', 1000);
              }
          }
      }else{
          cmp.notification.toast("不支持查看!");
      }
  }
  //加载数据
  function loadData(params) {
      var containDivID = getCurrentDiv();
      buildBusinessList(containDivID, params);
      return;
  }

  /********************************** 页面布局  ***********************************/

  function initHtml() {
    //国际化title标签
    document.querySelector("title").innerText = cmp.i18n("Edoc.title.edoc");
    if (pageX.cacheData.edocType) {
      toList();
    }
  }

  function toList() {
    var edocType = pageX.cacheData.edocType;

    if (edocType == "0" || edocType == "1" || edocType == "2") {
      $("#searchIcon").css("display", 'none');
    }
    // cmpNav.indexTo(pageX.cacheData.edocType);

  }

  function showOneList(callback) {
    var edocType = pageX.cacheData.edocType;
    var tabs = cmpNavOptions.data || [];
    for (var i = 0; i < tabs.length; i++) {
      if (tabs[i].custom.edocType == edocType) {
        callback && callback(tabs[i].id);
        var classList = _$(tabs[i].custom.href).classList;
        if (!classList.contains("cmp-active")) {
          classList.add("cmp-active");
        }
      } else {
        var classList = _$(tabs[i].custom.href).classList;
        if (classList.contains("cmp-active")) {
          classList.remove("cmp-active");
        }
      }
    }
  }
  /********************************** 初始化控件事件  ***********************************/
  function pageNavTabEvent(res) {
    var custom = res.custom || {};
    switch (res.id) {
      case 'sendTab':
        hideSearchDiv();
        showOneList();
        pageX.cacheData.edocType = custom.edocType;
        break;
      case 'reportTab':
        hideSearchDiv();
        showOneList();
        pageX.cacheData.edocType = custom.edocType;
        break;
      case 'receiveTab':
        hideSearchDiv();
        showOneList();
        pageX.cacheData.edocType = custom.edocType;
        break;
      case 'allPendingTab': //待办列表数据
        pageX.cacheData.edocType = edocAllPendingKey;
        showOneList();
        listPendingFn();
        break;
      case 'doneTab': //已办列表数据
        pageX.cacheData.edocType = edocAllDoneKey;
        showOneList();
        listDoneFn();
        break;
      case 'doingTab': //在办列表数据
        pageX.cacheData.edocType = edocAllDoingKey;
        showOneList();
        listDoingFn();
        break;
        // zsy
      case 'pendingReadTab': //待阅列表数据
        pageX.cacheData.edocType = edocAllPendingReadKey;
        showOneList();
        listPendingReadFn();
        break;
      case 'doneReadTab': //已阅列表数据
        pageX.cacheData.edocType = edocAllDoneReadKey;
        showOneList();
        listDoneReadFn();
        break;
      case 'storeTab': //收藏列表数据
        pageX.cacheData.edocType = edocAllStoreKey;
        showOneList();
        listStoreFn();
        break;
      default:
        break;
    }

  }

  function initEvent() {

      cmp("#allPendingList,#allDoing,#allDone").on('tap', ".col-list-cell-info", function (e) {
          cmp.event.trigger("beforepageredirect", document);
          //保存缓存
          _M3_Save_Storage();

          var openFrom = "";
          if (this.getAttribute("affairState") == "3") {
            if (this.getAttribute("subState") == "13" || this.getAttribute("subState") == "19") {
              openFrom = "listZcdb";
            } else {
              openFrom = "listPending";
            }
          } else if (this.getAttribute("affairState") == "2") {
            openFrom = "listSent";
          } else if (this.getAttribute("affairState") == "1") {
            openFrom = "listWaitSend";
          } else {
            openFrom = "listDoneAll";
          }
          var params = {
            "affairId": this.getAttribute("affairId"),
            "openFrom": openFrom
          };
          edocApi.openSummary(params);

          //点击穿透到详情的时候，将未读设置成已读
          var unReadDiv = _$("#unRead" + this.getAttribute("affairId"));
          if (unReadDiv && unReadDiv.style.display != "none") {
            unReadDiv.style.display = "none";
          }

      });

      //点击查看搜索条件
      _$("#toSearch").addEventListener("click", function (e) {
          searchFn();
      });

      //清除查询条件
      _$("#cancelSearch").addEventListener("click", function (e) {
          $("#searchHeader").css("display", '');
          $("#reSearch").css("display", 'none');
          clearSearchCondition();
          if (pageX.cacheData.edocType == edocAllDoneKey) {
            listDoneFn();
          } else if (pageX.cacheData.edocType == edocAllDoingKey) {
            listDoingFn();
          } else {
            listPendingFn();
          }
      });

      //点击搜索框
      _$("#searchinputBox").addEventListener("click", function (e) {
            var path = "/seeyon/m3/apps/v5/edoc/html/edocGroupSearch.html";
            cmp.href.next(path);  
            // searchFn();
      });

      //公文统计
      $('#has_statistics_zone .statistics-menu').on("tap", function () {
          pageX.cacheData.edocType = this.getAttribute("edocType");
          _M3_Save_Storage();

          var params = {
            edocType: this.getAttribute("edocType")
          };
          var option = {};
          // if(EdocUtils.isFromM3NavBar()){
          //   option.openWebViewCatch = true;
          // }
          option.openWebViewCatch = true;
          cmp.href.next(_edocPath + "/html/edocStatistics.html" + colBuildVersion, params, option, {
            "nativeBanner": false
          });
      });
      $cmp('#send_receive_report .menu-item').on('tap', function () {
          _M3_Save_Storage();
          cmp.storage.save("edocListToEdocSummaryList", true, true);

          var params = {
            edocType: this.getAttribute("edocType"),
            listType: 'listPending'
          };

          var option = {};
          option.openWebViewCatch = true;
          cmp.href.next(_edocPath + "/html/edocSummaryList.html" + colBuildVersion, params, option, {
            "nativeBanner": false
          });
      });
      cmp.webViewListener.add({
          type: 'edoc.ListRefresh'
      });
      document.addEventListener("edoc.ListRefresh", function () {
          pageX.loadAll = true;
          if (pageX.cacheData.edocType == edocAllDoneKey) { //已办
              listDoneFn();
          } else if (pageX.cacheData.edocType == edocAllDoingKey) { //在办
              listDoingFn();
          } else if (pageX.cacheData.edocType == '0') {
              hideSearchDiv();
          } else if (pageX.cacheData.edocType == '1') {
              hideSearchDiv();
          } else if (pageX.cacheData.edocType == '2') {
              hideSearchDiv();
          } else {
              listPendingFn();
          }
          // initEdocTypeCount();
      });

      //zsy -组合查询入口
      $("#combin_query").on("tap", function () {
          var path = "/seeyon/m3/apps/v5/edoc/html/edocGroupSearch.html";
          cmp.href.next(path);
      });
      //zsy-收藏按钮事件
      $(".zsy-footer-collect").on("tap", ".collect", function () {
          var containDivID = getCurrentDiv();
          if(!containDivID)return;
          var _isAllstore = containDivID == "#allStore";//收藏模块
          var _getAffairState = getAffairState();
          var states = _getAffairState.datas;
          var mark = false;//默认执行取消收藏
          var ids = _getAffairState.ids;
          states && states.length > 0 && $(states).each(function(i,item){
              if(!item.mark){ //如果有一个为未收藏，那就全部执行收藏操作
                  mark = true;
                  return false;
              }
          });
          if(!ids || ids.length == 0 ){
              cmp.notification.toast("数据异常!");
              return;
          }
          _batchAffair( _isAllstore ? false : mark , ids ,function(result){
              if(_isAllstore){
                  businessListMap[containDivID].removeListItems(0,function (item) {
                          return item.isSelect;
                      }
                  );
              }else{
                  batchAffairState(containDivID,mark);//成功收藏或者成功取消收藏才更改状态
              }
              cancelBatchFn(businessListMap[containDivID],null);
              cmp.notification.toast(_isAllstore ? "取消收藏成功!": mark ? "收藏成功!" : "取消收藏成功!","center",500);
          },function(res){
              console.log(res);
          });
          
      });
      //zsy-删除按钮
      // $(".zsy-footer-collect").on("tap", ".delete", function () {
      //     var containDivID = getCurrentDiv();
      //     businessListMap[containDivID].removeListItems(0,function (item) {
      //             return item.isSelect;
      //         }
      //     );
      //     cmp.notification.toast("删除成功!","center",500);
      //     cancelBatchFn(businessListMap[containDivID],null);

      // });
  }
  //通过已选择的数据-获取当前到底应该执行收藏还是取消收藏
  function getAffairState(){
      var containDivID = getCurrentDiv();
      var _isAllstore = containDivID == "#allStore";//收藏模块
      var items = businessListMap[containDivID].getSelectItems();
      var _ids = [],_datas = [];
      items && (items.length > 0) && $(items).each(function(i,index){
          if(_isAllstore){
              _ids.push(index.itemData.source_id);
          }else{
              var _index = index.index;
              var selectedItems = document.querySelector(containDivID).querySelectorAll(".cmp-list-item.edoc-list-item")[_index];
              var attrText = selectedItems.getAttribute("markState");
              var getAttribute = JSON.parse(attrText);
              var favorite = attrText ? getAttribute : index.itemData.favorite;
              _ids.push(index.itemData.affairId);
              _datas.push({
                  id:index.itemData.affairId,
                  mark: favorite //获取当前数据是否已经收藏
              });
          }
      });
      return {
        ids:  _ids,
        datas : _datas
      }
  }
  //批量设置收藏状态-目前只有待阅/已阅列表
  function batchAffairState(containDivID,state){
      var selectedItems = document.querySelector(containDivID).querySelectorAll(".cmp-list-item.edoc-list-item.cmp-item-selected");
      if(selectedItems && selectedItems.length > 0){
          for(var i=0,len=selectedItems.length;i<len;i++){
              var collectItem = selectedItems[i].querySelector(".item-collection"),
                  collect = "see-icon-v5-common-collect",
                  collectFill = "see-icon-v5-common-collect-fill";
              selectedItems[i].setAttribute("markState",state); //手动设置一次收藏状态
              if(state){ //批量设置收藏
                  collectItem.innerHTML = "取消收藏";
                  collectItem.classList.remove(collect);
                  !collectItem.classList.contains(collectFill) && collectItem.classList.add(collectFill);
              }else{ //批量设置取消收藏
                  collectItem.innerHTML = "收藏";
                  collectItem.classList.remove(collectFill);
                  !collectItem.classList.contains(collect) && collectItem.classList.add(collect);
              }
          }
      }
  }

  function switchSearchDiv() {
    var defaultParams = getSearchCachedParams();

    setTimeout(function () { //延迟显示搜索框，以免搜索框隐藏时点击tab触发到搜索框的点击事件
      _$("#reSearch").style.display = defaultParams ? "block" : "none";
      _$("#searchHeader").style.display = defaultParams ? "none" : "";
    }, 200);

    _$("#toSearch").innerHTML = cmp.i18n("Edoc.page.label.see_search_condition");
    return defaultParams;
  }

  function hideSearchDiv() {
    _$("#reSearch").style.display = "none";
    _$("#searchHeader").style.display = "none";
  }

  function searchFn() {
    var subject = "";
    var startMemberName = "";
    var createDate = "";
    var searchParam = switchSearchDiv();
    if (searchParam && searchParam.subject) {
      subject = searchParam.subject;
    }
    if (searchParam && searchParam.startMemberName) {
      startMemberName = searchParam.startMemberName;
    }
    if (searchParam && searchParam.sDate && searchParam.eDate) {
      createDate = [searchParam.sDate, searchParam.eDate];
    }

    //标题、发起人、发起时间
    var searchObj = [{
        id: "subject",
        type: "text",
        condition: cmp.i18n("Edoc.title.title"),
        text: cmp.i18n("Edoc.title.title"),
        defValue: subject
      },
      {
        id: "startMemberName",
        type: "text",
        condition: cmp.i18n("Edoc.title.sender"),
        text: cmp.i18n("Edoc.title.sender"),
        defValue: startMemberName
      },
      {
        id: "createDate",
        type: "date",
        condition: cmp.i18n("Edoc.title.createTime"),
        text: cmp.i18n("Edoc.title.createTime"),
        defValue: createDate
      }
    ];

    cmp.groupSearch.init({
      items: searchObj,
      model: {
        name: "edoc",
        id: searchModelId
      },
      appId: "4",
      H5Header: false,
      openSearchResult: false, //是否打开存放搜索结果的容器
      callback: function (result) {
        doSearch(result.result);
      },
      closeCallback: function () {}
    });
  }

  function doSearch(result) {
    if (Array.isArray(result)) {
      page = {};
      for (var i = 0; i < result.length; i++) {
        var id = result[i].id; //返回的搜索条件
        var type = result[i].type; //搜索输入的数据类型有text和date两种
        if (type == "date") {
          if (result[i].value == "") {
            pageX.cacheData.searchCondition.sDate = "";
            pageX.cacheData.searchCondition.eDate = "";
          } else {
            pageX.cacheData.searchCondition.sDate = result[i].value[0];
            pageX.cacheData.searchCondition.eDate = result[i].value[1];
          }
        } else if (id == "subject") {
          pageX.cacheData.searchCondition.subject = result[i].value;
        } else if (id == "startMemberName") {
          pageX.cacheData.searchCondition.startMemberName = result[i].value;
        }
      }
    }
    switchSearchDiv();

    page.subject = pageX.cacheData.searchCondition.subject;
    page.startMemberName = pageX.cacheData.searchCondition.startMemberName;
    page.sDate = pageX.cacheData.searchCondition.sDate;
    page.eDate = pageX.cacheData.searchCondition.eDate;

    //判断当前选择的类型
    if (pageX.cacheData.edocType == edocAllDoneKey) { //已办
      var a = {
        edocType: edocAllDoneKey,
        listType: edocAllDoneListType
      };
      page = $.extend(page, a);
    } else if (pageX.cacheData.edocType == edocAllDoingKey) { //在办
      var a = {
        edocType: edocAllDoingKey,
        listType: edocAllDoingListType
      };
      page = $.extend(page, a);
    } else { //待办
      var a = {
        edocType: edocAllPendingKey,
        listType: edocAllPendingListType
      };
      page = $.extend(page, a);
    }
    var params = [{}, page];
    setTimeout(function () {
      loadData(params);
    }, 200);
  }

  function listPendingFn() {
    urlParam.edocType = edocAllPendingKey;
    pageX.cacheData.edocType = edocAllPendingKey;
    switchSearchDiv();
    _M3_Save_Storage();
    page = {};
    var params = {
      "edocType": edocAllPendingKey,
      "listType": edocAllPendingListType
    };
    page = initSearchCachedParams(page, params);
    var params = [{}, page];
    loadData(params);
  }

  function listDoingFn() {
    switchSearchDiv();
    pageX.cacheData.edocType = edocAllDoingKey;
    _M3_Save_Storage();
    page = {}
    page.edocType = edocAllDoingKey;
    page.listType = edocAllDoingListType; //listDone
    var params = {
      "edocType": edocAllDoingKey,
      "listType": edocAllDoingListType
    };
    page = initSearchCachedParams(page, params);
    params = [{}, page];
    loadData(params);
  }

  function listDoneFn() {
    switchSearchDiv();
    pageX.cacheData.edocType = edocAllDoneKey;
    _M3_Save_Storage();
    page = {}
    page.edocType = edocAllDoneKey;
    page.listType = edocAllDoneListType; //listDoneAll
    var params = {
      "edocType": edocAllDoneKey,
      "listType": edocAllDoneListType
    };
    page = initSearchCachedParams(page, params);
    params = [{}, page];
    loadData(params);
  }

  //zsy切换页签
  function listPendingReadFn() {
    switchSearchDiv();
    pageX.cacheData.edocType = edocAllPendingReadKey;
    _M3_Save_Storage();
    page = {}
    page.edocType = edocAllPendingReadKey;
    page.listType = edocAllPendingReadListType; //listDone
    var params = {
      "edocType": edocAllPendingReadKey,
      "listType": edocAllPendingReadListType
    };
    page = initSearchCachedParams(page, params);
    params = [{}, page];
    loadData(params);

  }

  function listDoneReadFn() {
    switchSearchDiv();
    pageX.cacheData.edocType = edocAllDoneReadKey;
    _M3_Save_Storage();
    page = {}
    page.edocType = edocAllDoneReadKey;
    page.listType = edocAllDoneReadListType; //listDone
    var params = {
      "edocType": edocAllDoneReadKey,
      "listType": edocAllDoneReadListType
    };
    page = initSearchCachedParams(page, params);
    params = [{}, page];
    loadData(params);
  }

  function listStoreFn() {
    switchSearchDiv();
    pageX.cacheData.edocType = edocAllStoreKey;
    _M3_Save_Storage();
    page = {}
    page.edocType = edocAllStoreKey;
    page.listType = edocAllStoreListType; //listDone
    var params = {
      "edocType": edocAllStoreKey,
      "listType": edocAllStoreKey
    };
    page = initSearchCachedParams(page, params);
    params = [{}, page];
    loadData(params);
  }

  //zsyend

  function initSearchCachedParams(page, params) {
    if (pageX.cacheData.searchCondition) {
      if (pageX.cacheData.searchCondition.subject) {
        page.subject = pageX.cacheData.searchCondition.subject;
      } else {
        page.subject = "";
      }
      if (pageX.cacheData.searchCondition.startMemberName) {
        page.startMemberName = pageX.cacheData.searchCondition.startMemberName;
      } else {
        page.startMemberName = "";
      }
      if (pageX.cacheData.searchCondition.sDate) {
        page.sDate = pageX.cacheData.searchCondition.sDate;
      } else {
        page.sDate = "";
      }
      if (pageX.cacheData.searchCondition.eDate) {
        page.eDate = pageX.cacheData.searchCondition.eDate;
      } else {
        page.eDate = "";
      }
    }
    page = $.extend(page, params);
    return page;
  }

  function getSearchCachedParams() {
    if (pageX.cacheData.searchCondition &&
      (pageX.cacheData.searchCondition.subject || pageX.cacheData.searchCondition.startMemberName || pageX.cacheData.searchCondition.sDate || pageX.cacheData.searchCondition.eDate)) {
      var searchCachedParams = {}
      searchCachedParams.subject = pageX.cacheData.searchCondition.subject;
      searchCachedParams.startMemberName = pageX.cacheData.searchCondition.startMemberName;
      if (pageX.cacheData.searchCondition.sDate) {
        searchCachedParams.sDate = pageX.cacheData.searchCondition.sDate
      }
      if (pageX.cacheData.searchCondition.eDate) {
        searchCachedParams.eDate = pageX.cacheData.searchCondition.eDate;
      }
      return searchCachedParams
    }
  }

  function getCurrentDiv() {
    var containDivID = "#allPending";
    if (pageX.cacheData.edocType == edocAllDoneKey) {
      containDivID = "#allDone"
    } else if (pageX.cacheData.edocType == edocAllDoingKey) {
      containDivID = "#allDoing"
    }
    //zsy
    else if (pageX.cacheData.edocType == edocAllPendingReadKey) {
      containDivID = "#pendingRead";
    } else if (pageX.cacheData.edocType == edocAllDoneReadKey) {
      containDivID = "#allDoneRead";
    } else if (pageX.cacheData.edocType == edocAllStoreKey) {
      containDivID = "#allStore";
    }
    return containDivID;
  }

  function clearSearchCondition() {
    pageX.cacheData.searchCondition = {}
    page.subject = "";
    page.startMemberName = "";
    page.createDate = "";
    page.sDate = "";
    page.eDate = "";
  }

  function initEvent_subList() {
    cmp(".doc-list-wrap").on('tap', ".selectNoCss", function (e) {
      _M3_Save_Storage();
      cmp.storage.save("edocListToEdocSummaryList", true, true);

      var params = {
        listType: this.getAttribute("listType"),
        edocType: pageX.cacheData.edocType
      };

      var option = {};
      option.openWebViewCatch = true;
      /*if(EdocUtils.isFromM3NavBar()){
      }*/
      cmp.href.next(_edocPath + "/html/edocSummaryList.html" + colBuildVersion, params, option, {
        "nativeBanner": false
      });
    });
  }

  //zsy假数据列表，待阅、已阅和收藏的列表
  var urgentLevelMapping = {
    "1": "普通",
    "2": "平急",
    "3": "加急",
    "4": "特急",
    "5": "特急",
    "加急":"3",
    "特急":"5"
  };

  var getShowTime = function(inputTimestamp){
      if(isNaN(inputTimestamp)){
          inputTimestamp = inputTimestamp.replace(/-/g,"\/");
          inputTimestamp = new Date(inputTimestamp).getTime();
      }
      var oneYearTimestamp = 365 * 24 * 60*60*1000;//1年
      var todayTimestamp = 24*60*60*1000;//今天的整个时间戳长度
      var oneHour = 60*60*1000;//1小时
      var twoHour = 2*60*60*1000;//2小时
      var threeHour = 3*60*60*1000;//3小时
      var fiveMinute = 5*60*1000;//5分钟
      var inputDate = new Date(parseInt(inputTimestamp));//输入的日期
      var currentTimestamp = new Date().getTime();
      var ret = "";
      var timeDiff = currentTimestamp - inputTimestamp;
      var ymdhm = getYMDHMByDate(inputDate);
      if(timeDiff <= fiveMinute){
          ret = "刚刚";
      }else if(timeDiff<=  oneHour){
          var diffMunite = Math.floor(timeDiff/(60*1000));
          ret = diffMunite + "分钟前";
      }else if(timeDiff <= twoHour){
          ret = "1小时前";
      }else if(timeDiff <= threeHour){
          ret = "2小时前";
      }else if(timeDiff < todayTimestamp){//小于1天内，要判断一下是昨天还是今天
          var inputD = ymdhm[2];
          var currentD = new Date().getDate();
          var oneDayDescreption = "今天";
          if(inputD != currentD){
              oneDayDescreption = "昨天"
          }

          ret = oneDayDescreption+ymdhm[3] + "时" + ymdhm[4] + "分";
      }
      // bug 
    //   else if(timeDiff <= oneYearTimestamp){
    //       ret = ymdhm[1] + "-" + ymdhm[2] + " " + ymdhm[3] + ":" + ymdhm[4];
    //   }
      else {
          ret = ymdhm[0] + "-" + ymdhm[1] + "-" + ymdhm[2] + " " + ymdhm[3] + ":" + ymdhm[4];
      }
      return ret;
  };

  var getYMDHMByDate = function(date){
      var year = date.getFullYear(),
          month = handleNum(date.getMonth() + 1),
          dates = handleNum(date.getDate()),
          hour = handleNum(date.getHours()),
          minute = handleNum(date.getMinutes());
      return [year,month,dates,hour,minute];
  };
    function handleNum(num){
        if(num < 10){
            num = "0" + num;
        }
        return num;
    }

  function renderCustomItem(item) {
      var str = "";
      var urgentLevel = item.urgentLevel;
      var urgentLevelText = urgentLevel ? urgentLevelMapping[urgentLevel] :"";
      var unread = item.unread;
      var isAllDone = item.model == "allDone" ? true : false; //是否是已办数据
      var isPendingRead = item.model == "pendingRead" ? true : false; //是否是待阅数据
      var isallDoneRead = item.model == "allDoneRead" ? true : false; //是否是已阅数据
      var isallStore = item.model == "allStore" ? true : false; //是否是收藏
      var topText = item.topText.escapeHTML();
      //如果是待阅/已阅/收藏-加载左右滑动效果的html
      if (isAllDone || isPendingRead || isallDoneRead || isallStore) { //或者是收藏的话
          var allDoneCollectionStyle = isAllDone?"zsy-layout-pt10":"";//已办收藏的样式
          str += '<li class="cmp-list-item edoc-list-item cmp-listactive-bgc cmp-white-bg cmp-table-view-cell">' +
              '<div class="cmp-slider-right cmp-disabled">';
          if (isallStore) {
              str += '<a class="cmp-btn cmp-btn-red item-delete see-icon-v5-common-delete">删除</a>';
          }else{
              if(item.collectState){ //已收藏
                  str += '<a class="cmp-btn cmp-btn-blue item-collection see-icon-v5-common-collect-fill '+allDoneCollectionStyle+'">取消收藏</a>';
              }else{
                  str += '<a class="cmp-btn cmp-btn-blue item-collection see-icon-v5-common-collect '+allDoneCollectionStyle+'">收藏</a>';
              }
          }
          str +='</div>' +
              '<div class="cmp-slider-handle cmp-flex-h">' +
                  '<div class="cmp-item-box cmp-white-bg cmp-bdc cmp-select-radio cmp-gray-bgc cmp-list-lh cmp-reverse-fc cmp-flex-h cmp-y-center cmp-x-center">'+ item.leftText +'</div>' +
                  '<div class="list-item-center cmp-flex-1 cmp-list-cp">' +
                  '<div class="list-item-title cmp-textover-2 '+ (unread ? " cmp-f-bold" : "") +' ">' + topText + '</div>' ;

          if(isAllDone){
              var zsyFileType = item.centerText ? (" | " + item.centerText) : "";
              str += '<div class="list-item-info cmp-f-4 cmp-sup-fc1">'
                  + (item.centerLeftText || "")  + zsyFileType + " | " + item.centerRightText +
                  '</div>' ;
          }

             str +=     '<div class="list-item-time cmp-f-4 cmp-sup-fc1">' + item.bottomText + '</div>' +
              '</div>';
          if (!isallStore) { //只显示...
              if(isAllDone){
                  str += '<div class="list-item-urgent cmp-f-2 cmp-white-fc cmp-reverse-fc urgentLevel-' + urgentLevel + '">' + urgentLevelText + '</div>';
              }else{
                  str += '<div class="list-item-urgent see-icon-v5-common-more-fill"></div>';
              }
          } 
          //else { //显示当前紧急状态
          //     str += '<div class="list-item-urgent cmp-f-2 cmp-white-fc cmp-reverse-fc urgentLevel-' + urgentLevel + '">' + urgentLevelText + '</div>';
          // }
          '</div>' +
          '</li>';
      } else {
          var zsyFileType = item.centerText ? (" | " + item.centerText) : "";
          str += '<li class="cmp-list-item edoc-list-item cmp-listactive-bgc cmp-white-bg cmp-flex-h cmp-table-view-cell ">' +
                  '<div class="cmp-item-box cmp-white-bg cmp-bdc cmp-select-radio  cmp-gray-bgc cmp-list-lh cmp-reverse-fc cmp-flex-h cmp-y-center cmp-x-center">'+ item.leftText +'</div>' +
                  '<div class="list-item-center cmp-flex-1 cmp-list-cp">' +
                      '<div class="list-item-title cmp-textover-2 '+ (unread ? " cmp-f-bold" : "") +' ">' + topText + '</div>' +
                      '<div class="list-item-info cmp-f-4 cmp-sup-fc1">'
                      + (item.centerLeftText || "")  + zsyFileType + " | " + item.centerRightText + 
                  '</div>' +
                  '<div class="list-item-time cmp-f-4 cmp-sup-fc1">' + item.bottomText + '</div>' +
            '</div>';
          // if (isallDoneRead) { //已阅-显示操作按钮
          //     str += '<div class="list-item-urgent see-icon-v5-common-more-fill"></div>';
          // } else {
              str += '<div class="list-item-urgent cmp-f-2 cmp-white-fc cmp-reverse-fc urgentLevel-' + urgentLevel + '">' + urgentLevelText + '</div>';
          // }
          str += '</li>';
      }
      return str;
  };

  //动态给页签添加未读红点样式
  function renderUnreadDom(id){
      var str = "",itemNav = document.querySelector("#"+id + "Tab");
      str += "<div class='nav-unread'></div>";
      itemNav.innerHTML = itemNav.innerHTML + str;
  }

    /**
     * 转换文件类型的显示文字
     * @param fileTypeName：后台传的文件类型名字
     * @param edocType 公文类型（0：发文；1：收文）
     * @private
     */
  function _convertFileTypeName(fileTypeName,edocType){
      var ret = "";
      if(fileTypeName.indexOf("党群") != -1){
          ret = "党群";
      }else if(fileTypeName.indexOf("公司") != -1){
          if(edocType == 1){//收文的情况
              ret = "公司收文";
          }else {
              ret = "公司";
          }
      }else if(fileTypeName.indexOf("部门") != -1){
          if(edocType == 1){//收文的情况
              ret = "部门收文";
          }else {
              ret = "部门";
          }
      }else if(fileTypeName.indexOf("专用") != -1){
          ret = "专用";
      }else if(fileTypeName.indexOf("呈批件") != -1){
          ret = "呈";
      }else {
          ret = "其他";
      }
      return ret;
  }
})(cmp, $cmp);