var pageX = {};
pageX.orgResult = {};

cmp.ready(function() {
    cmp.dialog.loading();
	_bindEvent();
    // 返回事件
    _initBackEvent();
	//加载数据
	_initPageData(function(){
		_fillPage(); 
	});
});

/**
 * 加载数据
 */
function _initPageData(onDataReady){
    pageX.winParams = cmp.href.getParam() || {};
    window.summaryBO = pageX.winParams.summaryBO;
    
    if(onDataReady){
        onDataReady();
    }
};

/** 初始化返回事件 * */
function _initBackEvent() {
    cmp.backbutton();
    
    var isFromM3NavBar = window.location.href.match('m3from=navbar');
    if (isFromM3NavBar) {
        cmp.backbutton.push(cmp.closeM3App);
    } else {
        cmp.backbutton.push(_goBack);
    }
    
}
// 页面展示
function _fillPage() {
    cmp.dialog.loading(false);
    if(summaryBO.govdocType == "2"){
    	_$("#mainbodyDataDiv_0").style.display = "";
    	_$("#content").setAttribute("placeholder", cmp.i18n("govdoc.placeholder.opinion"));
    }
}

// 绑定事件
function _bindEvent() {
	//绑定按钮事件
	cmp.require('ui-button', function() {
		new cmp.ui.button({
			type:'button',
			el: '#page-footer-submit',
            class:'cmp-white-bg',
			data: [{
					text: cmp.i18n('exchange.menu.column.resend')
				}]
			},
			function () {
				if(isNull(pageX.transOrg)){
					_alert(cmp.i18n("alert.org.choose"));
					return;
				}
				var subApp = summaryBO.summary.affairSubApp;
				var summaryId = summaryBO.summary.id;
				var affairId = summaryBO.summary.affairId;
				
				$s.EdocResource.checkBackAffairCanDeal(affairId, {}, {}, errorBuilder({
					success: function (result) {
						if(result.data != null && result.data != ""){
							_alert(result.data);
							return;
						}
						
						if(subApp == 1){ // 发文
							var validateRoleCallback = function(){
								$s.EdocResource.validateReissueeRepeat(summaryId, pageX.transOrg, {}, {}, errorBuilder({
									success: function (result) {
										var data = cmp.parseJSON(result.data);
										if(isNull(data)){
											exchangeReissue(summaryId, affairId);
										}else{
											cmp.notification.confirm(cmp.i18n("govdoc.exchange.reissueConfirm.label", [data.names]), function (e) { //e==1是/e==0 否
												if (e == 1) { //是
													exchangeReissue(summaryId, affairId);
												}
											});
										}
									}
								}));
							}
							$s.EdocResource.checkExchangeRole(pageX.transOrg,{}, {},errorBuilder({
								success: function (result) {
									var data = result.data;
									if("ok" != data){
										cmp.notification.confirm(cmp.i18n("govdoc.error.send.no.gwsfy.tips", [data]), function (e) { //e==1是/e==0 否
											if (e == 1) { //是
												validateRoleCallback();
											}
										});
									}else{
										validateRoleCallback();
									}
								}
							}));
						}else{// 收文
							var validateRoleCallback = function(){
								$s.EdocResource.verifyUnitExists(summaryId, pageX.transOrg, {}, {}, errorBuilder({
									success: function (result) {
										var data = cmp.parseJSON(result.data);
										if(isNull(data)){
											doTurnRecEdoc(affairId, pageX.transOrg);
										}else{
											cmp.notification.confirm(cmp.i18n("govdoc.turnRecEdoc.sendMessage.label", [data.names]), function (e) { //e==1是/e==0 否
												if (e == 1) { //是
													doTurnRecEdoc(affairId, pageX.transOrg);
												}else{
													if(isNull(data.finalIds)){
														_alert(cmp.i18n("govdoc.turnRecEdoc.noAccount.label"));
														return;
													}
													doTurnRecEdoc(affairId, data.finalIds);
												}
											});
										}
									}
								}));
							}
							$s.EdocResource.checkExchangeRole(pageX.transOrg,{}, {},errorBuilder({
								success: function (result) {
									var data = result.data;
									if("ok" != data){
										cmp.notification.confirm(cmp.i18n("govdoc.error.send.no.gwsfy.tips", [data]), function (e) { //e==1是/e==0 否
											if (e == 1) { //是
												validateRoleCallback();
											}
										});
									}else{
										validateRoleCallback();
									}
								}
							}));
						}
					}
				}));
			}
		);
	});
	
	//选择机构
	_$("#chooseOrg").addEventListener("tap", function(){
		cmp.selectOrg("reSendSelectOrg", {
			type : "1",
			flowType : "2",
			label : ["dept", "org", "orgMetadataTag"],
			choosableType : ["department","account"],
			fillBackData : pageX.orgResult,
			notShowRecent:true, //不显示常用栏
			callback : function(result){
                var ret = cmp.parseJSON(result);
                var orgResult = ret.orgResult;
                var showOrg = "", transOrg = "";
                for(var i = 0;i< orgResult.length; i ++){
                   if(i != 0){
                	   showOrg += "," + orgResult[i].name;
                	   transOrg += "," + orgResult[i].type + "|" + orgResult[i].id;
                   }else{
                	   showOrg = orgResult[i].name;
                	   transOrg = orgResult[i].type + "|" + orgResult[i].id;
                   }
                }
                
                pageX.showOrg = showOrg;
                pageX.transOrg = transOrg;
                pageX.orgResult = orgResult;
                document.getElementById("showOrg").innerHTML = pageX.showOrg;
			}
		});
	});
}

//补发
function exchangeReissue(summaryId, affairId){
	$s.EdocResource.exchangeReissue(summaryId, pageX.transOrg, affairId, {}, {}, errorBuilder({
		success: function (result) {
			_gotoList();
		}
	}));
}

//转办
function doTurnRecEdoc(affairId, unitId){
	var params = {
		unitId : unitId,
		opinion : document.getElementById("content").value
	}
	$s.EdocResource.doTurnRecEdoc(affairId, {}, params, errorBuilder({
		success: function (result) {
			_gotoList();
		}
	}));
}

//处理成功后返回列表
function _gotoList(){
  if(cmp.platform.CMPShell){
      //触发平台事件，用于刷新列表数据
      cmp.webViewListener.fire({
          type: "com.seeyon.m3.ListRefresh",
          data: {type: 'update'}
      });
      cmp.webViewListener.fire({
          type: "edoc.ListRefresh",
      });
  }

  //触发删除缓存
  cmp.event.trigger("deletesessioncache", document);
  
  var backN = 1;
  if(window.summaryBO && summaryBO.backIndex){
      backN = backN + summaryBO.backIndex;
  }
  
  cmp.href.back(backN);
}

function isNull(obj){
	if(obj == null || obj == "" || typeof(obj) == "undefined"){
		return true;
	}
	return false;
}



//返回上一个页面
function _goBack() {
  //异常删除点击了返回的情况, 解决微协同打开office查看，返回时页面跳转问题
  if (cmp.href.backAbnormal()) {
      return;
  }
  //防止爆点
  if (pageX.exeLock) {
      return;
  }
  pageX.exeLock = true;

  //触发删除缓存
  cmp.event.trigger("deletesessioncache", document);
  cmp.href.back();
}