/**
 * Created by liuyc on 2020/12/03.
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
        typeof define === 'function' && (define.amd || define.cmd) ? define(factory) :
            (global.SuiCustom = factory());
} (this, function () {
    'use strict';
    cmp.sui = cmp.sui || {};
    //静态API
    var api = {};
    /*以下是SuiEvent的具体实现*/

    /**
     * 自定义控件-办文依据，返回html
     * @param html, inputAttrObj, options, auth
     * @returns {string}
     */
    api.buildAccordingChmentDom = function(html,inputAttrObj, options, auth) {
        //如果是relation或者relationform，则修改__state
        if (options.fieldInfo.inputType == 'relation' || options.fieldInfo.inputType == 'relationform') {
            options.model.__state = 'modified';
        }
        inputAttrObj['value'] = options.model.text;
        inputAttrObj['readonly'] = 'true';

        html += '<div ' + cmp.sui.attrBuilder({class: 'sui-form-ctrl-value-display sui-form-ctrl-document sui-form-ctrl-attachment', id: options.fieldInfo.name}) + '>';
        //document控件 --start
        options.model.relationData = options.model.relationData || [];
        var relationData = options.model.relationData;
        options.model.attData = options.model.attData || [];
        var attData = options.model.attData;

        if (relationData.length > 0) {
            html += '<div class="document-items">';
            relationData.forEach(function(item){
                item.remoteSource = !item.remoteSource ? (cmp.util.getSeeyonPath() + '/rest/document/file/' + item.fileUrl) : item.remoteSource;
                html += '   <div class="document-item according-document-item" data-id="'+item.fileUrl+'"">';
                if (item.mimeType == 'collaboration') {
                    html += '       <i class="document-icon ' + 'see-icon-v5-form-ic-col-fill' +  '"></i>';
                } else if (item.mimeType == 'edoc') {
                    html += '       <i class="document-icon ' + 'see-icon-v5-form-ic-offdoc-fill' +  '"></i>';
                } else {
                    html += '       <i class="document-icon ' + 'see-icon-v5-form-relation-doc' +  '"></i>';
                }

                var dom = document.createElement('div');
                dom.classList.add('document-content');
                dom.classList.add('allow-click-attachment');
                dom.setAttribute('see-att-data', JSON.stringify(item));
                dom.innerHTML = item.filename;
                html += dom.outerHTML;
                if (auth == 'edit') {
                    html += '    <i class="see-icon-v5-form-close-circle-fill"></i>';
                }
                html += '   </div>';
            });
            _openAccordingDoc()
        } else {
            html += '<div class="document-items items-empty">';
        }
        html += '</div>';//items-end
        if (auth == 'edit') {
            html += '<div class="document-add-item">' + (cmp.i18n('form.document.notice') || 'Please choose relation document') +
                '		 <div class="icon-add">' +
                '           <i class="see-icon-v5-form-add"></i>' +
                '		</div>' +
                '	</div>';
        }
        if (attData.length > 0) {
            html += '<div class="attachment-items">';
            attData.forEach(function(item){
                item.remoteSource = !item.remoteSource ? (cmp.util.getSeeyonPath() + '/rest/attachment/file/' + item.fileUrl) : item.remoteSource;
                html += '   <div class="attachment-item">';
                html += '       <i class="attachment-icon ' + _FileExtensionFilter(item.extension) +  '"></i>';
                var dom = document.createElement('div');
                dom.classList.add('attachment-content');
                dom.classList.add('allow-click-attachment');
                dom.setAttribute('see-att-data', JSON.stringify(item));
                dom.innerHTML = item.filename;
                html += dom.outerHTML;
                if (auth == 'edit') {
                    html += '    <i class="see-icon-v5-form-close-circle-fill"></i>';
                }
                html += '   </div>';
            });
        } else {
            html += '<div class="attachment-items items-empty">';
        }
        html += '</div>';//items-end
        if (auth == 'edit') {
            html += '<div class="attachment-add-item">' + (cmp.i18n('form.attachment.uploadLimit') || 'Please upload file which limited as 50MB') +
                '		 <div class="icon-add">' +
                '           <i class="see-icon-v5-form-add"></i>' +
                '		</div>' +
                '	</div>';
        }

        html += '</div>';
        html += '<input ' + cmp.sui.attrBuilder(inputAttrObj) + '/>';
        //document控件 --end
        html +='</div>';

        return html
    }

    function _openAccordingDoc() {
        $("body").on("tap",".according-document-item",function(){
            cmp.href.next(_unflowform + "/html/relationList.html?date=" + (new Date().getTime()),{'summaryId':$(this).data("id")})
        });
    }

    /**
     * 自定义控件-附件，返回html
     * @param html, inputAttrObj, options, auth
     * @returns {string}
     */
    api.buildAttaChmentDom = function(html, inputAttrObj, options, auth){
        //如果是relation或者relationform，则修改__state
        if (options.fieldInfo.inputType == 'relation' || options.fieldInfo.inputType == 'relationform') {
            options.model.__state = 'modified';
        }
        inputAttrObj['value'] = options.model.value;
        inputAttrObj['readonly'] = 'true';
        inputAttrObj['class'] += ' sui-hide';
        html += '<input ' + cmp.sui.attrBuilder(inputAttrObj) + '/>';
        html += '<div ' + cmp.sui.attrBuilder({class: 'sui-form-ctrl-value-display sui-form-ctrl-attachment', id: options.fieldInfo.name}) + '>';
        //attachment控件 --start
        options.model.attData = options.model.attData || [];
        var items = options.model.attData;

        if (items.length > 0) {
            html += '<div class="attachment-items">';
            items.forEach(function(item){
                item.remoteSource = !item.remoteSource ? (cmp.util.getSeeyonPath() + '/rest/attachment/file/' + item.fileUrl) : item.remoteSource;
                html += '   <div class="attachment-item">';
                html += '       <i class="attachment-icon ' + _FileExtensionFilter(item.extension) +  '"></i>';
                var dom = document.createElement('div');
                dom.classList.add('attachment-content');
                dom.classList.add('allow-click-attachment');
                dom.setAttribute('see-att-data', JSON.stringify(item));
                dom.innerHTML = item.filename;
                html += dom.outerHTML;
                if (auth == 'edit') {
                    html += '    <i class="see-icon-v5-form-close-circle-fill"></i>';
                }
                html += '   </div>';
            });
        } else {
            html += '<div class="attachment-items items-empty">';
        }

        html += '</div>';//items-end
        if (auth == 'edit') {
            html += '<div class="attachment-add-item">' + (cmp.i18n('form.attachment.uploadLimit') || 'Please upload file which limited as 50MB') +
                '		 <div class="icon-add">' +
                '           <i class="see-icon-v5-form-add"></i>' +
                '		</div>' +
                '	</div>';
        }

        html += '</div>';
        //attachment控件 --end
        html +='</div>';
        return html
    }


    /**
     * 自定义控件-附件，返回html
     * @param html
     * @returns {string}
     */
    api.buildContentChmentDom = function(html){
        html += '<button class="cmp-btn cmp-btn-primary2 cmp-ellipsis cmp-btn-outlined" style="margin-left: 8px" id="zsyContent">查看</button>';
        _bindContentEvent();
        return html
    }

    function _bindContentEvent(){
        $("body").off('tap').on("tap","#zsyContent",function(){
            _showConent1();
        });
    }

    /**
     * 根据扩展名，返回图标class
     * @param extension
     * @returns {string}
     * @private
     */
    function _FileExtensionFilter (extension) {
        extension = (extension || '').toLowerCase();
        extension = extension.substring(extension.lastIndexOf('.') + 1);
        switch (extension) {
            case 'txt':
                return 'see-icon-v5-form-ic-txt-fill';
            case 'jpg':
            case 'png':
            case 'icon':
            case 'gif':
            case 'jpeg':
                return 'see-icon-v5-form-ic-image-fill';
            case 'doc':
            case 'docx':
                return 'see-icon-v5-form-ic-doc-fill';
            case 'xls':
            case 'xlsx':
                return 'see-icon-v5-form-ic-xls-fill';
            case 'ppt':
            case 'pptx':
                return 'see-icon-v5-form-ic-ppt-fill';
            case 'wps':
                return 'see-icon-v5-form-ic-wps-fill';
            case 'vsd':
                return 'see-icon-v5-form-ic-vsd-fill';
            case 'pdf':
                return 'see-icon-v5-form-ic-pdf-fill';
            case 'et':
                return 'see-icon-v5-form-ic-et-fill';
            case 'htm':
            case 'html':
            case 'sht':
            case 'shtm':
            case 'shtml':
            case 'asp':
            case 'aspx':
            case 'jsp':
            case 'php':
                return 'see-icon-v5-form-ic-html-fill';
            case 'mp3':
                return 'see-icon-v5-form-ic-mp3-fill';
            case 'avi':
            case 'mp4':
            case 'wmv':
            case 'rm':
            case 'rmvb':
            case 'mpg':
            case 'mkv':
            case 'flv':
                return 'see-icon-v5-form-ic-mp4-fill';
            case 'wma':
            case 'wav':
            case 'amr':
            case 'ava':
            case 'ACT':
                return 'see-icon-v5-form-ic-voice-fill';
            case 'zip':
            case 'rar':
            case 'jar':
            case '7z':
            case 'tar':
                return 'see-icon-v5-form-ic-zip-fill';
            default:
                break;
        }
        return "see-icon-v5-form-ic-unknown-fill";
    }



    /*以上是SuiEvent的具体实现*/

    api.version = '1.0.0';
    return api;

}));