function selectOrg() {
  this.scrollerCache = {}
  this.scrollerCache['selected'] = new cmp.iScroll('#dragwrap', {
    vScroll:true,
    hScroll:true,
    x: 0,
    y: 0,
    bounce: true,
    bounceLock: false,
    momentum: true,
    lockDirection: true,
    useTransform: true,
    useTransition: false,
    handleClick: true,
    special:true,
  })
}
var CMPFULLSREENHEIGHT = window.innerHeight;
//指定的dom创建iscroll
selectOrg.prototype._createScroller  = function(dom,isPP,direction) {
  var self = this;
  var id = dom.getAttribute("id");
  var scroller;
  var fullScreenHeight = CMPFULLSREENHEIGHT < window.innerHeight? window.innerHeight:CMPFULLSREENHEIGHT;
  if(isPP) {
  }else {
    var vScroll = (direction == 1)?true: false;
    var hScroll = (vScroll == true)?false : true;
    var special = true;//已选区的滚动需要做特殊处理，因为需要对图片进行拖动
    scroller = new cmp.iScroll("#"+id,{
      vScroll:vScroll,
      hScroll:hScroll,
      x: 0,
      y: 0,
      bounce: true,
      bounceLock: false,
      momentum: true,
      lockDirection: true,
      useTransform: true,
      useTransition: false,
      handleClick: true,
      special:special,
    });
  }
  return scroller;
};
selectOrg.prototype.getItemIndex = function(container,item){
  var index = 0;
  var children = container.childNodes;
  var i = 0,len = children.length;
  for(;i<len;i++){
    if(children[i] == item){
      index = i;
      break;
    }
  }
  return index;
};
selectOrg.prototype.getCoordinate = function(event, page){
  return ("ontouchstart" in window) ? event.changedTouches[0][page] : event[page];
};
selectOrg.prototype._adjustSelectedData = function(preIndex,index,data,direction){
  var self = this;
  if(direction > 0){
    preIndex += direction;
  }else {
    index += 1;
  }
  // self.selectDataCache.splice(preIndex,0,data);  //先向原数组添加指定元素
  // self.selectDataCache.splice(index,1);
};
selectOrg.prototype.getItemByIndex = function(container,index){
  return container.childNodes[index];
};
selectOrg.prototype.getItemByDistance = function (container, item, dis) {
  var index = this.getItemIndex(container, item)
  var length = container.children.length
  var targetItem = null
  var totalDis = 0
  if (dis < -5) {
    // 向左拖动
    while (index > 0) {
      if (container.children[index -1].clientWidth + totalDis + 5 > -dis) {
        targetItem = container.children[index -1];
        break
      } else {
        totalDis += container.children[index -1].clientWidth + 10
        index --
      }
    }
  } else {
    // 向右拖动
    if (dis > (5 + item.clientWidth) && index < length ) {
      while (index < length) {
        if (container.children[index + 1].clientWidth + totalDis + 5 + item.clientWidth > dis) {
          targetItem = container.children[index  + 1];
          break
        } else {
          totalDis += container.children[index -1].clientWidth + 10
          index ++
        }
      }
    }
  }
  return targetItem;
}
selectOrg.prototype._selectedItemEvent = function(basicDiv,container,item){
  var self = this;
  var drag = false;//是否可以拖动的标识（true才能拖动）
  var exchange = false;//是否进行位置交换的标识（true才能交换）
  var tipX = -3,tipY = -3;//一个长按成功的一个视觉距离
  var sX = 0,sY = 0;
  var delRang = container.offsetHeight;
  var itemWidth = 57;  //作为移动用(75是图片宽度css定好了的)
  cmp.event.click(item, function () {
    self.delByDrag(container,item);
  })
  cmp.event.touchHold(item,function(e){
    drag = true;
    sX = self.getCoordinate(e, "pageX"); //获取移动坐标
    sY = self.getCoordinate(e, "pageY");
    self.move(item,tipX,tipY,0.5,"ease-in-out");
  });
  item.addEventListener("touchmove",function(e){
    if(drag){
      self.scrollerCache["selected"].disable();
      var x =  self.getCoordinate(e, "pageX"),
        y =  self.getCoordinate(e, "pageY");
      var mx = x - sX - tipX;
      var my = y - sY - tipY;
      self.move(item,mx,my,0.5,"ease-in-out");
    }

  },false);
  item.addEventListener("touchend",function(e){
    drag = false;
    var x = self.getCoordinate(e, "pageX"),
      y =  self.getCoordinate(e, "pageY");
    var endY = y-sY;
    var endX = x -sX;
    var moveItemNum = 0;
    if(endX < 0){
      moveItemNum = Math.floor(endX/itemWidth);
    }else {
      moveItemNum = Math.round(endX/itemWidth);
    }
    exchange = container.childNodes.length > 1;
    if(endY < 0 && Math.abs(endY) >= delRang){
      self.delByDrag(container,item);
    }else {
      if(Math.abs(endY) <= item.offsetHeight/2){
        if(exchange){
          var index = self.getItemIndex(container,item);
          var targetItem = self.getItemByDistance(container,item, endX);
          if((moveItemNum < 0 && index >0 && (Math.abs(endX) >= itemWidth/2)) || (moveItemNum >= 0 && (Math.abs(endX) >= itemWidth/2)) ){
            var preIndex = index + moveItemNum;
            // var preItem = self.getItemByIndex(container,preIndex);
            var preItem = targetItem;
            var direction = 0;
            if(moveItemNum < 0){
              container.insertBefore(item,preItem);
              direction = -1;
            }else {
              var nextDom;
              if(!preItem.nextSibling) {
                nextDom = document.createElement("li");
                container.appendChild(nextDom);
              }
              container.insertBefore(item,preItem.nextSibling);
              if(nextDom) nextDom.remove();
              direction = 1;
            }
            var data = item.getAttribute("info");
            var newIndex = preIndex + direction;
            self._adjustSelectedData(preIndex,index,data,direction);//调整数据的顺序
          }
        }
      }
      self.move(item,0,0,0.5,"ease-in-out");
    }
    self.scrollerCache["selected"].enable();
    drag = false;
  },false)
};
selectOrg.prototype.getTranslate = function(x,y){
  var distX = x, distY = y;
  return ("WebKitCSSMatrix" in window && "m11" in new WebKitCSSMatrix()) ? "translate3d("+ distX +"px, "+ distY +"px, 0)" : "translate("+ distX +"px, "+ distY +"px)";
};
selectOrg.prototype.move = function(dom,x, y, timer, type){
  var self = this;
  dom.style.webkitTransitionProperty = "-webkit-transform";
  dom.style.webkitTransitionDuration = timer;
  dom.style.webkitTransitionTimingFunction = type;
  dom.style.webkitTransform = self.getTranslate(x, y);
};
selectOrg.prototype.delByDrag = function (container, item) {
  var username = item.getAttribute('username');
  var input = document.querySelector(`[checkname=${username}]`);
  if (input) {
    input.checked = false
  }
  container.removeChild(item)
  // this.scrollerCache['selected'].refresh()
}