/**
 * @module asyncLoad
 * @description 加载器 asyncLoad
 * @requireJS ["cmp-asyncLoad.js"]
 */
;(function(_){
    var asyncLoadedResourceCache = {};
    var sslRegex = /^(https:)/i;
    var sslProtocol = sslRegex.test(window.location.protocol);

    _.asyncLoad = {};
    /**
     * @method js
     * @description JS加载器
     * @createDate 2019-03-01
     * @lastModify 2019-03-02
     * @param {array} jss 需要加载的js数组
     * @param {function} callback  所有js加载完成后的回调
     * @hasDemo
     */
    _.asyncLoad.js = function(jss,callback){
        var path = [];
        for (var i = 0;i < jss.length;i++) {
            path.push(jss[ i ]);
        }
        cmp.require(path, callback, 'js');
    };

    /**
     * @method css
     * @description CSS加载器，demo
     * @createDate 2019-03-01
     * @lastModify 2019-03-02
     * @param {array} csss 需要加载的css数组
     * @hasDemo
     */
    _.asyncLoad.css = function(csss){
        cmp.require(csss, function() {}, 'css');
    }
})(cmp);