/**
 * 新的日期时间插件--依赖日历插件---只针对时间选择类型为date,dateTime,groupTime的格式--
 * varstion 1.0.5
 * by 马山 V7.1SP1
 * Houfeng@DCloud.io
 */

 /**
 * @module datePicker
 * @description 日期选择类 datePicker
 * @requireJS ["cmp-picker.js","cmp-dateCalender.js","cmp-dtPicker.js","cmp-dtPicker-calender.js"]
 * @requireCSS ["cmp-picker.css","cmp-dateCalender.css"]
 */
//配置参数：
 /**
 * @method DtPickerCalender
 * @description 日历格式的日期选择插件(弹出类选择)  cmp.DtPickerCalender(options);
 * @param {object} options 配置
 * @param {string} options.type 类型,默认：dateCalender  <isNotNull>
*  @paramTemplate options.type 1.dateCalender：日历形式的年月日的选择<br> 2.dateTimeCalender:日历形式的年月日时分的选择 <br> 3.groupTime:只选择时间(时分)
 * @param {string} options.y 默认年份  <isNotNull>
 * @param {string} options.m 默认月份  <isNotNull>
 * @param {string} options.d 默认日   <isNotNull>
 * @param {string} options.value 开始时间默认值 格式："2018-5-5";  <isNotNull>
 * @param {string} options.endValue 结束时间默认值 格式："2018-5-5";  <isNotNull>
 * @param {boolean} options.group 是否组合选择   <isNotNull>
 * @param {string} options.beginYear 自定义开始年份  <isNotNull>  
 * @param {string} options.endYear 自定义结束年份  <isNotNull>
 * @param {string} options.MinutesScale 自定义分钟数刻度  <isNotNull>
 * @param {function} options.callback 返回Object   <isNotNull>
 * @hasDemo
 * **/
//调用方式：
 /*var picker = new cmp.DtPicker(options);
 */
//回调函数：
/**
 * 方式1：picker.callback(result);//result返回Object
 * 方式2：picker.show(result);//result返回Object
 */

(function(_,document) {

    var CMP_DTPICKER_I18N_LOADED = false;
    cmp.i18n.load(cmpBASEPATH+'/i18n/', 'cmp-dtPicker',function(){
        CMP_DTPICKER_I18N_LOADED = true;
        cmp.event.trigger("cmp-dtPicker-calender-init",document);
    },cmpBuildversion);

    function DtPickerFun(options){
        if(!CMP_DTPICKER_I18N_LOADED){
            document.addEventListener("cmp-dtPicker-calender-init",function(){
                _dtPicker.init(options);
            });
        }else {
            _dtPicker.init(options);
        }
        
    }
    function targgerHide(){
        var cancelDom = document.querySelector(".cmp-dtpicker").querySelector(".cmp-poppicker-btn-cancel");
        _.event.trigger("tap",cancelDom);
    }
    
    var _dtPicker = {
        initDom:function(options){
            var header='<div class="cmp-dtpicker-header cmp-white-bg">';
            if(options.group){
                header+='<div class="cmp-segmented-control cmp-picker-groupBtn">'+
                '<nav id="startBtn" class="cmp-control-item cmp-active">'+cmp.i18n("cmp.dtPicker.start")+'</nav>'+
                '<nav id="endBtn" class="cmp-control-item">'+cmp.i18n("cmp.dtPicker.end")+'</nav>'+
                '</div>';
            }      
            header+='<button data-id="btn-cancel" class="cmp-btn cmp-poppicker-btn-cancel cmp-white-bg cmp-sup1-fc">'+cmp.i18n("cmp.dtPicker.cancel")+'</button>'+			
            '<button data-id="btn-ok" class="cmp-white-bg cmp-theme-fc cmp-btn cmp-btn-blue cmp-poppicker-btn-ok cmp-theme-fc">'+cmp.i18n("cmp.dtPicker.ok")+'</button>'+
            '</div>';
            var body='<div class="cmp-dtpicker-body">';
            //年月日容器
            var date='<div class="cmp-picker-date" id=""></div>';
            //时分容器
            var hidom='<div class=""style="position:relative;width:100%;height:100%;">'+
            '<div class="cmp-picker-hr cmp-picker-hr-top"></div><div class="cmp-picker-hr cmp-picker-hr-bottom"></div>'+
            '<div data-id="picker-h" class="cmp-picker cmp-white-bg">'+
                '<div class="cmp-picker-inner">'+
                    '<div class="cmp-pciker-rule cmp-pciker-rule-ft cmp-p-bg"></div>'+
                    '<ul class="cmp-pciker-list">'+
                    '</ul>'+
                    '<div class="cmp-pciker-rule cmp-pciker-rule-bg"></div>'+
                '</div>'+
            '</div>'+
            '<div data-id="picker-i" class="cmp-picker cmp-white-bg">'+
                '<div class="cmp-picker-inner">'+
                    '<div class="cmp-pciker-rule cmp-pciker-rule-ft cmp-p-bg"></div>'+
                    '<ul class="cmp-pciker-list">'+
                    '</ul>'+
                    '<div class="cmp-pciker-rule cmp-pciker-rule-bg"></div>'+
                '</div>'+
            '</div></div></div>';
            var dateTime='<div class="cmp-picker-dateTime cmp-before-line" id="">';
            //时分容器
            // var groupTime='<div class="cmp-picker-groupTime" id=""></div>';
            if(options.type=="dateCalender"){//选择年月日
                body=body+date;
            }else if(options.type=="dateTimeCalender"){//选择年月日时分
                body=body+date+dateTime+hidom;
            }else if(options.type=="groupTime"){//单独的选择开始和结束时间
                body=body+dateTime+hidom;
            }
            body+='</div>';
            return header+body;
        },
        init:function(options){
            var self = this;
            self.nowTime = new Date();
            var nowMoth = self.nowTime.getMonth()+1;
            var nowDay = self.nowTime.getDate();
            self.options = _.extend({
                /**
                 * type类型
                 * dateCalender：为年月日的选择
                 * dateTimeCalender：为年月日时分的选择
                 * groupTime：为时间段的选择
                 * group:组合时间选择
                 */
                y:self.nowTime.getFullYear().toString(),
                m:( nowMoth < 10)?"0"+nowMoth : nowMoth,
                d:nowDay < 10 ? "0"+nowDay : nowDay,
                type:"dateCalender",
                group:false,
                value:"",//默认值--开发者可自定义
                endValue:"",
                defTimeValue:[],//默认的时分数据
                MinutesScale:"1",
                beginYear:"1900",//开始年份--开发者可自定义
                endYear:"2099",//结束年份--开发者可自定义
                customData:"",//自定义数据--只在类型为 groupTime 才能设置
                dateSwitch:true,//是否点击日期切换按钮就切换日期
                switchMothBtn:true,//是否显示切换月视图前进后退按钮
                switchViewBtn:false,//是否显示切换周视图和月视图按钮
                showTodayBtn:false,//是否显示回到今天按钮
                showLunar:false,//是否显示农历
                showEndTime:false,//组件打开时默认显示结束时间选择
                callback:null
            },options);
            var basicDiv = document.createElement("div");
            basicDiv.className="cmp-dtpicker cmp-white-bg cmp-line";
            basicDiv.id="cmp_dtpicker_"+_.buildUUID();
            basicDiv.setAttribute("data-type",options.type);
            var html = self.initDom(options);
            basicDiv.innerHTML = html;

            var index = _.zIndex.get();
            basicDiv.style.zIndex = index+2;
            document.body.appendChild(basicDiv);
            _.backDrop.push();
            self.mask = _.backDrop.maskDom();
            _.zIndex.set(index+2);
            // self.mask = self.createMask();
            // self.mask[0].style.zIndex = index+1;
            self.basicDiv = basicDiv;
            self.basicDivBody = basicDiv.querySelector(".cmp-dtpicker-body");
            self.startBtn = basicDiv.querySelector("#startBtn");
            self.endBtn = basicDiv.querySelector("#endBtn");
            self.cancelBtn = basicDiv.querySelector(".cmp-poppicker-btn-cancel");//取消按钮
            self.okBtn = basicDiv.querySelector(".cmp-poppicker-btn-ok");//完成按钮
            self.group = options.group;
            var value = self.options.value;
            var endValue = self.options.endValue;
            if(value || endValue){
                var startH,startI,endH,endI;
                if(self.options.type=="groupTime"){
                    var parts = value.replace(":", "-").replace(" ", "-").replace(":", "-").split("-"); 
                    startH = parts[0];
                    startI = parts[1];
                    endH = parts[2];
                    endI = parts[3];
                    self.initData={
                        beginYear:null,
                        endYear:null,
                        beginTime:startH+":"+startI,
                        endTime:endH+":"+endI,
                    };
                }else{
                    var parts = value.replace(":", "-").replace(" ", "-").split("-");
                    var endParts = endValue.replace(":", "-").replace(" ", "-").split("-");
                    
                    if((parts[3]&&parts[4])||(endParts[3]&&endParts[4])){
                        startH=parts[3];
                        startI=parts[4];
                        endH=endParts[3];
                        endI=endParts[4];
                    }else{
                        startH=self.nowTime.getHours();
                        startI=self.nowTime.getMinutes();
                        endH=self.nowTime.getHours();
                        endI=self.nowTime.getMinutes();
                    }

                    self.initData={
                        beginYear:{ //初始化开始年月日
                            y:parts[0],m:parts[1],d:parts[2]
                        },
                        endYear:{ //初始化结束年月日
                            // y:self.options.y,m:self.options.m,d:self.options.d
                            y:endParts[0],m:endParts[1],d:endParts[2]
                        },
                        beginTime:self.options.defTimeValue[0] || startH+":"+startI,
                        endTime:self.options.defTimeValue[1] || endH+":"+endI,
                    };

                }
                
                self.parts = parts;
                
                
            }else{
                self.initData={
                    beginYear:{ //初始化开始年月日
                        y:self.options.y,m:self.options.m,d:self.options.d
                    },
                    endYear:{ //初始化结束年月日
                        y:self.options.y,m:self.options.m,d:self.options.d
                    },
                    beginTime:self.nowTime.getHours()+":"+self.nowTime.getMinutes(),
                    endTime:null,
                };
            }
            self.isArray = Array.isArray ||
            function (object) {
                return object instanceof Array;
            };
            self.openStartBtn=true;//默认是开始按钮开启状态
            self.dataTimeDom = self.basicDiv.querySelector(".cmp-picker-dateTime");
            _.backbutton.push(targgerHide);
            self.initStyle(self.options,basicDiv);
            self.openShow();
            self.event();
        },
        initStyle:function(options,basicDiv){
            var self = this;
            var type = options.type;
            self.calenderDom = basicDiv.querySelector(".cmp-picker-date");
            if(type=="dateCalender" || type == "dateTimeCalender"){
                if(self.parts){
                    options.y=self.parts[0];
                    options.m=self.parts[1];
                    options.d=self.parts[2];
                }
                if(options.m[0]=="0"){
                    options.m = options.m[1];
                }
                if(options.d[0]=="0"){
                    options.d=options.d[1];
                }
                options.y = JSON.parse(options.y);
                options.m = JSON.parse(options.m);
                options.d = JSON.parse(options.d);
                self.initCalender = self.initCalenderFun(self.calenderDom,options,function(resData){
                    console.log(resData);
                    // var data = cmp.toJSON(resData);
                    var parts = resData.value.replace(":", "-").replace(" ", "-").replace(":", "-").split("-"); 
                    if(self.openStartBtn){ //记录选择的开始和结束时间
                        self.initData.beginYear = {
                            y:parts[0],m:parts[1],d:parts[2]
                        };
                    }else{
                        self.initData.endYear = {
                            y:parts[0],m:parts[1],d:parts[2]
                        };
                    }
                });
                //有时分类型，需要渲染时分选择容器
                if(type == "dateTimeCalender"){
                    if(self.dataTimeDom){
                        var createTimeText = document.createElement("div");
                        createTimeText.className="cmp-picker-text cmp-sup-fc1";
                        createTimeText.innerHTML=cmp.i18n("cmp.dtPicker.time");
                        self.dataTimeDom.appendChild(createTimeText);
                        var createTimeColon = document.createElement("div");
                        createTimeColon.className="cmp-picker-colon cmp-main-fc";
                        createTimeColon.innerHTML=":";
                        self.dataTimeDom.appendChild(createTimeColon);
                        if(self.options.type=="dateTimeCalender" || self.options.type=="groupTime"){
                            cmp('[data-id*="picker"]', self.dataTimeDom).picker();
                            var pickerh = cmp('[data-id="picker-h"]', self.dataTimeDom)[0];
                            var pickeri = cmp('[data-id="picker-i"]', self.dataTimeDom)[0];
                            self.ui={
                                h:pickerh,
                                i:pickeri
                            }
                            self._createHours();
                            self._createMinutes(self.options.MinutesScale);
                            self._setSelectedValue(self.initData.beginTime);
                            var newTimePickerHeight = 130;
                            self.dataTimeDom.style.height = newTimePickerHeight+"px";
                            pickerh.style.height = newTimePickerHeight+"px";
                            pickeri.style.height = newTimePickerHeight+"px";
                        }
                    }
                }
            }else if(type=="groupTime"){
                if(self.dataTimeDom){
                    if(self.options.type=="dateTimeCalender" || self.options.type=="groupTime"){
                        cmp('[data-id*="picker"]', self.dataTimeDom).picker();
                        var pickerh = cmp('[data-id="picker-h"]', self.dataTimeDom)[0];
                        var pickeri = cmp('[data-id="picker-i"]', self.dataTimeDom)[0];
                        self.ui={
                            h:pickerh,
                            i:pickeri
                        }
                        self._createHours();
                        self._createMinutes(self.options.MinutesScale);
                        self._setSelectedValue(self.initData.beginTime);
                    }
                }
            }
            if(self.options.group && self.options.showEndTime){//组合搜索，同时默认显示结束时间的话
                self.refreshEndTime(self.endBtn);
            }
        },
        createMask : function(callback) {
            var self = this;
            var element = document.createElement('div');
            element.classList.add('cmp-backdrop');
            element.addEventListener('touchmove', cmp.preventDefault);
            element.addEventListener('tap', function() {
                mask.close();
            });
            var mask = [element];
            mask._show = false;
            mask.show = function() {
                mask._show = true;
                element.setAttribute('style', 'opacity:1');
                document.body.appendChild(element);
                return mask;
            };
            mask._remove = function() {
                if (mask._show) {
                    mask._show = false;
                    element.setAttribute('style', 'opacity:0');
                    self.later(function() {
                        var body = document.body;
                        element.parentNode === body && body.removeChild(element);
                    }, 350);
                }
                return mask;
            };
            mask.close = function() {
                if (callback) {
                    if (callback() !== false) {
                        mask._remove();
                    }
                } else {
                    mask._remove();
                }
            };
            return mask;
        },
        later : function (fn, when, context, data) {
            var self = this;
            when = when || 0;
            var m = fn;
            var d = data;
            var f;
            var r;
    
            if (typeof fn === 'string') {
                m = context[fn];
            }
    
            f = function () {
                m.apply(context, self.isArray(d) ? d : [d]);
            };
    
            r = setTimeout(f, when);
    
            return {
                id: r,
                cancel: function () {
                    clearTimeout(r);
                }
            };
        },

        initCalenderFun:function(dom,options,callback){
            var opt = {
                y:options.y,  //设置年
                m:options.m,  //设置月
                d:options.d, //设置日
                type:"month",  //插件类型，有week周视图，month月视图
                // orderD: ["2016-12-22", "2016-12-26"],  //哪些天被预定
                beginYear:options.beginYear, //开始年
                endYear:options.endYear, //结束年
                // uichangeToCallback:true,//是否只要ui改变了就要回调函数
                switchMothBtn:options.switchMothBtn,//是否显示切换月视图前进后退按钮,默认true
                switchViewBtn:options.switchViewBtn,//是否显示切换周视图和月视图按钮,默认false
                showTodayBtn:options.showTodayBtn,//是否显示回到今天按钮,默认false
                showLunar:options.showLunar,//是否显示农历,默认false
                callback: function (date) {
                    callback && callback(date);
                    // document.querySelector("#showData").innerHTML = cmp.toJSON(date);
                }
            };
            return cmp.DateCalender(dom, opt);
        },
        _fill: function(num) {
            num = num.toString();
            if (num.length < 2) {
                num = 0 + num;
            }
            return num;
        },
        _setSelectedValue: function(value) {
            var self = this;
            var ui = self.ui;
            var parsedValue = self._parseValue(value);
            ui.h.picker.setSelectedValue(parsedValue.h, 0);
            ui.i.picker.setSelectedValue(parsedValue.i, 0);
        },
        _parseValue: function(value) {
            var self = this;
            var rs = {};
            var type=self.options.type;
            var now = new Date();
            if (value) {
                var parts;
                parts = value.replace(":", "-").replace(" ", "-").split("-");
                rs.h = parts[0] || now.getHours();
                rs.i = parts[1] || now.getMinutes();
            } else {
                rs.h = now.getHours();
                rs.i = now.getMinutes();
            }
            return rs;
        },
        //生成时列表
        _createHours: function(current) {
            var self = this;
            var options = self.options;
            var ui = self.ui;
            var hArray = [];
            if(options){
                if(typeof options.customData != "undefined"){
                    if (options.customData.h) {
                        hArray = options.customData.h;
                    }else {
                        for (var h = 0; h <= 23; h++) {
                            var val = self._fill(h);
                            hArray.push({
                                text: val+ ''+cmp.i18n("cmp.dtPicker.hours"),
                                value: val
                            });
                        }
                    }
                }
            }
            ui.h.picker.setItems(hArray);
        },
        //生成分列表
        _createMinutes: function(current) {
            var self = this;
            var options = self.options;
            var ui = self.ui;
            var iArray = [];
            if(options){
                if(typeof options.customData != "undefined"){
                    if (options.customData.i) {
                        iArray = options.customData.i;
                    }else {
                        if(current){
                            var num = parseInt(current);
                            if(num > 30){
                                num = 30;
                            }else if(num < 1){
                                num = 1;
                            }
                            for (var m = 0; m <= 59; m+=num) {
                                var val2 = self._fill(m);
                                iArray.push({
                                    text: val2 + ''+cmp.i18n("cmp.dtPicker.minutes"),
                                    value: val2
                                });
                            }
                        }else{
                            for (var i = 0; i <= 59; i++) {
                                var val = self._fill(i);
                                iArray.push({
                                    text: val + ''+cmp.i18n("cmp.dtPicker.minutes"),
                                    value: val
                                });
                            }
                        }

                    }
                }
            }
            ui.i.picker.setItems(iArray);
        },
        _getSelected: function() {
            var self = this;
            var ui = self.ui;
            var selected = {
                value:null,
                text:null,
                h: ui.h.picker.getSelectedItem(),
                i: ui.i.picker.getSelectedItem(),
                toString: function() {
                    return this.value;
                }
            };
            if(selected){
                if(selected.h && selected.i){
                    if(selected.h.value || selected.i.value){
                        selected.value = selected.h.value + ':' + selected.i.value;
                        selected.text = selected.h.text + ':' + selected.i.text;
                    }
                }
            }
            return selected;
        },
        event:function(){
            var self = this;
            if(self.startBtn){ //开始时间按钮
                self.startBtn.addEventListener("tap",function(e){
                    e.stopPropagation();
                    if(self.openStartBtn)return;
                    self.endBtn.classList.remove("cmp-active");
                    this.classList.add("cmp-active");
                    self.openStartBtn=true;
                    var type = self.options.type;
                    if(self.initCalender && (type=="dateCalender"||type=="dateTimeCalender")){
                        var m=self.initData.beginYear.m;
                        var d=self.initData.beginYear.d;
                        if(m[0]=="0"){
                            m=m[1];
                        }
                        if(d[0]=="0"){
                            d=d[1];
                        }
                        var options={
                            type:"month",
                            y:JSON.parse(self.initData.beginYear.y),
                            m:JSON.parse(m),
                            d:JSON.parse(d)
                        }
                        self.initCalender.refresh(options);
                    }
                    if(type!="dateCalender"){
                        var time = self._getSelected();//获取当前时间
                        self.initData.endTime = time.value;//记录结束时间
                        self._setSelectedValue(self.initData.beginTime);
                    }
                },false);
            }
            if(self.endBtn){  //结束时间按钮
                self.endBtn.addEventListener("tap",function(e){
                    e.stopPropagation();
                    self.refreshEndTime(this);
                },false);
            }
            //点击背景 self.mask[0]
            self.mask.addEventListener("tap",function(e){
                e.stopPropagation();
                _.zIndex.set(_.zIndex.get()-2);
                _.backDrop.pop();
                self.hide();
            },false);
            //点击取消按钮
            self.cancelBtn.addEventListener("tap",function(e){
                e.stopPropagation();
                _.zIndex.set(_.zIndex.get()-2);
                _.backDrop.pop();
                self.hide();
            },false);
            //点击完成按钮
            self.okBtn.addEventListener("tap",function(e){
                e.stopPropagation();
                _.zIndex.set(_.zIndex.get()-2);
                _.backDrop.pop();
                var call = self.options.selfDtpicker || self.options;
                call.callback && call.callback(self.callDataBack(true));
                self.hide();
            },false);

        },
        //刷新结束时间
        refreshEndTime:function(event){
            var self = this;
            if(!self.openStartBtn)return;
            self.startBtn.classList.remove("cmp-active");
            event.classList.add("cmp-active");
            self.openStartBtn=false;
            var type = self.options.type;
            if(self.initCalender && (type=="dateCalender"||type=="dateTimeCalender")){
                var m=self.initData.endYear.m;
                var d=self.initData.endYear.d;
                if(m[0]=="0"){
                    m=m[1];
                }
                if(d[0]=="0"){
                    d=d[1];
                }
                var options={
                    type:"month",
                    y:JSON.parse(self.initData.endYear.y),
                    m:JSON.parse(m),
                    d:JSON.parse(d)
                }
                //刷新日历选择
                self.initCalender.refresh(options);
            }
            if(type!="dateCalender"){
                // 刷新时间选择
                var time = self._getSelected();//获取当前时间
                self.initData.beginTime=time.value; //记录开始时间
                if(!self.initData.endTime){
                    if(self.options.value){
                        self.initData.endTime = self.options.value;
                    }else{
                        var minutes = self.nowTime.getMinutes();
                        var hours = self.nowTime.getHours();
                        minutes = minutes<10?"0"+minutes:minutes;
                        hours = hours<10?"0"+hours:hours;
                        self.initData.endTime = hours+":"+minutes;
                    }
                }
                self._setSelectedValue(self.initData.endTime);
            }
        },
        callDataBack:function(isShow){
            var self = this;
            var callData=self.initData;
            var type = self.options.type;
            if(type!="dateCalender"){
                var time = self._getSelected();
                if(self.openStartBtn || !callData.beginTime){
                    callData.beginTime = time.value;
                }
                if(!self.openStartBtn || !callData.endTime){
                    callData.endTime = time.value;
                }
            }
            if(!self.group){
                callData.endYear=null;
                callData.endTime=null;
            }
            
            switch(type){
                case "dateCalender":
                    callData.beginTime=null;
                break;
                case "dateTimeCalender":

                break;
                case "groupTime":
                    callData.beginYear=null;
                    callData.endYear=null;
                break;
            }
            var y=callData.beginYear?callData.beginYear.y:null;
            var m=callData.beginYear?callData.beginYear.m:null;
            var d=callData.beginYear?callData.beginYear.d:null;
            var h=time?time.h.value:null;
            var i=time?time.i.value:null;
            var value = "",text="";
            if(self.options.type=="dateTimeCalender"){
                text = y+"年"+m+"月"+d+"日"+h+"时"+i+"分";
                value = y+"-"+m+"-"+d+" "+h+":"+i;
            }else{
                if(self.options.type=="groupTime"){
                    text= h+"时"+i+"分";
                    value = h+":"+i;
                }else{
                    text= y+"年"+m+"月"+d+"日";
                    value = y+"-"+m+"-"+d;
                }
                
            }
            var callDataCustom = {
                y:{text:y+"年",value:y},//年月日时分
                m:{text:m+"月",value:m},
                d:{text:d+"日",value:d},
                h:{text:h+"时",value:h},
                i:{text:i+"分",value:i},
                text:text,
                value:value,
                type:self.options.type,
                beginTime:callData.beginTime,
                endTime:callData.endTime,
                beginData:{text:y+"年"+m+"月"+d+"日",value:y+"-"+m+"-"+d}
            };
            if(callData.endYear){
                callDataCustom.endData={
                    text:callData.endYear.y+"年"+callData.endYear.m+"月"+callData.endYear.d+"日",
                    value:callData.endYear.y+"-"+callData.endYear.m+"-"+callData.endYear.d
                }
            }else{
                callDataCustom.endData=null;
            }
            
            if(isShow){
                return callDataCustom;
            }else{
                // self.options.callback && self.options.callback(callDataCustom);
            }
            // self.hide();
        },
        openShow:function(){
            var self = this;
            self.basicDiv.classList.add("cmp-active");
            // self.mask.show();
        },
        show:function(){
            var self = this;
            var reslutData = self.callDataBack(true);
            return reslutData;
        },
        hide:function(){
            var self = this;
            if(self.basicDiv){
                self.basicDiv.classList.remove("cmp-active");
                // self.mask.close();
                self.basicDiv && self.basicDiv.remove();
                self.basicDiv=null;
                self=null;
                _.backbutton.pop();
            }
        }
    };

    _.DtPickerCalender = function(options){
        return DtPickerFun(options);
    }


})(cmp,document);

