
;(function($) {
    $.life('sharePage', {

        $i18n: [{
            i18nPath: 'http://cmp/v1.0.0/i18n/',
            moduleName: 'cmp-im-select'
        }],

        $components: [
            'cmp-attachment',
        ],

        //cmp ready
        $onloaded: function() {
            this.showProgress("0.01");
            document.title = $.i18n('cmp.sharePage.outShare');
        },

        //组件挂载完毕
        $mounted: function() {
            var _param = this.pageParam,
                type = _param.params.type,
                appId = _param.appId;
            this.fileUpload(function(attachments) {
                $cmp('.cmp-progress-wbox').hide();
                $.href.next = $.href.replaceNode;
                $.api.openAppByApi({
                    appId: appId,
                    openApi: 'openApp',
                    action: 'thirdAppShareToM3File',
                    params: {
                        data: {
                            type: type,
                            atts: attachments
                        }
                    },
                    from: 'outShare'
                });
            });
        },

        methods: {

            //上传附件
            fileUpload: function(callback) {
                var files = this.pageParam.params.paths,
                    fileListArray = [],
                    ret = [];
                for(var i = 0,len = files.length;i < len;i++) {
                    var itemFile = files[ i ];
                    var obj = {
                        filepath:itemFile,
                        fileId: Math.floor(Math.random() * 100000000000) + ''
                    }
                    fileListArray.push(obj);
                };
                var uploadObj = {
                    url:cmp.origin + "/rest/attachment?option.n_a_s=1",
                        fileList:fileListArray,
                        isMultiple:true
                    }
                var self = this;
                var tCount = fileListArray.length;
                // 把每个附件上传进度分别存储
                var posMap = {};
                cmp.sdk.fileUpload(uploadObj,function(res){
                    typeof res === 'string' && (res = JSON.parse(res));
                    var fileId = res.fileId;
                    posMap[fileId] = res.pos;
                    // 获取posMap所有文件进度
                    var t = 0;
                    for(var key in posMap){
                        t += posMap[key];
                    }
                    var pos = t / tCount;
                    self.showProgress(pos);
                    if(res.pos == 1){
                        ret = ret.concat(JSON.parse(res.response).atts);
                        ret.length === fileListArray.length && callback && callback(ret);
                    }
                },function(res){
                    cmp.notification.toast(ret.message || '上传异常,没有返回任何异常')
                });
            },
            showProgress :function (p) {
                var uploadTxt = cmp.i18n('cmp.sharePage.uploading');
                var progress = Math.ceil(p *100)+"%";
                $cmp(".cmp-share-progress").css("width",progress);
                var progressText = uploadTxt + "（"+progress+"）";
                $cmp(".progress-text").html(progressText);
            }
        }
    })
})(cmp);