
;(function($) {
    $.life('page', {

        $i18n: [{
            i18nPath: 'http://cmp/v1.0.0/i18n/',
            moduleName: 'cmp-im-select'
        }],

        $components: [
            //关联文档
            'accdoc',
            //选人组件
            'selectOrg'
        ],

        //cmp ready
        $onloaded: function() {
            $.dialog.loading(true);
        },

        //组件挂载完毕
        $mounted: function() {
            $.dialog.loading(false);
            this.init();
        },

        methods: {
            init: function() {
                var param = this.pageParam || {},
                    maxSize = param.max || 1;
                this[ param.type + 'Handle'](maxSize);
                $.backbutton.push(cmp.href.back);
            },

            //关联文档
            accdocHandle: function(maxSize) {
                var _this = this;
                this.accDoc = cmp.accDoc("accDoc_Id",{
                    fillbackData: null,
                    maxSize: maxSize,
                    //点击OK时不关闭
                    forbiddenClose: true,
                    callback:function(ret){
                        ret = JSON.parse(ret);
                        //判断长度，没选择则弹出提示
                        if (ret.length === 0) { return $.notification.toast(_this.getI18n('cmp.imselect.noChose'), 'center', 2000);}
                        _this.showPermissionDia(ret, function(val) {
                            val.result !== '-1' && _this.sendMsg(_this.formatAccDocData(ret, val.result));
                        });
                        
                    },
                    closeCallback:function(){
                        console.log('close');
                        $.href.back();
                    }
                });
                setTimeout(function() {
                    if ($cmp('.cmp-accDoc-basicDiv-show').length === 0) {
                        cmp.backbutton.push(cmp.href.back);
                    }
                }, 1000);
            },

            showPermissionDia: function(data, cb) {
                // for (var i = 0;i < data.length;i++) {
                //     var item = JSON.parse(data[ i ]);
                //     if (item.appId == '1' || item.appId == '4') {
                //         return $.api.showFlowPermissionDialog(cb);
                //     }
                // }
                cb('1');
            },

            //选人
            memberHandle: function(maxSize) {
                var _this = this
                cmp.selectOrg('member_Id', {
                    type : 2,
                    // flowType:2,
                    showBusinessOrganization : true,//开启多维组织
                    lightOptsChange : true,// 轻表单模式选人
                    fillBackData : [],
                    //excludeData : config.excludeData || [],
                    //disable:true,
                    jump : false,
                    permission : true,
                    lightMemberPermission : true,
                    label : ["dept","org","post","team","extP"],
                    maxSize : maxSize,
                    flowOptsChange : true,
                    minSize : 1,
                    accountID : "", // 轻表单需要传当前登录人员的单位ID
                    selectType : 'member',
                    title : '',
                    closeCallback: function() {
                        cmp.href.back();
                    },
                    callback : function(ret) {
                        _this.sendMsg(_this.formatMemberData(JSON.parse(ret)));
                    }
                });
            },

            //h5app
            h5AppHandle: function(maxSize) {
                cmp.href.next = cmp.href.replaceNode;
                cmp.api.openAppByApi({
                    appId: this.pageParam.appId || '',
                    openApi: 'IMSelectPage',
                    params: {
                        maxSize: maxSize
                    },
                    from: ''
                })
            },

            formatMemberData: function(data) {
                data = data.orgResult;
                console.log(data);
                var ret = [];
                for (var i = 0;i < data.length;i++) {
                    var item = data[ i ];
                    ret.push({
                        title: item.name || '',
                        id: item.id || '',
                        post: item.post || '',
                        dept: item.department || ''
                    });
                }
                return ret;
            },

            formatAccDocData: function(data, isForward) {
                var ret = [];
                for (var i = 0;i < data.length;i++) {
                    var item = JSON.parse(data[ i ]),
                        dataItem = {
                            linkParams: item.linkParams || '{}',
                            messageCategory: item.appId || '',
                            //OA-216377【M3-发送关联文档】发送协同公文到致信中，默认允许流程外人员查看(原值默认是0，改为默认为1)
                            isForward: isForward === undefined ? '1' : isForward
                        };
                    dataItem.id = item.id || (item.summary ? item.summary.summaryId : '');
                    if (item.appId === '1') { dataItem.id = item.summaryId; }
                    ret.push(dataItem);
                }
                return ret;
            },

            //send msg
            sendMsg: function(data) {
                console.log(data);
                cmp.sdk.setIMSelectResult({
                    type: this.pageParam.type,
                    data: data
                }, function() {
                    $.href.back();
                }, function(e) {
                    console.log(e);
                });
            }
        }
    })
})(cmp);
