﻿
'use strict';
require.config({//已校验
    baseUrl: './lib',
    paths: {
        domReady: 'requirejs/domReady',
        // light7: 'light7/js/light7',
        light7: 'light7/js/light7.min',
        i18n: 'requirejs/i18n',
        // jquery: 'jquery/jquery',
        jquery: 'jquery/jquery.min',
        // 'jquery-json': 'jquery-json/jquery.json',
        'jquery-json': 'jquery-json/jquery.json.min',
        // 'jquery-ui': 'jquery-ui/jquery-ui',
        'jquery-ui': 'jquery-ui/jquery-ui.min',
        'jquerycityselect':'jquerycityselect/jquerycityselect.min',
        'jqueryCityData':'jquerycityselect/city.min',
        jsrsasign: 'jsrsasign/jsrsasign-latest-all-min.min',
        // jsrender: 'jsrender/jsrender',
        jsrender: 'jsrender/jsrender.min',
        // knockout: 'knockout/knockout.debug',
        knockout: 'knockout/knockout',
        // komapping: 'knockout/knockout.mapping.debug',
        komapping: 'knockout/knockout.mapping',
        // 'knockout.validation': 'knockout-validation/knockout.validation',
        'knockout.validation': 'knockout-validation/knockout.validation.min',
        'knockout.validation.zh': 'knockout-validation/localization/zh-CN',
        // moa: '../app/js/config',
         moa: '../app/js/config',
        // moment: 'moment/moment',
        moment: 'moment/moment.min',
        ncsPage: 'ncs/components/ncsPage',
        // ncsPage: 'ncs/components/ncsPage.min',
        ncsNewPage:'ncs/components/ncsNewPage',
        swiper: 'swiper/js/swiper.jquery.umd',
        // store2: 'store2/store2',
        swiper2:'swiper2/js/swiper-3.4.0.jquery.min',
        store2: 'store2/store2.min',
        text: 'requirejs/text',
        urijs: 'urijs/URI.min',
        // 'crypto-js': 'crypto-js/crypto-js',
        'crypto-js': 'crypto-js/crypto-js.min',
        cometd: 'cometd',
        'jquery.cometd': 'jquery/jquery.cometd',
        'jquery.cometd-ack': 'jquery/jquery.cometd-ack',
        'jquery.cometd-binary': 'jquery/jquery.cometd-binary',
        'jquery.cometd-reload': 'jquery/jquery.cometd-reload',
        'jquery.cometd-timestamp': 'jquery/jquery.cometd-timestamp',
        'jquery.cometd-timesync': 'jquery/jquery.cometd-timesync',
        // layui: 'layui/layui-es',
        'layui':'layui-v2.4.5/layui/layui',
        pinchzoom: 'pinchzoom/pinchzoom',
        ncs: 'ncs',
        'richfit':'ruixinopenapi/RuixinOpenAPI.min',
        // 'richfit':'http://e.cnpc.com.cn:66/js/api/RuixinOpenAPI',
        'cityPicker':'light7/js/light7-city-picker.min',
        'rollTime':'selectTime/js/rolldate.min',
        ncsNonFlowPage:'ncs/components/ncsNonFlowPage',
        ncsCalendar:'../app/api/calendarApi.min',
        ncsFAB:'../app/api/fabApi'
        
    },
    waitSeconds:0,
    deps: ['knockout', 'komapping'],
    callback: function(ko, komapping) {
        ko.mapping = komapping;
    },
    shim: {
        jsrender: {
            deps: ['jquery']
        },
        light7: {
            deps: ['jquery'],
            init: function($) {
                return $;
            }
        },
        layui: {
            exports: 'layui'
        }
        
    }
});

require(['moa', 'light7', 'knockout',  'jsrsasign', 
        'store2', "ncsCalendar"
    ],
    function(moa, light7, ko, jsarsasign, store,ncsCalendar) {
        ko.components.register('ncs-text', {
            viewModel: { require: 'ncs/components/ncsText' },
            template: { require: 'text!ncs/components/ncsText.html' }
        });
        ko.components.register('ncs-time', {
            viewModel: { require: 'ncs/components/ncsTime' },
            template: { require: 'text!ncs/components/ncsTime.html' }
        });
        ko.components.register('ncs-date', {
            viewModel: { require: 'ncs/components/ncsDate' },
            template: { require: 'text!ncs/components/ncsDate.html' }
        });
        ko.components.register('ncs-datetime', {
            viewModel: { require: 'ncs/components/ncsDateTime' },
            template: { require: 'text!ncs/components/ncsDateTime.html' }
        });
        ko.components.register('ncs-textarea', {
            viewModel: { require: 'ncs/components/ncsTextarea' },
            template: { require: 'text!ncs/components/ncsTextarea.html' }
        });
        ko.components.register('ncs-email', {
            viewModel: { require: 'ncs/components/ncsEmail' },
            template: { require: 'text!ncs/components/ncsEmail.html' }
        });
        ko.components.register('ncs-sign', {
            viewModel: { require: 'ncs/components/ncsSign' },
            template: { require: 'text!ncs/components/ncsSign.html' }
        });
        ko.components.register('ncs-signtime', {
            viewModel: { require: 'ncs/components/ncsSignTime' },
            template: { require: 'text!ncs/components/ncsSignTime.html' }
        });
        ko.components.register('ncs-short', {
            viewModel: { require: 'ncs/components/ncsShort' },
            template: { require: 'text!ncs/components/ncsShort.html' }
        });
        ko.components.register('ncs-int', {
            viewModel: { require: 'ncs/components/ncsInt' },
            template: { require: 'text!ncs/components/ncsInt.html' }
        });
        ko.components.register('ncs-long', {
            viewModel: { require: 'ncs/components/ncsLong' },
            template: { require: 'text!ncs/components/ncsLong.html' }
        });
        ko.components.register('ncs-float', {
            viewModel: { require: 'ncs/components/ncsFloat' },
            template: { require: 'text!ncs/components/ncsFloat.html' }
        });
        ko.components.register('ncs-double', {
            viewModel: { require: 'ncs/components/ncsDouble' },
            template: { require: 'text!ncs/components/ncsDouble.html' }
        });
        //下拉框控件
        ko.components.register('ncs-select', {
            viewModel: { require: 'ncs/components/ncsSelect' },
            template: { require: 'text!ncs/components/ncsSelect.html' }
        });
        ko.components.register('ncs-checkbox', {
            viewModel: { require: 'ncs/components/ncsCheckBox' },
            template: { require: 'text!ncs/components/ncsCheckBox.html' }
        });
        ko.components.register('ncs-radio', {
            viewModel: { require: 'ncs/components/ncsRadio' },
            template: { require: 'text!ncs/components/ncsRadio.html' }
        });
        ko.components.register('ncs-attach', {
            viewModel: { require: 'ncs/components/ncsAttach' },
            template: { require: 'text!ncs/components/ncsAttach.html' }
        });
        ko.components.register('ncs-title', {
            viewModel: { require: 'ncs/components/ncsTitle' },
            template: { require: 'text!ncs/components/ncsTitle.html' }
        });
        ko.components.register('ncs-zw', {
            viewModel: { require: 'ncs/components/ncsZw' },
            template: { require: 'text!ncs/components/ncsZw.html' }
        });
        ko.components.register('ncs-peoplepicker', {
            viewModel: { require: 'ncs/components/ncsPeoplePicker' },
            template: { require: 'text!ncs/components/ncsPeoplePicker.html' }
        });
        //文号控件
        ko.components.register('ncs-docnumber', {
            viewModel: { require: 'ncs/components/ncsDocNumber' },
            template: { require: 'text!ncs/components/ncsDocNumber.html' }
        });
        //意见控件
        ko.components.register('ncs-opinion', {
            viewModel: { require: 'ncs/components/ncsOpinion' },
            template: { require: 'text!ncs/components/ncsOpinion.html' }
        });
        ko.components.register('ncs-basis', {
            viewModel: { require: 'ncs/components/ncsBasis' },
            template: { require: 'text!ncs/components/ncsBasis.html' }
        });
        ko.components.register('ncs-v4zw', {
            viewModel: { require: 'ncs/components/ncsV4Zw' },
            template: { require: 'text!ncs/components/ncsV4Zw.html' }
        });
        ko.components.register('ncs-zlczw', {
            viewModel: { require: 'ncs/components/ncszlczw' },
            template: { require: 'text!ncs/components/ncszlczw.html' }
        });
        ko.components.register('ncs-newtext', {
            viewModel: { require: 'ncs/components/ncsNewText' },
            template: { require: 'text!ncs/components/ncsNewText.html' }
        });
        ko.components.register('ncs-newphone', {
            viewModel: { require: 'ncs/components/ncsNewPhone' },
            template: { require: 'text!ncs/components/ncsNewPhone.html' }
        });
        ko.components.register('ncs-rx-attach', {
            viewModel: { require: 'ncs/components/ncsRxAttach' },
            template: { require: 'text!ncs/components/ncsRxAttach.html' }
        });
        ko.components.register('ncs-rx-zwattach', {
            viewModel: { require: 'ncs/components/ncsRxZWattach' },
            template: { require: 'text!ncs/components/ncsRxZWattach.html' }
        });
        //审批意见控件
        ko.components.register('ncs-show-opinion', {
            viewModel: { require: 'ncs/components/ncsShowOpinion' },
            template: { require: 'text!ncs/components/ncsShowOpinion.html' }
        });
        //传阅意见控件
        ko.components.register('ncs-cy-opinion', {
            viewModel: { require: 'ncs/components/ncsChuanyOpinion' },
            template: { require: 'text!ncs/components/ncsChuanyOpinion.html' }
        });
        ko.components.register('ncs-bwyj-fj', {
            viewModel: { require: 'ncs/components/ncsBasisV2' },
            template: { require: 'text!ncs/components/ncsBasisV2.html' }
        });
        
        ko.components.register('ncs-applicant-select', {
            viewModel: { require: 'ncs/components/ncsApplicantSelect' },
            template: { require: 'text!ncs/components/ncsApplicantSelect.html' }
        });
        ko.components.register('ncs-leader-select', {
            viewModel: { require: 'ncs/components/ncsLeaderSelect' },
            template: { require: 'text!ncs/components/ncsLeaderSelect.html' }
        });
        ko.components.register('ncs-img-uploading', {
            viewModel: { require: 'ncs/components/ncsImgUploading' },
            template: { require: 'text!ncs/components/ncsImgUploading.html' }
        });
        //请假下拉框
        ko.components.register('ncs-qj-select', {
            viewModel: { require: 'ncs/components/ncsQJSelect' },
            template: { require: 'text!ncs/components/ncsQJSelect.html' }
        });

        //请假下拉框
        ko.components.register('ncs-rolldate', {
            viewModel: { require: 'ncs/components/ncsRolldate' },
            template: { require: 'text!ncs/components/ncsRolldate.html' }
        });

        ko.components.register('ncs-contact', {
            viewModel: { require: 'ncs/components/ncsContact' },
            template: { require: 'text!ncs/components/ncsContact.html' }
        });
        ko.components.register('ncs-hb-select', {
            viewModel: { require: 'ncs/components/ncsHBanSelect' },
            template: { require: 'text!ncs/components/ncsHBanSelect.html' }
        });

        ko.components.register('ncs-select-new', {
            viewModel: { require: 'ncs/components/ncsSelectNew' },
            template: { require: 'text!ncs/components/ncsSelectNew.html' }
        });

        ko.components.register('ncs-destination', {
            viewModel: { require: 'ncs/components/ncsDestination' },
            template: { require: 'text!ncs/components/ncsDestination.html' }
        });

        ko.components.register('ncs-combobox', {
            viewModel: { require: 'ncs/components/ncsComboBox' },
            template: { require: 'text!ncs/components/ncsComboBox.html' }
        });
    
        ko.components.register('ncs-header', {
            viewModel: { require: 'ncs/components/ncsHeader' },
            template: { require: 'text!ncs/components/ncsHeader.html' }
        });
        ko.components.register('ncs-number-text', {
            viewModel: { require: 'ncs/components/ncsNumberText' },
            template: { require: 'text!ncs/components/ncsNumberText.html' }
        });
    
    
        //系统出始化入口
        var settings = {
            messageServer: messageServer,
            server: server,
            host: host,
            contextPath: contextPath,
            realPath:realPath,
            flowPages: {
                'demoPage': 'demoPage.html',
                'FLOW_OAV2_FW_JTW':'FLOW_OAV2_FW_JTW.html',         //集团文
                'FLOW_OAVW_LDGBQJ':'FLOW_OAVW_LDGBQJ.html',         //重要事项报告
                'FLOW_OAV2_FW_CPJN':'FLOW_OAV2_FW_CPJN.html',       //呈批件
                'FLOW_OAV2_FW_DZWJ':'FLOW_OAV2_FW_DZWJ.html',        //党群文件
                'FLOW_OAV2_FW_BMW':'FLOW_OAV2_FW_BMW.html',          //部门文件
                'FLOW_OAV2_FW_GZTZX':'FLOW_OAV2_FW_GZTZX.html',      //工作通知
                'FLOW_OAV2_BMW_CQDSHYJY':'FLOW_OAV2_BMW_CQDSHYJY.html',  //专门文件
                'FLOW_OAV2_FW_CPJ_CWBM':'FLOW_OAV2_FW_CPJ_CWBM.html',   //呈批件（财务部门）
                'FLOW_OAV2_FW_JJFWH':'FLOW_OAV2_FW_JJFWH.html',       //纪检发文(函)
                'FLOW_OAV2_FW_GSRMW':'FLOW_OAV2_FW_GSRMW.html',       //公司任免文
                'FLOW_OAV2_FW_QYDT':'FLOW_OAV2_FW_QYDT.html',         //企业动态
                'FLOW_OAV2_FW_GSWJKT':'FLOW_OAV2_FW_GSWJKT.html',     //公司文件(勘探)
                'FLOW_OAV2_HYJY_GFBG':'FLOW_OAV2_HYJY_GFBG.html',     //股份公司办公会议纪要
                'FLOW_OAV2_FW_SQWTS':'FLOW_OAV2_FW_SQWTS.html',       //授权委托书
                'FLOW_OAV2_SBH_WZ':'FLOW_OAV2_SBH_WZ.html',           //二级单位上报函（网状）
                'FLOW_OAV2_BPWJ_WZ':'FLOW_OAV2_BPWJ_WZ.html',         //普通文件(网状)
                'FLOW_OAV2_FW_LDPSTZ':'FLOW_OAV2_FW_LDPSTZ.html',     //领导批示通知
                'FLOW_OAV2_FW_JB1':'FLOW_OAV2_FW_JB1.html',            //部门简报
                'FLOW_OAV2_FW_MSECHYJY':'FLOW_OAV2_FW_MSECHYJY.html',  //会议纪要
                'FLOW_OAV2_FW_ZYFGSBMWK':'FLOW_OAV2_FW_ZYFGSBMWK.html', //专业分公司部门发文
                'FLOW_OAV2_SBW_WZ':'FLOW_OAV2_SBW_WZ.html',             //二级单位上报文(网状)
                'FLOW_OAV2_FW_ZYGSBMW': 'FLOW_OAV2_FW_ZYGSBMW.html',    //专业分公司部门发文
                'FLOW_OAV2_FW_KTSCJB':'FLOW_OAV2_FW_KTSCJB.html',       //勘探与生产分公司简报
                'FLOW_OAV2_SW_JTGSBM':'FLOW_OAV2_SW_JTGSBM.html',       //部门收文(发文转收文)
                'FLOW_OAV2_BM_SW':'FLOW_OAV2_BM_SW.html',               //部门收文(手工登记)
                'FLOW_OAV2_HYGL_HDBMFK': 'FLOW_OAV2_HYGL_HDBMFK.html',  //活动报名反馈
                'FLOW_OAV2_FW_BGTTB':'FLOW_OAV2_FW_BGTTB.html',         //办公厅通报
                'FLOW_OAV2_FW_HYJYKT':'FLOW_OAV2_FW_HYJYKT.html',
                'FLOW_ZBGL_DXSQ':'FLOW_ZBGL_DXSQ.html',  //倒休流程
                'FLOW_ZBGL_HBSQ':'FLOW_ZBGL_HBSQ.html',  //换班流程
                'FLOW_ZBGL_QJSQ':'FLOW_ZBGL_QJSQ.html',  //请假流程
                'FLOW_ZBGL_TBSQ':'FLOW_ZBGL_TBSQ.html',  //替班流程
                'FLOW_OAV2_HYJY_GFGS':'FLOW_OAV2_HYJY_GFGS.html',        //股份公司会议纪要
                'FLOW_OAV2_ZBXMHS':'FLOW_OAV2_ZBXMHS.html',       //项目招标
                'FLOW_OAV2_GZ_SP':'FLOW_OAV2_GZ_SP.html'        //公章审批
                 },
            nonflowPages: {
                'page-official-doc-search-list': 'page-official-doc-search-list.html'
            },
            //功能列表菜单根节点路径
            listMenuRoot: '/导航菜单/moa用户菜单/moa用户全部菜单',
            //发起功能菜单根节点路径
            launchMenuRoot: '/导航菜单/moa用户菜单/moa用户发起菜单',
            //是否接受所有的安全证书
            trustAllHosts: true,
            //启用客户端数据传输加密
            clientEncrypt: false
        };
        
        /**
         * DOM结构加载完毕 立即执行
         */
        $(document).ready(function() {
            // are we running in native app or in a browser?
            window.isphone = false;
            if (document.URL.indexOf('http://') === -1 && document.URL.indexOf('https://') === -1) {
                window.isphone = true;
            }
            if (window.isphone) {
                document.addEventListener('deviceready', onDeviceReady, false);
                document.addEventListener('pause', function() {
                    // paused = true;
                }, false);
                document.addEventListener('resume', function() {
                    //延时设置，以避免wps等将back事件发送到所在页
                    window.setTimeout(function() {
                        // paused = false;
                    }, 300);
                }, false);
            } else {
                onDeviceReady();
            }
        });
        
        /**
         * 设备就绪，执行初始化
         */
        function onDeviceReady() {
            $.moaInit(settings);
            $.init();
            $.ncsCalendarInit();//初始化日历api
        }
        
    });




/**
 *隐藏导航栏
 */
function MenuTabInit () {
    var richfit = new RuixinApi();
    richfit.hideWebViewTitle({});
}


//主送
var flag = true;
function zsClickActive(){
    if(!flag){
        $('#zsBtn img').attr('src','img/xjt2.png');
        $('#zsHideDiv').hide();
        flag = true;
    }else{
        
        $('#zsBtn img').attr('src','img/sjt.png');
        $('#zsHideDiv').show();
        flag = false;
    }
}
//抄送
function csClickActive() {
    if (!flag) {
        $('#csBtn img').attr('src', 'img/xjt2.png');
        $('#csHideDiv').hide();
        flag = true;
    } else {
        $('#csBtn img').attr('src', 'img/sjt.png');
        $('#csHideDiv').show();
        flag = false;
    }
}
//分送
function fsClickActive(){
    if (!flag) {
        $('#fsBtn img').attr('src', 'img/xjt2.png');
        $('#fsHideDiv').hide();
        flag = true;
    } else {
        
        $('#fsBtn img').attr('src', 'img/sjt.png');
        $('#fsHideDiv').show();
        flag = false;
    }
}

//其他信息
function basicClickBtn(){
    if (!flag) {
        $('#basicInfo img').attr('src', 'img/xjt2.png');
        $('.isBasicHide').hide();
        flag = true;
    } else {
        
        $('#basicInfo img').attr('src', 'img/sjt.png');
        $('.isBasicHide').show();
        flag = false;
    }
}
// 密集
function mjClickBtn(){
    if (!flag) {
        $('#mjInfo img').attr('src', 'img/xjt2.png');
        $('.isMjHide').hide();
        flag = true;
    } else {
        
        $('#mjInfo img').attr('src', 'img/sjt.png');
        $('.isMjHide').show();
        flag = false;
    }
}
// 附件
function fjClickBtn(){
    if (!flag) {
        $('#fjInfo img').attr('src', 'img/xjt2.png');
        $('.isFjHide').hide();
        flag = true;
    } else {
        
        $('#fjInfo img').attr('src', 'img/sjt.png');
        $('.isFjHide').show();
        flag = false;
    }
}

// 办文依据
function bwyjClickBtn(){
    if (!flag) {
        $('#bwyjInfo img').attr('src', 'img/xjt2.png');
        $('.isBwyjHide').hide();
        flag = true;
    } else {
        
        $('#bwyjInfo img').attr('src', 'img/sjt.png');
        $('.isBwyjHide').show();
        flag = false;
    }
}

//定密依据
function getDMYJData(pageModel){
    var dmid = '';
    var mmsx = '';
    if(pageModel['dmid'].value()){
        dmid = pageModel['dmid'].value();
        if(dmid == '-1'){
            $("#dmid").val('非涉密');
        }else if(dmid == '-2'){
            $("#dmid").val('内部资料');
        }else{
            $.moa.getDMInfo(dmid,function(result){
                if(result.success && result.data.DMB!=''){
                    var arr = $.parseJSON(result.data.DMB);
                    if(arr!=null){
                        mmsx=arr.mmsx;
                        $("#dmid").val(mmsx);
                    }
                   
                }
               
            });
        }
    }else{
        return '';
    }
}

//获取待办|待阅|委托条数
function getRedNumber(account,userId){
    //  //待阅统计条数  start,size,exp,orderBy
    var start = 0,size=10;
    $.moa.findCirculateList(start,size,JSON.stringify([{
        name: "seen",
        op: 'eq',
        intValue: 0
    },{
        name: "receiver",
        op: 'eq',
        longValue:userId,
    }]),'senttime DESC',function(result){
        if(result){
            var dyTotal = JSON.stringify(result['data']['totalSize']);
            if(dyTotal && dyTotal>0){
                $('#badge-dy').show();
                if(dyTotal>99){
                    $('#badge-dy').text('···');
                }else{
                    $('#badge-dy').text(dyTotal);
                }
            }else{
                $('#badge-dy').hide();
            }
        }
    });
    
    
    $.moa.getTodoListCount(account,JSON.stringify([{
        name: "module",
        op: 'ne',
        stringValue: 'CancelNotice'
    },{
        name: "trustor",
        op: 'is_null'
    },{
        name: "ywtype",
        op: 'eq',
        stringValue: 'GW'
    }
    ]),function(result){
        if(result.data){
            if(result.data && result.data>0){
                $('#badge-db').show();
                if(result.data>99){
                    $('#badge-db').text('···');
                }else{
                    $('#badge-db').text(result.data);
                }
            }else{
                $('#badge-db').hide();
            }
        }
    });
    
    $.moa.getTodoListCount(account,JSON.stringify([{
        name: "module",
        op: 'ne',
        stringValue: 'CancelNotice'
    },{
        name: "trustor",
        op: 'is_not_null'
    },{
        name: "ywtype",
        op: 'eq',
        stringValue: 'GW'
    }]),function(result){
        if(result.data){
            if(result.data && result.data>0){
                $('#badge-wt').show();
                if(result.data>99){
                    $('#badge-wt').text('···');
                }else{
                    $('#badge-wt').text(result.data);
                }
            }else{
                $('#badge-wt').hide();
            }
        }
    });
    
}


//待办显示保存提交，已办详情页显示撤办
function cbShowBtn(typeCb,flowData){
    var currertName = flowData.stepName;
    if(currertName && currertName.indexOf('签发')!=-1){
        $.alert('对不起，领导签发环节不能在移动端处理，请用您的办公计算机办理。');
        $('.formtab .fixed-box').hide();
    };
    if(typeCb == 'active'){
        $('#right-img').remove();
        $('.remain-box').show();
        $('.done-box').hide();
        if(flowData['flowId'] =='FLOW_OAVW_LDGBQJ' || flowData['flowId'] =='FLOW_ZBGL_QJSQ' || flowData['flowId'] =='FLOW_ZBGL_DXSQ'
            || flowData['flowId'] =='FLOW_ZBGL_HBSQ' || flowData['flowId'] =='FLOW_ZBGL_TBSQ'){
            $('.save-btn').show();
        }
        
    }else if(typeCb =='processed'){
        console.log(typeCb,'processed');
        if(flowData['cbEntry'] == 'cancel'){
            $('.remain-box').hide();
            $('.done-box').show();
        }
        if(!flowData['cbEntry'] || flowData['cbEntry']!='cancel'){
            $('.remain-box').hide();
            $('.done-box').hide();
            $('.find-flow-box').show();
        }
    }else if(typeCb =='create'){
        console.log(typeCb,'create');
        //重要事项
        $('.remain-box').show();
        $('#right-img').remove();
        $('.done-box').hide();
        $('.chuanyue-box').hide();
    }else if(typeCb == 'toBeRead' || typeCb == 'readFinish'){
        $('.chuanyue-box').show();
        $('.remain-box').hide();
        $('.done-box').hide();
    }
}


// 正文用语
function getZwyy(formData){
    
    // 主送 正文用语
    var zwyy = formData.zsdwyy.value;
    $('#zsdwyy').text(zwyy);
    // 抄送 正文用语
    var csyy = formData.csdwyy.value;
    $('#csdwyy').text(csyy);
    // 分送 正文用语
    var fsyy = formData.fsdwyy.value;
    $('#fsdwyy').text(fsyy);
    
}

//获取瑞信用户详情页 ryId    flag   1通讯录id  0员工id
function getRuiXinUserInfoPage(flag,userId){
    $.moa.getUserComment(flag,userId,function(result){
        if(result.success){
            if(result.success){
                if(result.data!=''){
                    var userInfoList = JSON.parse(result['data']);
                    if(userInfoList['comment'] && userInfoList['comment']!=''){
                        var userid =userInfoList['comment'];
                        //跳转到用户详情页的js，客户端在2019090400包之后添加，
                        new RuixinApi().showUserInfo({
                            userId:userid,
                            fail:'errorWay'
                        });
                    }else{
                        $.toast('该用户暂无员工编号！');
                    }
                }
            }
            
        }
    })
}

/*调用失败的方法*/
function errorWay(err){
    $.alert(err);
}





//textarea根据內容自動展開
function autoTextAreaHeight(o,ngbm) {
    o.style.height = o.scrollTop + o.scrollHeight + "px";
    if(o.scrollHeight== 43){
        $('#'+ngbm).css({
            'line-height':o.scrollHeight+'px'
        })
    }
}




